#ifndef lint
static char const 
yyrcsid[] = "$FreeBSD: src/usr.bin/yacc/skeleton.c,v 1.28 2000/01/17 02:04:06 bde Exp $";
#endif
#include <stdlib.h>
#define YYBYACC 1
#define YYMAJOR 1
#define YYMINOR 9
#define YYLEX yylex()
#define YYEMPTY -1
#define yyclearin (yychar=(YYEMPTY))
#define yyerrok (yyerrflag=0)
#define YYRECOVERING() (yyerrflag!=0)
static int yygrowstack();
#define YYPREFIX "yy"
#line 58 "c-parse.y"
/* $Id: c-parse.y,v 1.38 2013/10/26 01:05:12 phargrov Exp $ */

#include "config.h"
#include "system.h"
#include <setjmp.h>

#include "tree.h"
#include "input.h"
#include "c-lex.h"
#include "c-tree.h"
#include "flags.h"
#include "output.h"
#include "toplev.h"
#include "ggc.h"

#ifdef MULTIBYTE_CHARS
#include <locale.h>
#endif

#include <upc-act.h>


/* Since parsers are distinct for each language, put the language string
   definition here.  */
const char * const language_string = "GNU UPC";

 extern void WFE_Pop_Pragma();  /*from wfe_dst.cxx*/
 extern void WFE_Push_Pragma();  /*from wfe_dst.cxx*/
 extern void WFE_Start_Inner_Scope();
 extern void WFE_Finish_Inner_Scope();
 
 extern int defining_type; 

/* Like YYERROR but do call yyerror.  */
#define YYERROR1 { yyerror ("syntax error"); YYERROR; }

/* Cause the `yydebug' variable to be defined.  */
/* #define YYDEBUG 1  -- Set via HOSTDEFS in Makefile.gbase, and then only for DEBUG builds */
#line 100 "c-parse.y"
typedef union {long itype; tree ttype; enum tree_code code;
	const char *filename; int lineno; int ends_in_label; } YYSTYPE;
#line 234 "c-parse.y"
/* Number of statements (loosely speaking) and compound statements 
   seen so far.  */
static int stmt_count;
static int compstmt_count;
  
/* Input file and line number of the end of the body of last simple_if;
   used by the stmt-rule immediately after simple_if returns.  */
static char *if_stmt_file;
static int if_stmt_line;

/* List of types and structure classes of the current declaration.  */
/*static*/ tree current_declspecs = NULL_TREE;
static tree prefix_attributes = NULL_TREE;

/* Stack of saved values of current_declspecs and prefix_attributes.  */
static tree declspec_stack;

/* 1 if we explained undeclared var errors.  */
/*static*/ int undeclared_variable_notice;

/* Nonzero means the expression being parsed is a attribute parameter. */
/*static*/ int attribute_param;

/* A phony value of for_init_stmt identifying a for loop w/ c99 declaration.
   Anything that can't be a valid statement is suitable.  */
#define c99_for_node integer_type_node


/* Tell yyparse how to print a token's value, if yydebug is set.  */

#define YYPRINT(FILE,YYCHAR,YYLVAL) yyprint(FILE,YYCHAR,YYLVAL)
extern void yyprint			PARAMS ((FILE *, int, YYSTYPE));

/* Add GC roots for variables local to this file.  */
void
c_parse_init ()
{
  ggc_add_tree_root (&declspec_stack, 1);
  ggc_add_tree_root (&current_declspecs, 1);
  ggc_add_tree_root (&prefix_attributes, 1);
}
#line 101 "c-parse.c"
#define YYERRCODE 256
#define IDENTIFIER 257
#define TYPENAME 258
#define SCSPEC 259
#define TYPESPEC 260
#define TYPE_QUAL 261
#define TYPE_QUAL_S 262
#define CONSTANT 263
#define STRING 264
#define ELLIPSIS 265
#define SIZEOF 266
#define ENUM 267
#define STRUCT 268
#define UNION 269
#define IF 270
#define ELSE 271
#define WHILE 272
#define DO 273
#define FOR 274
#define SWITCH 275
#define CASE 276
#define DEFAULT 277
#define BREAK 278
#define CONTINUE 279
#define RETURN 280
#define GOTO 281
#define ASM_KEYWORD 282
#define TYPEOF 283
#define ALIGNOF 284
#define ATTRIBUTE 285
#define EXTENSION 286
#define LABEL 287
#define REALPART 288
#define IMAGPART 289
#define ASSIGN 290
#define OROR 291
#define ANDAND 292
#define EQCOMPARE 293
#define ARITHCOMPARE 294
#define LSHIFT 295
#define RSHIFT 296
#define UNARY 297
#define PLUSPLUS 298
#define MINUSMINUS 299
#define HYPERUNARY 300
#define POINTSAT 301
#define INTERFACE 302
#define IMPLEMENTATION 303
#define END 304
#define SELECTOR 305
#define DEFS 306
#define ENCODE 307
#define CLASSNAME 308
#define PUBLIC 309
#define PRIVATE 310
#define PROTECTED 311
#define PROTOCOL 312
#define OBJECTNAME 313
#define CLASS 314
#define ALIAS 315
#define OBJC_STRING 316
#define FORALL 317
#define UPC_BLOCKSIZEOF 318
#define UPC_LOCALSIZEOF 319
#define UPC_ELEMSIZEOF 320
#define UPC_BARRIER 321
#define UPC_NOTIFY 322
#define UPC_WAIT 323
#define END_OF_LINE 324
#define UPC_FENCE 325
#define BUPC_ASSERT_TYPE 326
const short yylhs[] = {                                        -1,
    0,    0,   85,   83,   86,   83,   84,   84,   84,   84,
   88,   88,   88,   88,   88,   88,   88,   88,   91,   93,
   87,   87,   94,   95,   87,   87,   96,   97,   87,   87,
    2,    2,    1,    1,    1,    1,    1,    1,    1,    3,
    5,    5,    4,    4,    8,    8,    8,    8,    8,    8,
    8,    8,    8,    8,    8,    8,    8,    8,    8,    8,
    8,   79,   80,   81,   82,   98,   99,    7,    7,  101,
    7,    6,    6,    6,    6,    6,    6,    6,    6,    6,
    6,    6,    6,    6,  102,    6,  103,    6,  104,  105,
    6,  106,    6,    6,    6,    9,    9,    9,    9,    9,
  107,    9,    9,    9,    9,    9,    9,    9,    9,    9,
    9,    9,   10,   10,   90,   90,   90,  109,  108,  108,
  108,  108,  110,  110,  110,  110,   70,  112,  113,  113,
  113,  113,  113,  113,  113,   11,   11,   12,   12,   12,
   12,   18,   18,   19,   19,   19,   15,   15,   15,   15,
   20,   20,   20,   20,   58,   58,   58,   13,   13,   78,
   14,   14,   16,   16,   16,   16,   16,   17,   17,   17,
   17,   17,   23,   23,   24,   24,   28,   28,  116,   25,
   25,  117,   26,   26,   33,   33,   34,   34,   35,   36,
   36,   37,   37,   37,  118,  119,   37,   37,   38,   38,
   38,   38,   38,   27,  120,   27,   27,  100,  100,  121,
  121,  123,  123,  127,  123,  123,  128,  125,  125,  125,
  124,  124,  126,  126,  126,  129,  130,  114,  131,  132,
  115,   40,   40,   42,   42,   42,   42,   42,   42,   42,
  133,  133,  133,  133,  134,  134,   43,   43,   43,   43,
   43,   43,   43,   41,   41,   41,   41,   41,   41,   41,
   41,   52,   52,   53,   53,   54,   54,  135,   44,   44,
   44,  136,   44,   44,   44,  137,   44,  139,   44,   44,
  122,  122,  138,  138,   45,   45,   46,   46,   46,   47,
   47,   47,   47,   47,   47,   48,   48,   49,   49,   49,
   50,   50,   50,   51,   51,   55,   55,   56,   56,   21,
   21,   59,   59,   57,   57,   57,   57,   57,   57,   57,
   57,   57,   57,  140,   73,   73,   73,  111,  141,  142,
  142,  143,  143,  144,   92,   92,  145,   39,   39,   39,
  146,  146,  147,  150,  149,   75,   76,  148,  148,   72,
   74,   74,   74,  151,  151,  151,  154,  151,  151,  151,
  155,  156,  151,  151,  151,  157,  158,  159,  151,  160,
  161,  162,  163,  151,  164,  151,  151,  151,  151,  151,
  151,  151,  151,  151,  151,  151,  151,  151,  151,  151,
  151,  151,  151,  151,  165,   71,   71,   77,   77,  153,
  167,  166,  152,  152,  152,  152,   22,   22,   60,   60,
   60,   29,   29,   30,   30,   31,   32,   32,  168,   64,
   65,  169,   65,   65,   66,   66,   66,   66,   61,   61,
   62,   62,   62,   62,   62,  170,   67,   68,   68,   63,
   63,   69,   69,   89,
};
const short yylen[] = {                                         2,
    0,    1,    0,    2,    0,    3,    1,    1,    5,    2,
    3,    4,    4,    2,    2,    2,    2,    1,    0,    0,
    7,    4,    0,    0,    7,    4,    0,    0,    6,    3,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    0,    1,    1,    3,    1,    2,    2,    2,    2,    2,
    4,    2,    4,    2,    4,    2,    4,    2,    4,    2,
    2,    1,    1,    1,    1,    1,    1,    1,    4,    0,
    7,    1,    3,    3,    3,    3,    3,    3,    3,    3,
    3,    3,    3,    3,    0,    4,    0,    4,    0,    0,
    7,    0,    5,    3,    3,    1,    1,    1,    3,    3,
    0,    4,    6,    6,    6,    6,    4,    4,    3,    3,
    2,    2,    1,    2,    0,    1,    2,    3,    1,    1,
    2,    2,    4,    4,    2,    2,    0,    0,    4,    4,
    3,    3,    2,    2,    2,    2,    3,    0,    2,    2,
    2,    2,    3,    0,    2,    2,    1,    1,    2,    2,
    1,    1,    2,    2,    1,    1,    2,    2,    3,    3,
    0,    2,    1,    1,    1,    4,    4,    1,    1,    1,
    2,    1,    1,    3,    1,    3,    0,    4,    0,    6,
    3,    0,    6,    3,    0,    1,    1,    2,    6,    1,
    3,    0,    1,    4,    0,    0,    8,    4,    1,    1,
    1,    1,    1,    1,    0,    4,    1,    0,    2,    1,
    3,    3,    2,    0,    4,    1,    0,    4,    1,    1,
    1,    2,    2,    5,    3,    0,    0,    5,    0,    0,
    5,    1,    1,    3,    3,    4,    3,    3,    3,    1,
    0,    2,    2,    1,    1,    2,    3,    5,    5,    4,
    3,    3,    1,    3,    3,    3,    5,    5,    4,    3,
    1,    1,    2,    1,    2,    1,    2,    0,    7,    5,
    2,    0,    7,    5,    2,    0,    8,    0,    7,    2,
    0,    1,    0,    1,    1,    2,    0,    3,    2,    3,
    1,    3,    1,    1,    2,    1,    3,    4,    6,    5,
    1,    3,    1,    2,    4,    2,    2,    0,    1,    1,
    2,    0,    2,    3,    3,    2,    3,    5,    4,    2,
    4,    3,    3,    1,    1,    2,    2,    2,    0,    0,
    1,    1,    2,    3,    1,    2,    1,    2,    5,    5,
    2,    2,    4,    0,    4,    0,    0,    3,    4,    3,
    1,    1,    1,    1,    1,    2,    0,    4,    1,    3,
    0,    0,    7,    5,    2,    0,    0,    0,   11,    0,
    0,    0,    0,   14,    0,    6,    2,    2,    2,    3,
    2,    2,    3,    2,    3,    2,    3,    6,    8,   10,
   12,    3,    4,    1,    0,    2,    2,    1,    1,    1,
    0,    6,    3,    5,    2,    3,    0,    1,    0,    1,
    1,    0,    1,    1,    3,    4,    1,    3,    0,    2,
    2,    0,    4,    2,    0,    1,    1,    3,    1,    3,
    4,    4,    4,    4,    4,    0,    2,    1,    2,    1,
    3,    1,    3,    1,
};
const short yydefred[] = {                                      0,
    0,    0,    0,    0,    0,  165,  152,  163,  155,    0,
    0,    0,    0,    0,    0,    0,  444,   18,    0,    0,
  138,    0,    0,  187,  164,    0,    0,    0,  151,    0,
    4,    7,    8,    0,    6,   16,   17,    0,  157,    0,
    0,    0,    0,    0,    0,   15,    0,   14,  138,    0,
    0,    0,    0,  154,  153,  188,   31,   32,  287,    0,
  287,    0,  278,    0,  261,  312,    0,    0,  175,    0,
    0,   10,   96,   97,  113,   66,   67,    0,    0,    0,
   33,   35,   34,    0,   36,   37,    0,   62,   63,   64,
   65,   38,   39,    0,  410,    0,    0,   72,   68,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  161,    0,    0,  310,    0,  240,  312,
    0,    0,  173,    0,    0,    0,    0,    0,    0,    0,
  140,  168,  169,    0,  139,    0,  172,    0,    0,  268,
    0,  272,    0,  276,    0,    0,   11,    0,    0,   30,
    0,  436,    0,    0,    0,   60,   61,   49,   46,    0,
    0,    0,    0,   48,    0,    0,    0,    0,   87,   85,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  111,  112,    0,    0,    0,    0,  114,  160,
    0,   52,    0,   54,    0,   56,    0,   47,    0,   50,
    0,   58,    0,  166,  312,    0,    0,    0,  306,    0,
    0,  161,  307,  311,  167,  200,  201,  202,  203,  199,
    0,  190,    0,    0,    0,   13,    0,    0,   22,    0,
    0,  436,    0,   12,   26,    0,  171,    0,  294,  289,
    0,    0,    0,    0,  287,    0,  287,  303,    0,    0,
  301,    0,    0,  313,  255,  176,    0,    0,    0,  254,
    0,    0,  245,    0,    0,    0,    0,    0,  347,   28,
    0,    0,  120,  100,   99,    0,  337,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,   75,   76,   77,  110,  109,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    9,    0,    0,  320,    0,    0,    0,  419,    0,
  162,    0,    0,    0,    0,    0,  234,  174,    0,    0,
   20,  235,  237,    0,   24,  270,  346,  346,  288,  295,
    0,  274,    0,    0,    0,    0,    0,    0,    0,  440,
  426,  127,    0,    0,  429,    0,  438,    0,  437,    0,
    0,  259,    0,  243,  246,  182,  328,    0,    0,  117,
  121,  122,   70,   69,  102,  338,    0,    0,    0,    0,
    0,  107,  108,   53,   55,   57,    0,    0,   51,   59,
    0,  314,  420,  322,    0,    0,  317,    0,  189,  191,
    0,    0,  179,    0,  236,    0,    0,  296,  347,    0,
    0,    0,    0,  302,    0,    0,  178,  424,    0,    0,
  422,    0,  439,    0,  421,  257,  258,    0,  144,    0,
    0,  118,    0,  335,   29,    0,    0,    0,    0,  332,
   90,    0,    0,    0,    0,    0,  321,  319,    0,  194,
  195,  198,    0,   21,   25,  346,    0,  269,  273,    0,
  279,    0,  253,  312,    0,    0,    0,    0,    0,  312,
    0,    0,    0,    0,  428,  430,  441,  207,  205,    0,
  183,    0,  125,    0,  126,  144,    0,  336,  220,    0,
    0,    0,  217,    0,    0,    0,    0,  210,    0,  216,
    0,  442,    0,    0,  325,    0,  347,    0,  333,    0,
  106,  105,  104,  103,  318,    0,  180,  297,    0,    0,
  277,    0,    0,  432,  436,    0,  431,  433,    0,    0,
  434,  435,  423,    0,  146,  145,    0,    0,    0,    0,
  223,    0,    0,  214,   71,    0,  209,    0,  222,  213,
  334,    0,  339,  326,  327,    0,  340,    0,    0,    0,
    0,  298,    0,    0,  247,    0,    0,  123,  124,    0,
  225,    0,    0,  211,  212,  443,    0,    0,  361,  344,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  394,    0,    0,    0,    0,  354,
  350,    0,  353,    0,    0,    0,  351,  352,  355,  400,
    0,  300,    0,    0,  250,    0,  206,    0,  218,  215,
    0,    0,  346,    0,    0,    0,  405,  377,  378,  379,
    0,    0,    0,  408,    0,    0,  386,    0,  381,    0,
  384,    0,  382,    0,  356,  133,    0,  134,    0,  135,
    0,  342,  347,  341,  365,    0,  197,  299,  248,  249,
  224,    0,    0,    0,    0,    0,  366,  346,    0,    0,
  403,  380,    0,  392,    0,  370,  387,  383,  385,  406,
    0,    0,  131,    0,    0,  132,  360,  346,    0,    0,
  343,    0,  345,  401,  396,    0,  397,  375,    0,  393,
    0,    0,  129,    0,  130,    0,  358,  348,  346,    0,
  362,  346,    0,  346,  404,    0,    0,    0,  227,  230,
  349,  364,  346,  402,  367,  376,    0,    0,    0,  414,
  388,  371,    0,    0,  363,    0,    0,    0,    0,    0,
    0,  228,  231,    0,    0,    0,  389,  415,    0,  368,
  416,    0,    0,  372,  346,    0,    0,  390,    0,  369,
    0,    0,  399,  398,    0,  391,    0,  373,  346,  374,
};
const short yydgoto[] = {                                       1,
   94,  494,   95,   96,  302,   97,   98,   99,  100,  101,
  352,   53,  113,  211,  353,  114,  135,  430,  482,   22,
  115,  635,  122,   68,  123,   69,  481,  154,  728,  729,
  730,  757,  266,  267,   24,  221,  222,  223,  434,  257,
  126,  127,  468,   25,  138,  139,  243,  407,  408,  250,
  251,   26,   27,   28,  116,  209,  210,   29,  145,  666,
  354,  355,  356,  315,  357,  358,  260,  359,  503,   30,
  667,  505,  506,  601,  653,  368,  765,   39,  103,  104,
  105,  106,    2,   31,    3,    4,   32,   33,  107,  270,
  231,  435,  404,  236,  406,  155,  369,  108,  109,  496,
  436,  286,  285,  283,  510,  284,  163,  271,  272,  432,
  273,  149,  603,  683,  686,  453,  428,  516,  611,  534,
  497,  547,  498,  499,  500,  501,  573,  543,  704,  733,
  706,  734,  264,  265,  245,  247,  252,  346,  143,  508,
  377,  438,  439,  440,  279,  604,  605,  654,  606,  623,
  607,  608,  609,  688,  622,  723,  696,  736,  755,  702,
  741,  759,  769,  714,  668,  610,  712,  316,  474,  261,
};
const short yysindex[] = {                                      0,
    0,    0, 5117, 5117,    3,    0,    0,    0,    0,  -30,
 -207, -207, -207,   43,   76,  115,    0,    0,  102,  568,
    0,  547, -207,    0,    0,  122,  154,  196,    0,   45,
    0,    0,    0, 5117,    0,    0,    0, 3567,    0, -207,
 -207, -207, 3633, 2038,  186,    0,  387,    0,    0,  547,
 -207,   45, 1071,    0,    0,    0,    0,    0,    0,  111,
    0,  121,    0,  127,    0,    0,   45,  427,    0, -207,
  214,    0,    0,    0,    0,    0,    0, 3633, 3633,  194,
    0,    0,    0, 3633,    0,    0, 1829,    0,    0,    0,
    0,    0,    0, 3633,    0,  213, 4098,    0,    0,    9,
   91,  169, 3682, 3747, 3829,  287, 3633, 3868, 3944, 3633,
  351,  362,   77,    0, 1979,  435,    0, 1084,    0,    0,
  387,  751,    0, -207, -188,  244,  437, 1071,  752,  218,
    0,    0,    0,  -30,    0, -207,    0,  243,  471,    0,
  360,    0,  587,    0,  327,  491,    0,  387,   45,    0,
  447,    0, -180, -207,  238,    0,    0,    0,    0,  458,
  464,  474,  411,    0, 3633, 3633, 3633,    0,    0,    0,
 3633, 3633, 3633, 3633, 3633, 3633, 3633, 3633, 3633, 3633,
 3633, 3633,    0,    0,  194,  194, 3633, 3633,    0,    0,
 1829,    0, 1829,    0, 1829,    0, 2161,    0, 1829,    0,
 1829,    0,  476,    0,    0,   77, -180, -207,    0,  461,
  971,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  715,    0,  515,  310,  622,    0,  387,  387,    0, -207,
  238,    0, 2462,    0,    0,  238,    0, -207,    0,    0,
    0,  854,  484, 1354,    0, -207,    0,    0, -207,  553,
    0,  587,  244,    0,    0,    0,  280,  244,  336,    0,
 3117,  348,    0, 2537,  314,  552, -207,  546,    0,    0,
  381,  238,    0,    0,    0, 2576,    0,  598,  526, 4098,
 4098, 4098, 3633,  607, 3633, 3633, 1933,  868,  898,   65,
  152,  880,  880, 1001, 1001,    0,    0,    0,    0,    0,
  213,  626,  609,  659,  682,  683, 2650,  691,  703,  722,
  743,    0,   33,  653,    0, 3059, 2694,   77,    0, -180,
    0,  971,  749, 1084, 3983,  437,    0,    0,  437,  736,
    0,    0,    0,  739,    0,    0,    0,    0,    0,    0,
  731,    0,  737,  820,  194,  765,  553,   12,  850,    0,
    0,    0, 3445,  796,    0,  778,    0,  871,    0,  660,
 2753,    0,  827,    0,    0,    0,    0, 2143,   37,    0,
    0,    0,    0,    0,    0,    0,  637,  888, 3633, 1761,
 1210,    0,    0,    0,    0,    0, 2161, 2161,    0,    0,
  461,    0,    0,    0,  833,  461,    0, 2838,    0,    0,
  808,  909,    0,   37,    0,   37,  911,    0,    0,  911,
 -207, -207, 3633,    0, -207,  873,    0,    0,  281,  148,
    0, 2764,    0,  716,    0,    0,    0, 2347,    0,  951,
  920,    0,  411,    0,    0, 2308,  194,  755,  637,    0,
    0, 3920,  982,  998, 1000, 1013,    0,    0,  919,    0,
    0,    0, 2347,    0,    0,    0,  433,    0,    0, 4098,
    0, -207,    0,    0,  148, -207,   -7,   56, -207,    0,
 -207,   -7, -207, 3059,    0,    0,    0,    0,    0, 4098,
    0,  798,    0,  387,    0,    0,   45,    0,    0,    0,
  194, 3633,    0,  997, 4098,  931, 1018,    0,  646,    0,
 2423,    0,  848,  945,    0,  238,    0,  950,    0, 3633,
    0,    0,    0,    0,    0, 3633,    0,    0, 3633,   -2,
    0,  173,  281,    0,    0, -180,    0,    0,  156,  148,
    0,    0,    0, 2308,    0,    0,  889,  798,  890,   92,
    0,  593, 2308,    0,    0, 2308,    0, 2423,    0,    0,
    0,  194,    0,    0,    0, 1561,    0, 3920,  213, 3758,
 3633,    0,  500,  500,    0, 2882,  967,    0,    0, 3633,
    0,  986, 2423,    0,    0,    0,    0, 1034,    0,    0,
 1077, 1078, 3633, 1068, 1073, 1076, 2956,  164,  869, 1105,
 3015, 3073, 3144, 1092,    0, 1094, 1098, 1100, 1875,    0,
    0,  610,    0,  894,  904,   11,    0,    0,    0,    0,
 1125,    0, 3758, 3190,    0, 1074,    0, 4274,    0,    0,
 3633, 1128,    0, 3567, 3633, 2475,    0,    0,    0,    0,
 1110, 3633, 1112,    0, 1135, 3567,    0, 1117,    0, 1118,
    0, 1124,    0, -207,    0,    0,  387,    0,   45,    0,
  928,    0,    0,    0,    0, 3633,    0,    0,    0,    0,
    0, 1144, 3633,  914,   95, 1131,    0,    0, 1154, 3633,
    0,    0, 1137,    0, 3633,    0,    0,    0,    0,    0,
  949,  280,    0,  955,   92,    0,    0,    0, 1725, 1156,
    0, 1157,    0,    0,    0, 3567,    0,    0, 4285,    0,
  374, 3567,    0,  238,    0,  238,    0,    0,    0, 1141,
    0,    0, 1142,    0,    0,  938, 1148, 1151,    0,    0,
    0,    0,    0,    0,    0,    0, 1172,  570, 1169,    0,
    0,    0,  411,  411,    0, 3567, 3633,  938, 1161,  938,
 3567,    0,    0, 1174, 1175,  591,    0,    0, 1163,    0,
    0,  336, 1164,    0,    0,   91,  859,    0, 3255,    0,
 1165,  336,    0,    0, 1185,    0,   91,    0,    0,    0,
};
const short yyrindex[] = {                                    518,
    0,  556,  108,  108,    0,    0,    0,    0,    0, 2808,
  259,  279,  361,    0,    0,    0,    0,    0,  536,  108,
    0,  961, 4789,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  108,    0,    0,    0, 1134,    0,  367,
  384,  403,    0,    0,    0,    0,    0,    0,    0, 2549,
 4906,    0, 1608,    0,    0,    0,    0,    0,    0, 4608,
    0, 4653,    0, 4673,    0,    0,    0,    0,    0,  226,
 5008,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  420,    0,    0, 1113,    0,    0,    0,
    0,    0,    0,    0,    0,  544,  714,    0,    0,  667,
 4132,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  910,    0,  910,    0,    0,  974,    0,    0,
    0,    0,    0,   81, 5039, 4941, 4976, 2303,    0, 5069,
    0,    0,    0, 4694,    0, 5100,    0,    0, 1109,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0, 3305,  462, 2216,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 3371,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1196,    0,    0,    0,
 1113,    0, 1113,    0, 1113,    0,    0,    0, 1113,    0,
 1113,    0,    0,    0,    0, 1252, 3305,  517,    0,  141,
 3508,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  975,    0,    0,    0,    0,    0,    0,  462,
 2216,    0,    0,    0,    0, 2216,    0, 5052,    0,    0,
  179,  657, 1116,    0,    0, 5052,    0,    0,  395, 1120,
    0,    0, 4713,    0,    0,    0,  181, 4748,    0,    0,
  871,    0,    0,    0, 3453,  965,  708,    0,    0,    0,
 2110, 1841,    0,    0,    0,    0,    0,    0,  821,  860,
 1516, 1526,    0,    0,    0,    0, 4355, 3132, 4560, 3557,
 4550, 4433, 4491, 4342, 4396,    0,    0,    0,    0,    0,
 1201,    0,    0,    0,    0,    0, 1113,    0,    0,    0,
    0,    0, 1009,    0,    0,  871,    0,    0,    0, 3305,
    0, 4019,    0,  974, 1196, 4820,    0,    0, 4865,  973,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  149, 1126,    0, 1120,    0,    0,    0,
    0,    0,  806, 1202,    0,    0,    0,    0,    0, 3518,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, 1091,    0,    0, 1567,
 1416,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  143,    0,    0,    0,    0,  187,    0,    0,    0,    0,
 4059,    0,    0,    0,    0,    0,  294,    0,    0,  330,
 5052, 5052,    0,    0, 5052,    0,    0,    0,  724,  724,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  536,
  100,    0,    0,    0,    0, 1129,    0, 1631, 1166,    0,
    0, 1520,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  344,
    0, 5052,    0,    0, 1252,  680,  761,  761,  761,    0,
   63,  761,  761,  871,    0,    0,    0,    0,    0,  977,
    0,  485,    0,    0,    0,    0,    0,    0,    0, 4247,
    0,    0,    0,    0,  379,    0, 1170,    0,    0,    0,
  673,    0,    0,    0,    0, 1270,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  270,
    0,  816,    0,    0,    0, 3305,    0,    0,  816,    0,
    0,    0,    0, 1129,    0,    0,    0, 1378,    0,  181,
    0,    0, 1129,    0,    0, 1171,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0, 2151, 1208,  270,
    0,    0,  284,  421,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   30,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 1216,    0,
    0,    0,    0,    0,    0,    0,    0,  536,  108,    0,
    0,    0,    0, 1002, 1899,    0,    0,    0,    0,    0,
    0,    0,  270,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0, 1805,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1805,    0,    0,    0,    0,
    0,    0,    0, 1457,    0,    0,    0,    0,    0,    0,
 1993,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0, 1111,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0, 2393,    0,    0, 4239,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1191,    0,    0,    0,    0,
    0, 1191,    0, 2216,    0, 2216,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  704,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  740,    0,
    0,    0,    0,    0,    0, 1226,    0,  704,    0,    0,
 1191,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 1027,    0,    0, 1226,    0,
    0,    0,    0,    0,    0,    0, 1028,    0,    0,    0,
};
const short yygindex[] = {                                      0,
    0,  -23,  -42, -158,  948,  503,   20,   72,  674, -240,
    8, 1248,  -74, 1087,   14,   18, -151,    0,  819,   -5,
  -21,    0, -420,  -45,  -62,    0,  849, -101,  569,    0,
  566,    0, -156,   24,  230,    0,  985,    0, -147,  -41,
  -20,  254,  166,  -19,  163,    0, 1067,  976,  861, 1064,
  981,    0,    0,    0,   10,  -75, -139,   19,  -94,  -38,
    0,  896,    0, 1016, -257,    0, -189,    0,    0,   -6,
  700,  831,    0,    0, -105, -329,    0, 1228,    0,    0,
    0,    0,    0,   88,    0,    0,    0,    0,    5, -211,
    0,  253,    0,    0,    0,    0,    0,    0,    0, -261,
    0,    0,    0,    0,    0,    0,    0,    0, -248,    0,
 -226,  -93,  776,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  835,    0, -435,  883,    0,    0,    0,    0,
    0,    0, -177, 1122,    0,    0,    0, 1038,    0,    0,
    0,    0,    0,  947,    0,    0,    0, 2090,    0,    0,
  698,  699,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
};
#define YYTABLESIZE 5403
const short yytable[] = {                                     102,
  111,  112,   60,   62,   64,  125,  129,   34,   34,   71,
   19,   19,   47,   52,   50,  278,   20,   20,  348,  331,
   21,   21,  371,  230,  335,  224,   23,   23,  301,  317,
  228,  130,  152,  137,   40,   41,   42,   49,   34,  213,
   55,   19,  332,   51,  161,  372,  146,   20,  187,  269,
  656,   21,  417,   70,  186,  561,  158,   23,  393,  321,
   38,   36,  117,  537,  241,  550,  314,  229,   55,  165,
  124,  165,  206,  330,  205,   70,  136,   16,  262,  457,
  263,  336,   43,  153,   67,  256,   66,   32,  165,  342,
   70,   35,  344,  151,  220,  525,  162,  156,  157,  188,
  146,  182,  128,  159,  128,  117,  180,  178,  137,  179,
  313,  181,  575,  164,  318,   44,  206,  242,  205,  249,
  128,   72,  128,  207,  253,  269,  198,   37,  258,  159,
  269,  152,  212,  214,  187,  694,  208,  620,  208,  127,
  186,  127,  398,  244,  124,  303,  526,  127,  161,  127,
  161,  136,  161,  128,   45,  230,  161,  117,  161,  277,
   46,  299,  300,  254,  328,  269,  301,  207,   70,  241,
  321,  124,   70,  391,  192,  194,  196,  556,  396,  200,
  202,  309,  153,  315,  309,  188,  315,  465,  182,  470,
  334,  137,  304,  180,  178,  465,  179,  470,  181,  309,
  304,  315,  305,  253,  306,  632,  309,  258,  310,  117,
  311,  117,  465,  117,  464,  117,  533,  117,  127,  117,
  127,  363,  242,  141,  177,  118,  681,  323,  249,  208,
  323,  409,  409,  140,  337,  338,  127,  291,  207,  177,
  378,  177,  254,  142,   59,  323,  207,  124,  244,  144,
  124,  124,   56,  152,  458,  459,  165,  152,  461,  212,
  214,  190,  117,  207,  161,  128,  655,  128,  308,   56,
   56,   56,  567,  304,  395,  189,   61,   16,   21,  555,
   56,  572,   16,  152,   23,  488,  165,  165,  165,  165,
  165,  165,  433,    9,   10,  374,  165,  165,  165,   56,
  220,   65,  137,  291,  153,  521,  183,  184,  153,  185,
  524,  527,  528,  185,  165,  531,  532,   16,   63,  128,
  465,  249,  464,  689,  251,  314,  197,  251,  185,   16,
  536,  254,  507,   21,  153,  565,  208,  128,  128,   23,
   16,  208,  251,  469,  473,  419,  420,   50,  566,  121,
  409,  120,  290,   56,  189,  449,  127,  559,  175,  176,
  177,   16,  431,  562,  127,   56,   67,  238,   66,  522,
   49,  207,  523,  151,  225,  529,   51,  530,   57,   58,
  159,  266,  391,  396,  127,  429,  536,  305,  292,  391,
  396,  203,  183,  184,  185,  185,  444,  446,  467,  472,
  507,  262,  204,  612,   65,  117,  117,  341,  600,  343,
   57,   58,   65,  502,  717,  520,    9,   10,  290,  697,
   57,   58,  219,  484,  487,  309,  121,  315,  120,   65,
  463,  716,   16,    9,   10,  127,  127,   56,  185,   21,
   16,  539,  466,  471,  146,   23,  176,  177,  486,   55,
   57,   58,   57,   58,  292,  185,  658,   16,  443,  445,
  411,  252,  137,  127,  252,  177,  540,  541,  305,  150,
  148,  323,  121,  235,  120,  215,  232,  326,  411,  252,
  124,  329,  128,  264,  246,  147,  259,  680,  471,  267,
  519,   21,  719,  268,  720,  151,   56,   23,  274,  151,
  319,  253,  258,  219,  275,  185,  263,  124,  253,  258,
   70,  756,  411,  597,  276,  266,  266,    1,  137,  185,
  185,  767,  185,  616,  142,  265,  142,  233,  576,  240,
  152,  255,  596,  277,  312,  262,  262,   65,  463,  525,
  254,  600,  339,  142,  631,  466,  466,  254,  638,  640,
  642,  320,  471,  471,  325,    2,  128,    3,  128,    3,
  602,  151,  269,  598,  633,   16,   65,  119,  251,  599,
    9,   10,  364,   21,  365,  127,    3,  127,  662,   23,
  230,  153,  669,   65,   40,  742,  743,    9,   10,  673,
  526,  647,  649,   50,   16,    5,  345,    5,  269,   75,
  269,   40,   40,  684,  367,  682,  602,  128,  263,  598,
  739,   16,  366,  690,    5,  599,   49,  264,  264,   21,
  692,  198,   51,  267,  267,   23,   48,  738,  685,  182,
  173,  753,  701,  159,  180,  178,   40,  179,  375,  181,
  263,  263,   93,   65,  119,  370,  597,   81,  752,   87,
  376,  110,   82,  167,   83,  168,  454,  713,  455,  265,
  265,  232,  327,  718,  379,  596,  382,  280,  281,  282,
  124,   16,   70,  287,  288,  289,  290,  291,  292,  293,
  294,  295,  296,  297,  298,  571,  172,  563,  564,   65,
  119,  491,  319,  392,  745,   56,  127,  744,  127,  384,
   56,  383,  749,   45,   45,  252,  548,   45,   45,   45,
   45,   45,  233,   45,  127,  293,  171,   16,  221,  128,
  764,  128,  385,  386,   45,   45,  239,   45,    6,   45,
    8,    9,   10,  221,  387,   92,  492,   11,   12,   13,
  186,  142,  142,  320,  412,  186,  388,  186,  186,  186,
  186,  186,  186,   15,   43,  323,   17,   43,  324,   45,
   45,  412,  389,  221,  308,  186,  186,  308,  186,  142,
  128,   43,   43,    3,    3,    3,    3,    3,    3,    3,
  413,  293,  308,  390,    3,    3,    3,  380,  381,  399,
   45,   45,  127,  127,  227,  148,  403,  413,  186,    3,
    3,  185,    3,    3,  185,   54,   43,    9,   10,  226,
  234,    5,    5,    5,    5,    5,    5,    5,  423,  185,
  127,  424,    5,    5,    5,    6,    7,    8,    9,   10,
  186,  405,  186,  186,   11,   12,   13,    5,    5,  422,
    5,    5,  248,   57,   58,  127,  127,  127,  450,  127,
   15,  451,   16,  329,  421,  411,  316,  570,  329,  316,
  329,  412,  329,  329,  127,  329,   73,    6,    7,    8,
    9,   10,   74,   75,  316,   76,   11,   12,   13,  329,
  413,  442,  166,  169,  170,  174,  175,  176,  177,  415,
  418,  552,   15,   77,   16,   17,  127,   78,   79,  761,
   44,   80,  762,   44,  182,  173,  551,   85,   86,  180,
  178,  425,  179,  127,  181,  460,  182,   44,   44,  427,
  365,  180,  178,  437,  179,  447,  181,   88,   89,   90,
  480,   45,  227,  148,  182,   91,  128,  128,  495,  180,
  178,  127,  179,  329,  181,  441,  329,  568,  569,  452,
  308,   45,   44,  308,  456,  480,   45,   45,   45,   45,
   45,   45,   45,  186,  186,  186,  186,  186,  186,  186,
  186,  186,  477,  186,  186,  186,  186,  186,  485,  186,
  186,  186,  186,  186,  186,  186,  186,  186,  186,  186,
  186,  186,  227,  186,  542,  186,  186,  462,  148,  186,
  147,  147,  147,  495,  147,  186,  186,  703,  184,  483,
  504,  515,  558,  705,  192,  193,  181,  192,  193,  147,
  204,  560,  511,  184,  186,  186,  186,  186,  186,  186,
  186,  181,  186,  186,  359,  204,  495,  182,  512,  359,
  513,  359,  180,  359,  359,  495,  359,  181,  495,  316,
  495,  147,  316,  514,  544,  545,  535,  132,  133,  134,
  359,  546,  127,  613,   11,   12,   13,  417,  418,  553,
  417,  418,  618,  621,  557,  495,  329,  329,  329,  329,
  329,  329,  329,  329,  329,  626,  329,  329,  329,  329,
  329,  617,  329,  329,  329,  329,  329,  329,  329,  329,
  329,  329,  329,  329,  329,  329,  329,  329,  329,  329,
  619,    6,  329,    8,    9,   10,  624,  625,  329,  329,
   11,   12,   13,  330,  359,  627,  359,  359,  330,  634,
  330,  628,  330,  330,  629,  330,   15,  329,  329,  329,
  329,  329,  329,  329,  636,  329,  329,   45,   45,  330,
  643,  644,   45,   45,   45,   45,  645,   45,  646,  652,
  174,  175,  176,  177,  651,  657,  660,  663,  672,   45,
  674,   45,  699,   45,  675,  677,  678,    6,   54,    8,
    9,   10,  679,  687,  691,  693,   11,   12,   13,  695,
  174,  175,  176,  177,  698,  700,  710,  711,  331,  722,
  725,  727,   15,  331,   45,  331,  731,  331,  331,  732,
  331,  737,  740,  330,  750,  751,  330,  147,  147,  747,
  147,  754,  758,  766,  331,  768,  409,  147,  147,  147,
  132,  133,  134,  285,   45,  101,   41,   11,   12,   13,
  286,   42,  427,  147,  283,  147,  182,  173,  196,  409,
  284,  180,  178,  208,  179,  407,  181,  359,  359,  359,
  359,  359,  359,  359,  359,  359,  409,  359,  359,  359,
  359,  359,  402,  359,  359,  359,  359,  359,  359,  359,
  359,  359,  359,  359,  359,  359,  359,  359,  331,  359,
  359,  331,  419,  359,  281,  282,  128,  665,  322,  359,
  359,  517,  346,  172,  538,  748,  746,  346,  400,  346,
  340,  346,  346,  410,  346,  347,  518,  476,  359,  359,
  359,  359,  359,  359,  359,  414,  359,  359,  346,  131,
  132,  133,  134,  171,  397,  676,  554,   11,   12,   13,
   57,   58,  216,  217,  218,  219,  330,  330,  330,  330,
  330,  330,  330,  330,  330,   16,  330,  330,  330,  330,
  330,  237,  330,  330,  330,  330,  330,  330,  330,  330,
  330,  330,  330,  330,  330,  330,  330,  650,  330,  330,
  574,  549,  330,  360,  416,  509,  708,  709,  330,  330,
    0,    0,  346,    0,  324,  346,    0,    0,    0,    0,
   45,   45,   45,   45,   45,   45,   45,  330,  330,  330,
  330,  330,  330,  330,    0,  330,  330,  143,    0,  143,
    0,  331,  331,  331,  331,  331,  331,  331,  331,  331,
    0,  331,  331,  331,  331,  331,  143,  331,  331,  331,
  331,  331,  331,  331,  331,  331,  331,  331,  331,  331,
  331,  331,    0,  331,  331,    0,   86,  331,    0,   86,
    0,    0,    0,  331,  331,    0,    0,    0,    0,    0,
    0,    0,    0,   86,   86,    0,   86,    0,   86,    0,
    0,    0,  331,  331,  331,  331,  331,  331,  331,  185,
  331,  331,    0,    0,  185,    0,  185,    0,  185,  185,
    0,  185,  174,  175,  176,  177,    0,  419,   86,  419,
  419,  419,  419,  419,    0,  185,  419,    0,  419,  419,
  419,    0,    0,    0,    0,    0,  346,  346,  346,  346,
  346,  346,  346,  346,  419,  346,  346,  346,  346,  346,
   86,  346,  346,  346,  346,  346,  346,  346,  346,  346,
  346,  346,  346,  346,  346,  346,   95,  346,  346,   95,
   93,  346,    0,   93,    0,    0,   94,  346,  346,   94,
    0,    0,    0,   95,   95,    0,    0,   93,   93,  185,
   93,  185,  185,   94,   94,    0,  346,  346,  346,  346,
  346,  346,  346,   93,  346,  346,    0,    0,   81,    0,
   87,    0,  110,   82,    0,   83,    0,   88,   95,  239,
   88,    6,   93,    8,    9,   10,    0,    0,   94,  595,
   11,   12,   13,    0,   88,   88,    0,   88,    0,   88,
    0,    0,    0,    0,  143,  143,   15,    0,    0,   17,
   95,    0,    0,    0,   93,    0,    0,  136,  136,  136,
   94,  136,    0,    0,    0,    0,    0,    0,    0,   88,
    0,    0,  143,  346,    0,    0,  136,    0,  346,    0,
  346,    0,  346,  346,    0,  346,    0,    0,    0,    0,
   86,    0,    0,  277,    0,    0,   92,    0,    0,  346,
    0,   88,    0,    0,    0,    0,    0,    0,  136,    0,
   86,    0,    0,    0,    0,   86,   86,   86,    0,    0,
    0,    0,  185,  185,  185,  185,  185,  185,  185,  185,
  185,    0,  185,  185,  185,  185,  185,    0,  185,  185,
  185,  185,  185,  185,  185,  185,  185,  185,  185,  185,
  185,    0,  185,    0,  185,  185,    0,    0,  185,    0,
    0,    0,    0,  346,  185,  185,  346,   93,    0,    0,
    0,    0,   81,    0,   87,    0,  110,   82,    0,   83,
    0,    0,    0,  185,  185,  185,  185,  185,  185,  185,
   95,  185,  185,  595,   93,    0,    0,    0,    0,    0,
   94,    0,    0,    0,    0,    0,    0,  182,  173,    0,
   95,    0,  180,  178,   93,  179,    0,  181,    0,   93,
   94,    0,    0,    0,    0,    0,    0,  490,  577,    7,
    8,    9,   10,   74,   75,    0,   76,   11,   12,   13,
  578,   88,  579,  580,  581,  582,  583,  584,  585,  586,
  587,  588,  589,   15,   77,   16,   17,  277,   78,   79,
   92,   88,   80,    0,  172,    0,   88,   88,   85,   86,
    0,   93,    0,  409,  136,  136,   81,    0,   87,    0,
  110,   82,    0,   83,    0,    0,    0,  590,   88,   89,
   90,  591,  592,  593,  171,  594,   91,  346,  346,  346,
  346,  346,  346,  346,  346,    0,  346,  346,  346,  346,
  346,    0,  346,  346,  346,  346,  346,  346,  346,  346,
  346,  346,  346,  346,  346,  346,  346,    0,  346,  346,
    0,    0,  346,    0,    0,    0,    0,    0,  346,  346,
    0,  346,    0,  648,    0,    0,  346,    0,  346,    0,
  346,  346,    0,  346,    0,    0,    0,  346,  346,  346,
  346,  346,  346,  346,   92,  346,  346,  346,    0,    0,
    0,    0,    0,  119,    0,    0,    0,    0,    0,  182,
  173,    0,    0,    0,  180,  178,    0,  179,    0,  181,
    0,  490,   58,    0,    0,    0,    0,   74,   75,    0,
   76,    0,    0,    0,  578,    0,  579,  580,  581,  582,
  583,  584,  585,  586,  587,  588,  589,    0,   77,    0,
   17,    0,   78,   79,    0,    0,   80,    0,  206,    0,
  205,  346,   85,   86,  346,  357,  172,    0,    0,    0,
  357,    0,  357,    0,  357,  357,    0,  357,    0,    0,
    0,  590,   88,   89,   90,  591,  592,  593,    0,  594,
   91,  357,  170,  174,  175,  176,  177,    0,    0,    0,
    0,    0,  395,  395,  395,  395,  395,    0,    0,  207,
   93,  395,  395,  395,    0,   81,    0,   87,    0,  110,
   82,    0,   83,    0,  160,   73,    6,  395,    8,    9,
   10,   74,   75,    0,   76,   11,   12,   13,  119,  119,
  119,  119,  119,    0,    0,  119,    0,  119,  119,  119,
    0,   15,   77,    0,   17,  357,   78,   79,  357,    0,
   80,    0,    0,  119,    0,    0,   85,   86,    0,    0,
    0,    0,    6,    7,    8,    9,   10,    0,    0,    0,
    0,   11,   12,   13,    0,    0,   88,   89,   90,    0,
    0,    0,    0,    0,   91,  346,  346,   15,    0,   16,
    0,  346,  346,   92,  346,    0,    0,    0,  346,    0,
  346,  346,  346,  346,  346,  346,  346,  346,  346,  346,
  346,    0,  346,    0,  346,    0,  346,  346,    0,    0,
  346,   91,    0,   93,   91,    0,  346,  346,   81,    0,
  307,    0,  110,   82,    0,   83,    0,    0,   91,   91,
    0,   91,    0,    0,    0,  346,  346,  346,  346,  346,
  346,  346,    0,  346,  346,  174,  175,  176,  177,    0,
    0,    0,  116,    0,    0,    0,    6,    0,    8,    9,
   10,    0,    0,   91,    0,   11,   12,   13,    0,  357,
  357,    0,    0,    0,    0,  357,  357,    0,  357,    0,
    0,   15,  357,   16,  357,  357,  357,  357,  357,  357,
  357,  357,  357,  357,  357,   91,  357,    0,  357,    0,
  357,  357,    0,    0,  357,    0,   92,    0,    0,    0,
  357,  357,    0,    0,   73,    6,    0,    8,    9,   10,
   74,   75,    0,   76,   11,   12,   13,    0,    0,  357,
  357,  357,  357,  357,  357,  357,    0,  357,  357,    0,
   15,   77,    0,   17,    0,   78,   79,    0,    0,   80,
    0,    0,    0,    0,    0,   85,   86,    0,  115,    0,
   93,    0,  137,  137,  137,   81,  137,   87,    0,  110,
   82,    0,   83,  491,    0,   88,   89,   90,    0,    0,
    0,  137,    0,   91,    0,  116,    0,  346,  346,  346,
  346,  346,    0,    0,    0,    0,  346,  346,  346,   93,
    0,    0,    0,    0,   81,    0,   87,    0,  110,   82,
    0,   83,  346,  137,    0,    0,    0,    0,  492,    0,
    6,    7,    8,    9,   10,    0,    0,    0,    0,   11,
   12,   13,    0,    0,    0,   91,    0,   73,    6,    0,
    8,    9,   10,   74,   75,   15,   76,   11,   12,   13,
  493,    0,    0,   92,    0,   91,  177,    0,    0,    0,
   91,    0,    0,   15,   77,    0,   17,    0,   78,   79,
    0,  177,   80,  177,    0,   93,    0,    0,   85,   86,
   81,    0,   87,    0,  110,   82,    0,   83,    0,  479,
    0,    0,   92,  346,  346,  346,  346,  346,   88,   89,
   90,    0,  346,  346,  346,    0,   91,    0,    0,    0,
    0,    0,    0,    0,   93,    0,    0,    0,  346,   81,
    0,   87,    0,  110,   82,    0,   83,    0,    0,    0,
    0,  182,  173,    0,    0,  226,  180,  178,    0,  179,
    0,  181,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  671,    0,    0,  167,    0,  168,    0,    0,
    0,    0,    0,    0,    0,  493,    0,    0,   92,    0,
    0,    0,    0,    0,  333,    0,    0,    0,    0,  137,
  137,    0,    0,  489,  490,   58,    0,    0,  172,   93,
   74,   75,    0,   76,   81,    0,   87,    0,  361,   82,
    0,   83,    0,    0,    0,    0,    0,   92,  149,  149,
  149,   77,  149,   17,    0,   78,   79,    0,  171,   80,
    0,    0,  478,   73,    0,   85,   86,  149,   93,   74,
   75,    0,   76,   81,    0,   87,    0,  110,   82,    0,
   83,    0,    0,    0,    0,   88,   89,   90,    0,  362,
   77,    0,   17,   91,   78,   79,    0,    0,   80,  149,
    0,    0,    0,    0,   85,   86,    0,    0,  226,    0,
  226,  226,  226,  226,  226,    0,    0,    0,    0,  226,
  226,  226,   92,    0,   88,   89,   90,    0,    0,    0,
    0,    0,   91,    0,    0,  226,    0,  177,  489,   73,
    0,    0,   93,    0,    0,   74,   75,   81,   76,   87,
    0,  110,   82,    0,   83,    0,    0,    0,  373,    0,
    0,   92,    0,    0,    0,    0,   77,    0,   17,    0,
   78,   79,  664,    0,   80,    0,    0,    0,   73,    0,
   85,   86,    0,    0,   74,   75,   93,   76,    0,    0,
    0,   81,    0,   87,    0,  110,   82,    0,   83,  670,
   88,   89,   90,    0,    0,   77,    0,   17,   91,   78,
   79,    0,    0,   80,    0,    0,    0,    0,    0,   85,
   86,    0,    0,    0,  166,  169,  170,  174,  175,  176,
  177,    0,    0,    0,    0,   92,    0,  707,    0,   88,
   89,   90,    0,    0,    0,   93,  394,   91,    0,    0,
   81,    0,   87,   73,  110,   82,    0,   83,  721,   74,
   75,  724,   76,  726,    0,  149,  149,    0,  149,    0,
    0,    0,  735,    0,    0,  149,  149,  149,    0,   92,
   77,    0,   17,    0,   78,   79,    0,    0,   80,    0,
    0,  149,   73,  149,   85,   86,    0,    0,   74,   75,
    0,   76,    0,    0,  760,  426,    0,  156,  156,  156,
    0,  156,    0,    0,   88,   89,   90,    0,  770,   77,
    0,   17,   91,   78,   79,  156,  156,   80,    0,    0,
   93,    0,    0,   85,   86,   81,    0,   87,   92,  110,
   82,    0,   83,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   88,   89,   90,    0,    0,    0,    0,
    0,   91,    0,    0,    0,  160,   73,    0,    0,    0,
    0,    0,   74,   75,   93,   76,    0,    0,    0,   81,
    0,   87,    0,  614,   82,    0,   83,    0,    0,    0,
  448,    0,  156,   77,    0,   17,    0,   78,   79,    0,
    0,   80,    0,    0,    0,    0,    0,   85,   86,    0,
   73,    0,    0,    0,    0,    0,   74,   75,    0,   76,
    0,    0,    0,   92,    0,    0,    0,   88,   89,   90,
    0,    0,    0,    0,  615,   91,    0,   77,    0,   17,
    0,   78,   79,    0,    0,   80,    0,    0,   93,    0,
    0,   85,   86,   81,    0,   87,    0,  110,   82,    0,
   83,    0,    0,    0,    0,    0,    0,   92,    0,   73,
    0,   88,   89,   90,  630,   74,   75,    0,   76,   91,
    0,    6,    7,    8,    9,   10,    0,    0,  475,    0,
   11,   12,   13,    0,    0,    0,   77,    0,   17,    0,
   78,   79,    0,    0,   80,    0,   15,   93,   16,    0,
   85,   86,   81,    0,   87,    0,  110,   82,    0,   83,
    0,    0,    0,    0,  156,  156,  156,  156,  156,  156,
   88,   89,   90,  637,  156,  156,  156,    0,   91,    0,
    0,   92,    0,    0,    0,    0,    0,    0,    0,    0,
  156,    0,  156,    0,   73,    0,    0,    0,    0,    0,
   74,   75,    0,   76,    0,   93,    0,    0,    0,    0,
   81,    0,   87,    0,  110,   82,    0,   83,    0,    0,
    0,   77,    0,   17,    0,   78,   79,    0,    0,   80,
    0,  639,    0,    0,    0,   85,   86,    0,   73,    0,
   92,    0,    0,    0,   74,   75,    0,   76,    0,    0,
    0,    0,    0,    0,    0,   88,   89,   90,    0,    0,
    0,    0,    0,   91,    0,   77,    0,   17,    0,   78,
   79,    0,   84,   80,    0,   84,   93,    0,    0,   85,
   86,   81,    0,   87,    0,  110,   82,    0,   83,   84,
   84,    0,   84,    0,   84,    0,    0,    0,   92,   88,
   89,   90,  641,    0,    0,    0,    0,   91,    0,    0,
    0,    0,   73,    0,    0,    0,    0,    0,   74,   75,
    0,   76,   93,    0,   84,   84,    0,   81,    0,   87,
    0,  110,   82,    0,   83,    0,    0,    0,    0,   77,
    0,   17,    0,   78,   79,    0,    0,   80,    0,    0,
    0,    0,    0,   85,   86,   84,   84,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   92,
    0,   73,    0,   88,   89,   90,    0,   74,   75,    0,
   76,   91,  659,    0,    0,    0,    0,   93,    0,    0,
    0,    0,   81,    0,   87,    0,   84,   82,   77,   83,
   17,    0,   78,   79,    0,    0,   80,    0,    0,    0,
    0,    0,   85,   86,  349,   92,    6,    7,    8,    9,
   10,    0,    0,  351,    0,   11,   12,   13,    0,   73,
    0,    0,   88,   89,   90,   74,   75,  241,   76,    0,
   91,   15,  241,   16,  241,    0,  241,  241,    0,  241,
    0,    0,    0,    0,    0,    0,   77,    0,   17,    0,
   78,   79,    0,    0,   80,    0,    0,    0,    0,    0,
   85,   86,  349,  350,    6,    7,    8,    9,   10,    0,
   92,  351,    0,   11,   12,   13,    0,    0,    0,    0,
   88,   89,   90,    0,    0,    0,   84,  241,   91,   15,
   73,   16,    0,   89,    0,    0,   74,   75,   89,   76,
   89,    0,   89,   89,    0,   89,   84,    0,    0,    0,
    0,   84,   84,   84,    0,    0,    0,   77,   92,   17,
  241,   78,   79,    0,    0,   80,    0,    0,    0,    0,
    0,   85,   86,    0,    0,    0,   73,    0,    0,    0,
    0,    0,   74,   75,    0,   76,    0,    0,    0,    0,
    0,   88,   89,   90,    0,    0,    0,    0,    0,   91,
    0,    0,    0,   77,    0,   17,    0,   78,   79,    0,
    0,   80,    0,    0,    0,  244,    0,   85,   86,    0,
  244,    0,  244,    0,  244,  244,   89,  244,    0,    0,
    0,    0,    0,    0,    0,    0,    0,   88,   89,   90,
    0,   73,    0,    0,    0,   91,    0,   74,   75,    0,
   76,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  763,    0,    0,    0,    0,   77,    0,
   17,    0,   78,   79,    0,  244,   80,  158,  158,  158,
  242,  158,   85,   86,    0,  242,    0,  242,    0,  242,
  242,  241,  242,    0,    0,  158,  158,  241,  241,    0,
  241,    0,   88,   89,   90,    0,    0,    0,  244,    0,
   91,    0,    0,    0,    0,    0,    0,    0,  241,    0,
  241,    0,  241,  241,   81,    0,  241,   81,  158,   93,
   81,    0,  241,  241,   81,    0,   87,    0,   84,   82,
  242,   83,    0,    0,   81,   81,    0,   81,    0,   81,
    0,    0,  241,  241,  241,    0,    0,   89,    0,    0,
  241,    0,  158,   89,   89,    0,   89,    0,    0,    0,
    0,    0,    0,  242,    0,    0,    0,    0,    0,   81,
   81,    0,    0,    0,   89,    0,   89,    0,   89,   89,
    0,    0,   89,    0,    0,   93,    0,    0,   89,   89,
   81,    0,   87,    0,  110,   82,    0,   83,    0,    0,
   81,   81,    0,    0,    0,    0,    0,    0,   89,   89,
   89,    0,   92,    0,    0,    0,   89,    0,    0,    0,
    0,    0,    6,    7,    8,    9,   10,    0,    0,  244,
    0,   11,   12,   13,   93,  244,  244,    0,  244,   81,
    0,  191,    0,  110,   82,    0,   83,   15,    0,   16,
    0,    0,    0,    0,    0,    0,  244,    0,  244,    0,
  244,  244,    0,    0,  244,    0,    0,    0,    0,    0,
  244,  244,    0,    0,    0,    0,    0,    0,   92,    0,
    0,    0,    0,    0,  158,  158,    0,    0,    0,    0,
  244,  244,  244,    0,  242,    0,    0,    0,  244,   93,
  242,  242,    0,  242,   81,    0,  193,    0,  110,   82,
    0,   83,  158,    0,  182,  173,    0,    0,    0,  180,
  178,  242,  179,  242,  181,  242,  242,   92,    0,  242,
    0,    0,    0,    0,    0,  242,  242,    0,  167,    0,
  168,   81,    0,   73,    0,    0,    0,    0,    0,   74,
   75,    0,   76,    0,    0,  242,  242,  242,    0,    0,
    0,   81,    0,  242,    0,    0,   81,   81,   81,   81,
   77,  172,   17,    0,   78,   79,    0,    0,   80,    0,
    0,   93,    0,    0,   85,   86,   81,    0,  195,    0,
  110,   82,   92,   83,    0,    0,    0,    0,    0,    0,
    0,  171,    0,    0,   88,   89,   90,    0,    0,   73,
    0,    0,   91,    0,    0,   74,   75,    0,   76,    0,
   93,    0,    0,    0,    0,   81,    0,  199,    0,  110,
   82,    0,   83,    0,    0,    0,   77,    0,   17,    0,
   78,   79,    0,    0,   80,    0,    0,    0,    0,    0,
   85,   86,    0,    0,    0,    0,    0,    0,   73,    0,
    0,    0,    0,    0,   74,   75,    0,   76,    0,    0,
   88,   89,   90,    0,   92,    0,  182,  173,   91,    0,
    0,  180,  178,    0,  179,   77,  181,   17,    0,   78,
   79,    0,    0,   80,    0,    0,   93,    0,    0,   85,
   86,   81,  168,  201,    0,  110,   82,    0,   83,    0,
    0,    0,    0,   92,    0,    0,    0,    0,    0,   88,
   89,   90,    0,   73,    0,    0,    0,   91,    0,   74,
   75,    0,   76,  172,    0,   93,    0,    0,    0,    0,
   81,    0,   87,    0,  110,   82,    0,   83,    0,    0,
   77,    0,   17,    0,   78,   79,    0,    0,   80,    0,
    0,    0,   16,  171,   85,   86,    0,  166,  169,  170,
  174,  175,  176,  177,    0,    0,    0,    0,  159,  159,
  159,    0,  159,    0,   88,   89,   90,    0,    0,   92,
    0,    0,   91,    0,    0,    0,  159,  159,    0,    0,
    0,    0,    0,    0,    0,   73,    0,    0,    0,    0,
    0,   74,   75,    0,   76,   96,   96,    0,   96,    0,
   96,   96,    0,   96,   96,   96,    0,    0,   92,  159,
    0,    0,   77,    0,   17,    0,   78,   79,    0,   96,
   80,   96,    0,    0,   73,    0,   85,   86,    0,    0,
   74,   75,    0,   76,  182,  173,    0,    0,    0,  180,
  178,    0,  179,  159,  181,    0,   88,   89,   90,   96,
    0,   77,   96,   17,   91,   78,   79,    0,  167,   80,
  168,    0,    0,    0,    0,   85,   86,    0,   98,   98,
    0,   98,   98,   98,   98,   98,   98,   98,   98,    0,
    0,    0,   96,    0,    0,   88,   89,   90,    0,   98,
   98,  172,   98,   91,   98,    0,    0,    0,    0,    0,
   73,    0,    0,    0,    0,    0,   74,   75,    0,   76,
  169,  170,  174,  175,  176,  177,    0,    0,    0,    0,
    0,  171,   98,    0,   98,   98,    0,   77,    0,   17,
    0,   78,   79,    0,    0,   80,    0,    0,    0,  401,
    0,   85,   86,    0,    0,   74,   75,    0,   76,    0,
    0,    0,    0,    0,    0,   98,   98,    0,    0,    0,
    0,   88,   89,   90,    0,    0,   77,    0,   17,   91,
   78,   79,    0,    0,   80,  159,  159,    0,    0,    0,
   85,   86,  177,   96,   96,    0,   96,    0,   96,   96,
   96,   96,   96,   96,    0,    0,    0,  177,    0,  177,
   88,   89,   90,  159,   31,   96,    0,   96,   91,   96,
  182,  173,    0,    0,    0,  180,  178,    0,  179,    0,
  181,  182,  173,    0,    0,    0,  180,  178,    0,  179,
    0,  181,    0,    0,  167,    0,  168,   96,    0,    0,
   96,    0,  715,    0,    0,  167,    0,  168,   96,   96,
   96,   96,   96,   96,   96,    0,   96,   96,    0,   96,
    0,  229,    0,    0,    0,    0,  661,  172,    0,    0,
   96,   96,    0,    0,    0,    0,    0,    0,  172,   73,
    0,    0,   73,    0,   73,   73,   73,  166,  169,  170,
  174,  175,  176,  177,    0,   83,   98,  171,   83,   73,
   73,    0,   73,    0,   73,    0,    0,    0,  171,    0,
    0,    0,   83,   83,    0,   83,   98,   83,    0,    0,
    0,   98,   98,   98,   98,   98,   98,   98,    0,   98,
   98,    0,   98,   74,   73,   73,   74,    0,   74,   74,
   74,    0,    0,    0,    0,    0,    0,   83,    0,    0,
    0,    0,    0,   74,   74,    0,   74,    0,   74,    0,
    0,    0,    0,    0,    0,   73,   73,    0,    0,    0,
   78,    0,    0,   78,    0,    0,   78,    0,   83,   83,
    0,    0,    0,    0,    0,    0,    0,    0,   74,   74,
   78,   78,    0,   78,  229,   78,  229,  229,  229,  229,
  229,    0,    0,    0,    0,  229,  229,  229,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   74,
   74,  229,    0,  177,    0,   78,   78,    0,   79,    0,
    0,   79,    0,    0,   79,    0,   96,   96,   96,   96,
   96,   96,   96,    0,   96,   96,    0,   96,   79,   79,
    0,   79,    0,   79,    0,    0,   78,   78,    0,    0,
    0,    0,    0,  166,  169,  170,  174,  175,  176,  177,
    0,    0,    0,    0,  166,  169,  170,  174,  175,  176,
  177,    0,    0,   79,   79,    0,    0,   80,    0,    0,
   80,    0,    0,   80,    0,    0,    0,   82,    0,    0,
   82,    0,    0,   82,    0,    0,   73,   80,   80,    0,
   80,    0,   80,    0,   79,   79,    0,   82,   82,   83,
   82,    0,   82,    0,    0,    0,   73,    0,    0,    0,
    0,   73,   73,   73,   73,   73,   73,   73,    0,   83,
    0,    0,   80,   80,   83,   83,   83,  271,  271,  271,
    0,  271,   82,   82,    0,    0,    0,    0,    0,    0,
   74,    0,    0,    0,    0,  271,  271,    0,    0,    0,
    0,    0,    0,   80,   80,    0,    0,    0,    0,    0,
   74,    0,    0,   82,   82,   74,   74,   74,   74,   74,
   74,   74,  275,  275,  275,    0,  275,   78,  271,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  275,  275,  280,  280,  280,    0,  280,   78,    0,    0,
    0,    0,   78,   78,   78,   78,   78,   78,   78,    0,
  280,  280,  271,  170,  170,  170,    0,  170,    0,    0,
    0,    0,    0,  275,    0,    0,    0,    0,    0,    0,
    0,  170,  170,  256,    0,   79,  256,    0,    0,    0,
    0,    0,    0,  280,    0,    0,    0,    0,    0,    0,
  256,  256,    0,  256,    0,   79,    0,  275,    0,    0,
   79,   79,   79,   79,   79,   79,   79,    0,  260,    0,
    0,  260,    0,    0,    0,    0,    0,  280,    0,    0,
    0,    0,    0,    0,    0,  260,  260,    0,  260,    0,
    0,    0,    0,    0,   80,    0,    0,    0,  170,    0,
    0,    0,    0,    0,   82,    0,    0,    0,  148,  148,
  148,    0,  148,    0,   80,  256,    0,  256,    0,   80,
   80,   80,   80,   80,   82,    0,    0,  148,    0,   82,
   82,   82,    0,    0,    0,    0,    0,    0,    0,    0,
  238,    0,    0,  238,  271,  271,  271,  271,  271,  271,
  260,    0,  260,    0,  271,  271,  271,  238,  238,  148,
  238,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  271,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  239,    0,    0,  239,  275,
  275,  275,  275,  275,  275,    0,    0,    0,    0,  275,
  275,  275,  239,  239,    0,  239,    0,    0,    0,  280,
  280,  280,  280,  280,  280,    0,    0,  275,    0,  280,
  280,  280,  238,    0,  238,  150,  150,  150,    0,  150,
  170,  170,  170,  170,  170,  170,    0,  280,    0,    0,
  170,  170,  170,    0,  150,    0,    0,    0,  256,    0,
  256,  256,  256,  256,  256,    0,    0,    0,  170,  256,
  256,  256,    0,    0,  233,    0,    0,  239,    0,  239,
    0,    0,    0,    0,  256,  256,  150,  256,  233,  233,
    0,  233,    0,  260,    0,  260,  260,  260,  260,  260,
    0,    0,    0,    0,  260,  260,  260,    0,    0,  232,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  260,
  260,    0,  260,  232,  232,    0,  232,    0,    0,    0,
    0,    0,    0,    0,    0,  148,  148,  148,  148,  148,
  148,  177,    0,    0,    0,  148,  148,  148,    0,    0,
    0,    0,    0,  233,    0,  233,  177,    0,  177,    0,
    0,  148,    0,    0,    0,  238,    0,  238,  238,  238,
  238,  238,  177,    0,    0,    0,  238,  238,  238,    0,
    0,  185,  185,  185,    0,  185,    0,  177,  232,  177,
  232,  238,  238,    0,  238,    0,    0,    0,    0,  185,
  185,    0,  177,    0,    0,    0,    0,    0,    0,    0,
  239,    0,  239,  239,  239,  239,  239,  177,    0,  177,
   27,  239,  239,  239,    0,    0,    0,    0,    0,  141,
  141,  141,  185,  141,    0,    0,  239,  239,    0,  239,
    0,    0,    0,    0,    0,    0,    0,    0,  141,    0,
    0,   19,  150,  150,  150,  150,  150,  150,    0,    0,
    0,    0,  150,  150,  150,   18,  185,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  150,    0,
  141,   23,    0,    0,    0,    0,  233,    0,  233,  233,
  233,  233,  233,    0,    0,    0,    0,  233,  233,  233,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  233,  233,    0,  233,    0,    0,    0,    0,
    0,  232,    0,  232,  232,  232,  232,  232,    0,    0,
    0,    0,  232,  232,  232,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  232,  232,    0,
  232,    0,    0,    0,    0,   27,   27,   27,   27,   27,
    0,    0,    0,    0,   27,   27,   27,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
   27,    0,  177,    0,    0,    0,   19,   19,   19,   19,
   19,    0,    0,    0,    0,   19,   19,   19,  185,  185,
  185,  185,  185,  185,    0,    0,    0,    0,  185,  185,
  185,   19,    0,  177,    0,    0,   23,   23,   23,   23,
   23,    0,    0,    0,    0,   23,   23,   23,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   23,    0,  177,    0,    0,  141,  141,  141,  141,
  141,  141,    0,    0,    0,    0,  141,  141,  141,    0,
    0,    0,    5,    0,    6,    7,    8,    9,   10,    0,
    0,    0,    0,   11,   12,   13,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,   14,   15,
    0,   16,   17,
};
const short yycheck[] = {                                      38,
   43,   44,   26,   27,   28,   47,   52,    3,    4,   30,
    3,    4,   19,   20,   20,  163,    3,    4,  259,  231,
    3,    4,  271,  125,  236,  120,    3,    4,  187,  207,
  124,   52,   40,   53,   11,   12,   13,   20,   34,  115,
   22,   34,  232,   20,   87,  272,   67,   34,   40,  155,
   40,   34,   41,   30,   46,   58,   80,   34,  316,  211,
   91,   59,   44,  484,  139,  501,  206,  256,   50,   40,
   47,   42,   40,  230,   42,   52,   53,  285,  259,  409,
  261,  238,   40,   91,   40,  148,   42,   58,   59,  246,
   67,    4,  249,  282,  118,   40,   87,   78,   79,   91,
  121,   37,   40,   84,   42,   87,   42,   43,  128,   45,
  205,   47,  548,   94,  208,   40,   40,  139,   42,  143,
   40,   34,   42,   91,  145,  231,  107,  125,  149,  110,
  236,   40,  115,  115,   40,   41,  113,  573,  115,   40,
   46,   42,  320,  139,  121,  188,   91,   40,  191,   42,
  193,  128,  195,   91,   40,  257,  199,  139,  201,  123,
   59,  185,  186,  145,  227,  271,  325,   91,  145,  244,
  322,  148,  149,  313,  103,  104,  105,  507,  318,  108,
  109,   41,   91,   41,   44,   91,   44,   40,   37,   42,
  233,  211,   44,   42,   43,   40,   45,   42,   47,   59,
  191,   59,  193,  224,  195,   42,  197,  228,  199,  191,
  201,  193,   40,  195,   42,  197,  474,  199,   40,  201,
   42,  264,  244,   61,   44,   40,  647,   41,  252,  206,
   44,  337,  338,  123,  241,  242,   58,   59,   91,   59,
  283,   61,  224,  123,  123,   59,   91,  224,  244,  123,
  227,  228,   23,   40,  411,  412,   44,   40,  415,  242,
  242,   93,  244,   91,  307,   40,  256,   42,  197,   40,
   41,   42,  534,  125,  317,  264,  123,  285,  261,  506,
   51,  543,  285,   40,  261,  433,  257,  258,  259,  260,
  261,  262,  256,  261,  262,  276,  267,  268,  269,   70,
  324,  257,  322,  125,   91,  462,  298,  299,   91,  301,
  467,  468,  469,   44,  285,  472,  473,  285,  123,  257,
   40,  345,   42,  653,   41,  465,   40,   44,   59,  285,
  482,  313,  438,  316,   91,  525,  313,  257,  258,  316,
  285,  318,   59,  419,  420,  352,  353,  353,  526,   40,
  456,   42,   59,  124,  264,  398,  257,  516,  294,  295,
  296,  285,  368,  520,  257,  136,   40,  125,   42,  464,
  353,   91,  466,  282,  121,  470,  353,  471,  257,  258,
  361,  123,  522,  523,  285,  368,  538,   44,   59,  529,
  530,   41,  298,  299,  125,  301,  387,  388,  419,  420,
  506,  123,   41,  560,  257,  387,  388,  245,  556,  247,
  257,  258,  257,  437,   41,  457,  261,  262,  125,  668,
  257,  258,   44,  430,  431,  285,   40,  285,   42,  257,
  258,   58,  285,  261,  262,  257,  258,  208,   44,  422,
  285,  487,  419,  420,  465,  422,  295,  296,  431,  431,
  257,  258,  257,  258,  125,   61,  613,  285,  387,  388,
   41,   41,  482,  285,   44,  285,  487,  491,  125,  256,
   44,  285,   40,  256,   42,   41,   40,  224,   59,   59,
  457,  228,  257,  123,  125,   59,   40,  644,  465,  123,
   58,  474,  704,  256,  706,  282,  267,  474,   41,  282,
   40,  522,  523,  125,   41,   44,  123,  484,  529,  530,
  487,  752,   93,  556,   41,  257,  258,    0,  538,  125,
   59,  762,   61,  566,   40,  123,   42,   91,  552,   59,
   40,   41,  556,  123,   59,  257,  258,  257,  258,   40,
  522,  689,   59,   59,  587,  522,  523,  529,  591,  592,
  593,   91,  529,  530,   40,    0,   40,   40,   42,   42,
  556,  282,  668,  556,  588,  285,  257,  258,  285,  556,
  261,  262,  259,  556,  261,   40,   59,   42,  621,  556,
  682,   91,  625,  257,   41,  733,  734,  261,  262,  632,
   91,  598,  599,  599,  285,   40,   44,   42,  704,  264,
  706,   58,   59,  649,   59,  647,  602,   91,  261,  602,
   41,  285,   61,  656,   59,  602,  599,  257,  258,  602,
  663,  602,  599,  257,  258,  602,   59,   58,  649,   37,
   38,   41,  675,  614,   42,   43,   93,   45,   41,   47,
  257,  258,   33,  257,  258,  265,  689,   38,   58,   40,
  125,   42,   43,   61,   45,   63,  404,  696,  406,  257,
  258,   40,   41,  702,   58,  689,   41,  165,  166,  167,
  647,  285,  649,  171,  172,  173,  174,  175,  176,  177,
  178,  179,  180,  181,  182,   93,   94,  522,  523,  257,
  258,   46,   40,   41,  737,  466,   40,  736,   42,   41,
  471,   93,  741,   37,   38,  285,   61,   41,   42,   43,
   44,   45,   91,   47,   58,   59,  124,  285,   46,   40,
  759,   42,   41,   41,   58,   59,  256,   61,  258,   63,
  260,  261,  262,   61,   44,  126,   91,  267,  268,  269,
   33,  257,  258,   91,   41,   38,   44,   40,   41,   42,
   43,   44,   45,  283,   41,   41,  286,   44,   44,   93,
   94,   58,   41,   91,   41,   58,   59,   44,   61,  285,
   91,   58,   59,  256,  257,  258,  259,  260,  261,  262,
   41,  125,   59,   41,  267,  268,  269,  285,  286,   41,
  124,  125,  257,  258,   44,   44,   61,   58,   91,  282,
  283,   41,  285,  286,   44,  259,   93,  261,  262,   59,
   59,  256,  257,  258,  259,  260,  261,  262,   41,   59,
  285,   44,  267,  268,  269,  258,  259,  260,  261,  262,
  123,   93,  125,  126,  267,  268,  269,  282,  283,   44,
  285,  286,  256,  257,  258,   40,   41,   42,   41,   44,
  283,   44,  285,   33,   59,  125,   41,  265,   38,   44,
   40,  125,   42,   43,   59,   45,  257,  258,  259,  260,
  261,  262,  263,  264,   59,  266,  267,  268,  269,   59,
   61,  379,  290,  291,  292,  293,  294,  295,  296,  125,
   41,   44,  283,  284,  285,  286,   91,  288,  289,   41,
   41,  292,   44,   44,   37,   38,   59,  298,  299,   42,
   43,   41,   45,  257,   47,  413,   37,   58,   59,   93,
  261,   42,   43,  287,   45,   93,   47,  318,  319,  320,
  428,  265,   44,   44,   37,  326,  257,  258,  436,   42,
   43,  285,   45,  123,   47,   58,  126,   59,   59,   41,
   41,  285,   93,   44,   44,  453,  290,  291,  292,  293,
  294,  295,  296,  256,  257,  258,  259,  260,  261,  262,
  263,  264,  257,  266,  267,  268,  269,  270,   59,  272,
  273,  274,  275,  276,  277,  278,  279,  280,  281,  282,
  283,  284,   44,  286,  492,  288,  289,  125,   44,  292,
   40,   41,   42,  501,   44,  298,  299,   59,   44,   59,
  256,   93,  510,   59,   41,   41,   44,   44,   44,   59,
   44,  519,   41,   59,  317,  318,  319,  320,  321,  322,
  323,   59,  325,  326,   33,   59,  534,   37,   41,   38,
   41,   40,   42,   42,   43,  543,   45,   47,  546,   41,
  548,   91,   44,   41,   58,  125,  259,  260,  261,  262,
   59,   44,  257,  561,  267,  268,  269,   41,   41,  125,
   44,   44,  570,   40,  125,  573,  256,  257,  258,  259,
  260,  261,  262,  263,  264,  583,  266,  267,  268,  269,
  270,  125,  272,  273,  274,  275,  276,  277,  278,  279,
  280,  281,  282,  283,  284,  285,  286,  287,  288,  289,
  125,  258,  292,  260,  261,  262,   40,   40,  298,  299,
  267,  268,  269,   33,  123,   58,  125,  126,   38,  261,
   40,   59,   42,   43,   59,   45,  283,  317,  318,  319,
  320,  321,  322,  323,   40,  325,  326,   37,   38,   59,
   59,   58,   42,   43,   44,   45,   59,   47,   59,  256,
  293,  294,  295,  296,  271,   41,   93,   40,   59,   59,
   59,   61,  670,   63,   40,   59,   59,  258,  259,  260,
  261,  262,   59,  256,   41,  272,  267,  268,  269,   59,
  293,  294,  295,  296,   41,   59,   41,   41,   33,   59,
   59,  264,  283,   38,   94,   40,   59,   42,   43,   59,
   45,   40,   44,  123,   41,   41,  126,  257,  258,   59,
  260,   59,   59,   59,   59,   41,   93,  267,  268,  269,
  260,  261,  262,  125,  124,  123,   41,  267,  268,  269,
  125,   41,   41,  283,  125,  285,   37,   38,   41,   59,
  125,   42,   43,  125,   45,   40,   47,  256,  257,  258,
  259,  260,  261,  262,  263,  264,   41,  266,  267,  268,
  269,  270,  325,  272,  273,  274,  275,  276,  277,  278,
  279,  280,  281,  282,  283,  284,  285,  286,  123,  288,
  289,  126,   41,  292,  125,  125,   49,  624,  212,  298,
  299,  453,   33,   94,  486,  740,  738,   38,  324,   40,
  244,   42,   43,  338,   45,  252,  456,  422,  317,  318,
  319,  320,  321,  322,  323,  345,  325,  326,   59,  259,
  260,  261,  262,  124,  319,  636,  506,  267,  268,  269,
  257,  258,  259,  260,  261,  262,  256,  257,  258,  259,
  260,  261,  262,  263,  264,  285,  266,  267,  268,  269,
  270,  134,  272,  273,  274,  275,  276,  277,  278,  279,
  280,  281,  282,  283,  284,  285,  286,  602,  288,  289,
  546,  499,  292,  262,  347,  439,  689,  689,  298,  299,
   -1,   -1,  123,   -1,  125,  126,   -1,   -1,   -1,   -1,
  290,  291,  292,  293,  294,  295,  296,  317,  318,  319,
  320,  321,  322,  323,   -1,  325,  326,   40,   -1,   42,
   -1,  256,  257,  258,  259,  260,  261,  262,  263,  264,
   -1,  266,  267,  268,  269,  270,   59,  272,  273,  274,
  275,  276,  277,  278,  279,  280,  281,  282,  283,  284,
  285,  286,   -1,  288,  289,   -1,   41,  292,   -1,   44,
   -1,   -1,   -1,  298,  299,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   58,   59,   -1,   61,   -1,   63,   -1,
   -1,   -1,  317,  318,  319,  320,  321,  322,  323,   33,
  325,  326,   -1,   -1,   38,   -1,   40,   -1,   42,   43,
   -1,   45,  293,  294,  295,  296,   -1,  256,   93,  258,
  259,  260,  261,  262,   -1,   59,  265,   -1,  267,  268,
  269,   -1,   -1,   -1,   -1,   -1,  257,  258,  259,  260,
  261,  262,  263,  264,  283,  266,  267,  268,  269,  270,
  125,  272,  273,  274,  275,  276,  277,  278,  279,  280,
  281,  282,  283,  284,  285,  286,   41,  288,  289,   44,
   41,  292,   -1,   44,   -1,   -1,   41,  298,  299,   44,
   -1,   -1,   -1,   58,   59,   -1,   -1,   58,   59,  123,
   61,  125,  126,   58,   59,   -1,  317,  318,  319,  320,
  321,  322,  323,   33,  325,  326,   -1,   -1,   38,   -1,
   40,   -1,   42,   43,   -1,   45,   -1,   41,   93,  256,
   44,  258,   93,  260,  261,  262,   -1,   -1,   93,   59,
  267,  268,  269,   -1,   58,   59,   -1,   61,   -1,   63,
   -1,   -1,   -1,   -1,  257,  258,  283,   -1,   -1,  286,
  125,   -1,   -1,   -1,  125,   -1,   -1,   40,   41,   42,
  125,   44,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   93,
   -1,   -1,  285,   33,   -1,   -1,   59,   -1,   38,   -1,
   40,   -1,   42,   43,   -1,   45,   -1,   -1,   -1,   -1,
  265,   -1,   -1,  123,   -1,   -1,  126,   -1,   -1,   59,
   -1,  125,   -1,   -1,   -1,   -1,   -1,   -1,   91,   -1,
  285,   -1,   -1,   -1,   -1,  290,  291,  292,   -1,   -1,
   -1,   -1,  256,  257,  258,  259,  260,  261,  262,  263,
  264,   -1,  266,  267,  268,  269,  270,   -1,  272,  273,
  274,  275,  276,  277,  278,  279,  280,  281,  282,  283,
  284,   -1,  286,   -1,  288,  289,   -1,   -1,  292,   -1,
   -1,   -1,   -1,  123,  298,  299,  126,   33,   -1,   -1,
   -1,   -1,   38,   -1,   40,   -1,   42,   43,   -1,   45,
   -1,   -1,   -1,  317,  318,  319,  320,  321,  322,  323,
  265,  325,  326,   59,  265,   -1,   -1,   -1,   -1,   -1,
  265,   -1,   -1,   -1,   -1,   -1,   -1,   37,   38,   -1,
  285,   -1,   42,   43,  285,   45,   -1,   47,   -1,  290,
  285,   -1,   -1,   -1,   -1,   -1,   -1,  257,  258,  259,
  260,  261,  262,  263,  264,   -1,  266,  267,  268,  269,
  270,  265,  272,  273,  274,  275,  276,  277,  278,  279,
  280,  281,  282,  283,  284,  285,  286,  123,  288,  289,
  126,  285,  292,   -1,   94,   -1,  290,  291,  298,  299,
   -1,   33,   -1,   59,  257,  258,   38,   -1,   40,   -1,
   42,   43,   -1,   45,   -1,   -1,   -1,  317,  318,  319,
  320,  321,  322,  323,  124,  325,  326,  257,  258,  259,
  260,  261,  262,  263,  264,   -1,  266,  267,  268,  269,
  270,   -1,  272,  273,  274,  275,  276,  277,  278,  279,
  280,  281,  282,  283,  284,  285,  286,   -1,  288,  289,
   -1,   -1,  292,   -1,   -1,   -1,   -1,   -1,  298,  299,
   -1,   33,   -1,   59,   -1,   -1,   38,   -1,   40,   -1,
   42,   43,   -1,   45,   -1,   -1,   -1,  317,  318,  319,
  320,  321,  322,  323,  126,  325,  326,   59,   -1,   -1,
   -1,   -1,   -1,  123,   -1,   -1,   -1,   -1,   -1,   37,
   38,   -1,   -1,   -1,   42,   43,   -1,   45,   -1,   47,
   -1,  257,  258,   -1,   -1,   -1,   -1,  263,  264,   -1,
  266,   -1,   -1,   -1,  270,   -1,  272,  273,  274,  275,
  276,  277,  278,  279,  280,  281,  282,   -1,  284,   -1,
  286,   -1,  288,  289,   -1,   -1,  292,   -1,   40,   -1,
   42,  123,  298,  299,  126,   33,   94,   -1,   -1,   -1,
   38,   -1,   40,   -1,   42,   43,   -1,   45,   -1,   -1,
   -1,  317,  318,  319,  320,  321,  322,  323,   -1,  325,
  326,   59,  292,  293,  294,  295,  296,   -1,   -1,   -1,
   -1,   -1,  258,  259,  260,  261,  262,   -1,   -1,   91,
   33,  267,  268,  269,   -1,   38,   -1,   40,   -1,   42,
   43,   -1,   45,   -1,  256,  257,  258,  283,  260,  261,
  262,  263,  264,   -1,  266,  267,  268,  269,  258,  259,
  260,  261,  262,   -1,   -1,  265,   -1,  267,  268,  269,
   -1,  283,  284,   -1,  286,  123,  288,  289,  126,   -1,
  292,   -1,   -1,  283,   -1,   -1,  298,  299,   -1,   -1,
   -1,   -1,  258,  259,  260,  261,  262,   -1,   -1,   -1,
   -1,  267,  268,  269,   -1,   -1,  318,  319,  320,   -1,
   -1,   -1,   -1,   -1,  326,  257,  258,  283,   -1,  285,
   -1,  263,  264,  126,  266,   -1,   -1,   -1,  270,   -1,
  272,  273,  274,  275,  276,  277,  278,  279,  280,  281,
  282,   -1,  284,   -1,  286,   -1,  288,  289,   -1,   -1,
  292,   41,   -1,   33,   44,   -1,  298,  299,   38,   -1,
   40,   -1,   42,   43,   -1,   45,   -1,   -1,   58,   59,
   -1,   61,   -1,   -1,   -1,  317,  318,  319,  320,  321,
  322,  323,   -1,  325,  326,  293,  294,  295,  296,   -1,
   -1,   -1,  123,   -1,   -1,   -1,  258,   -1,  260,  261,
  262,   -1,   -1,   93,   -1,  267,  268,  269,   -1,  257,
  258,   -1,   -1,   -1,   -1,  263,  264,   -1,  266,   -1,
   -1,  283,  270,  285,  272,  273,  274,  275,  276,  277,
  278,  279,  280,  281,  282,  125,  284,   -1,  286,   -1,
  288,  289,   -1,   -1,  292,   -1,  126,   -1,   -1,   -1,
  298,  299,   -1,   -1,  257,  258,   -1,  260,  261,  262,
  263,  264,   -1,  266,  267,  268,  269,   -1,   -1,  317,
  318,  319,  320,  321,  322,  323,   -1,  325,  326,   -1,
  283,  284,   -1,  286,   -1,  288,  289,   -1,   -1,  292,
   -1,   -1,   -1,   -1,   -1,  298,  299,   -1,  123,   -1,
   33,   -1,   40,   41,   42,   38,   44,   40,   -1,   42,
   43,   -1,   45,   46,   -1,  318,  319,  320,   -1,   -1,
   -1,   59,   -1,  326,   -1,  256,   -1,  258,  259,  260,
  261,  262,   -1,   -1,   -1,   -1,  267,  268,  269,   33,
   -1,   -1,   -1,   -1,   38,   -1,   40,   -1,   42,   43,
   -1,   45,  283,   91,   -1,   -1,   -1,   -1,   91,   -1,
  258,  259,  260,  261,  262,   -1,   -1,   -1,   -1,  267,
  268,  269,   -1,   -1,   -1,  265,   -1,  257,  258,   -1,
  260,  261,  262,  263,  264,  283,  266,  267,  268,  269,
  123,   -1,   -1,  126,   -1,  285,   44,   -1,   -1,   -1,
  290,   -1,   -1,  283,  284,   -1,  286,   -1,  288,  289,
   -1,   59,  292,   61,   -1,   33,   -1,   -1,  298,  299,
   38,   -1,   40,   -1,   42,   43,   -1,   45,   -1,  123,
   -1,   -1,  126,  258,  259,  260,  261,  262,  318,  319,
  320,   -1,  267,  268,  269,   -1,  326,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   33,   -1,   -1,   -1,  283,   38,
   -1,   40,   -1,   42,   43,   -1,   45,   -1,   -1,   -1,
   -1,   37,   38,   -1,   -1,  123,   42,   43,   -1,   45,
   -1,   47,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   58,   -1,   -1,   61,   -1,   63,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  123,   -1,   -1,  126,   -1,
   -1,   -1,   -1,   -1,   93,   -1,   -1,   -1,   -1,  257,
  258,   -1,   -1,  256,  257,  258,   -1,   -1,   94,   33,
  263,  264,   -1,  266,   38,   -1,   40,   -1,   42,   43,
   -1,   45,   -1,   -1,   -1,   -1,   -1,  126,   40,   41,
   42,  284,   44,  286,   -1,  288,  289,   -1,  124,  292,
   -1,   -1,  256,  257,   -1,  298,  299,   59,   33,  263,
  264,   -1,  266,   38,   -1,   40,   -1,   42,   43,   -1,
   45,   -1,   -1,   -1,   -1,  318,  319,  320,   -1,   93,
  284,   -1,  286,  326,  288,  289,   -1,   -1,  292,   91,
   -1,   -1,   -1,   -1,  298,  299,   -1,   -1,  256,   -1,
  258,  259,  260,  261,  262,   -1,   -1,   -1,   -1,  267,
  268,  269,  126,   -1,  318,  319,  320,   -1,   -1,   -1,
   -1,   -1,  326,   -1,   -1,  283,   -1,  285,  256,  257,
   -1,   -1,   33,   -1,   -1,  263,  264,   38,  266,   40,
   -1,   42,   43,   -1,   45,   -1,   -1,   -1,  123,   -1,
   -1,  126,   -1,   -1,   -1,   -1,  284,   -1,  286,   -1,
  288,  289,  623,   -1,  292,   -1,   -1,   -1,  257,   -1,
  298,  299,   -1,   -1,  263,  264,   33,  266,   -1,   -1,
   -1,   38,   -1,   40,   -1,   42,   43,   -1,   45,  265,
  318,  319,  320,   -1,   -1,  284,   -1,  286,  326,  288,
  289,   -1,   -1,  292,   -1,   -1,   -1,   -1,   -1,  298,
  299,   -1,   -1,   -1,  290,  291,  292,  293,  294,  295,
  296,   -1,   -1,   -1,   -1,  126,   -1,  688,   -1,  318,
  319,  320,   -1,   -1,   -1,   33,   93,  326,   -1,   -1,
   38,   -1,   40,  257,   42,   43,   -1,   45,  709,  263,
  264,  712,  266,  714,   -1,  257,  258,   -1,  260,   -1,
   -1,   -1,  723,   -1,   -1,  267,  268,  269,   -1,  126,
  284,   -1,  286,   -1,  288,  289,   -1,   -1,  292,   -1,
   -1,  283,  257,  285,  298,  299,   -1,   -1,  263,  264,
   -1,  266,   -1,   -1,  755,   93,   -1,   40,   41,   42,
   -1,   44,   -1,   -1,  318,  319,  320,   -1,  769,  284,
   -1,  286,  326,  288,  289,   58,   59,  292,   -1,   -1,
   33,   -1,   -1,  298,  299,   38,   -1,   40,  126,   42,
   43,   -1,   45,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  318,  319,  320,   -1,   -1,   -1,   -1,
   -1,  326,   -1,   -1,   -1,  256,  257,   -1,   -1,   -1,
   -1,   -1,  263,  264,   33,  266,   -1,   -1,   -1,   38,
   -1,   40,   -1,   42,   43,   -1,   45,   -1,   -1,   -1,
   93,   -1,  125,  284,   -1,  286,   -1,  288,  289,   -1,
   -1,  292,   -1,   -1,   -1,   -1,   -1,  298,  299,   -1,
  257,   -1,   -1,   -1,   -1,   -1,  263,  264,   -1,  266,
   -1,   -1,   -1,  126,   -1,   -1,   -1,  318,  319,  320,
   -1,   -1,   -1,   -1,   93,  326,   -1,  284,   -1,  286,
   -1,  288,  289,   -1,   -1,  292,   -1,   -1,   33,   -1,
   -1,  298,  299,   38,   -1,   40,   -1,   42,   43,   -1,
   45,   -1,   -1,   -1,   -1,   -1,   -1,  126,   -1,  257,
   -1,  318,  319,  320,   59,  263,  264,   -1,  266,  326,
   -1,  258,  259,  260,  261,  262,   -1,   -1,  265,   -1,
  267,  268,  269,   -1,   -1,   -1,  284,   -1,  286,   -1,
  288,  289,   -1,   -1,  292,   -1,  283,   33,  285,   -1,
  298,  299,   38,   -1,   40,   -1,   42,   43,   -1,   45,
   -1,   -1,   -1,   -1,  257,  258,  259,  260,  261,  262,
  318,  319,  320,   59,  267,  268,  269,   -1,  326,   -1,
   -1,  126,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  283,   -1,  285,   -1,  257,   -1,   -1,   -1,   -1,   -1,
  263,  264,   -1,  266,   -1,   33,   -1,   -1,   -1,   -1,
   38,   -1,   40,   -1,   42,   43,   -1,   45,   -1,   -1,
   -1,  284,   -1,  286,   -1,  288,  289,   -1,   -1,  292,
   -1,   59,   -1,   -1,   -1,  298,  299,   -1,  257,   -1,
  126,   -1,   -1,   -1,  263,  264,   -1,  266,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  318,  319,  320,   -1,   -1,
   -1,   -1,   -1,  326,   -1,  284,   -1,  286,   -1,  288,
  289,   -1,   41,  292,   -1,   44,   33,   -1,   -1,  298,
  299,   38,   -1,   40,   -1,   42,   43,   -1,   45,   58,
   59,   -1,   61,   -1,   63,   -1,   -1,   -1,  126,  318,
  319,  320,   59,   -1,   -1,   -1,   -1,  326,   -1,   -1,
   -1,   -1,  257,   -1,   -1,   -1,   -1,   -1,  263,  264,
   -1,  266,   33,   -1,   93,   94,   -1,   38,   -1,   40,
   -1,   42,   43,   -1,   45,   -1,   -1,   -1,   -1,  284,
   -1,  286,   -1,  288,  289,   -1,   -1,  292,   -1,   -1,
   -1,   -1,   -1,  298,  299,  124,  125,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  126,
   -1,  257,   -1,  318,  319,  320,   -1,  263,  264,   -1,
  266,  326,   93,   -1,   -1,   -1,   -1,   33,   -1,   -1,
   -1,   -1,   38,   -1,   40,   -1,   42,   43,  284,   45,
  286,   -1,  288,  289,   -1,   -1,  292,   -1,   -1,   -1,
   -1,   -1,  298,  299,  256,  126,  258,  259,  260,  261,
  262,   -1,   -1,  265,   -1,  267,  268,  269,   -1,  257,
   -1,   -1,  318,  319,  320,  263,  264,   33,  266,   -1,
  326,  283,   38,  285,   40,   -1,   42,   43,   -1,   45,
   -1,   -1,   -1,   -1,   -1,   -1,  284,   -1,  286,   -1,
  288,  289,   -1,   -1,  292,   -1,   -1,   -1,   -1,   -1,
  298,  299,  256,  257,  258,  259,  260,  261,  262,   -1,
  126,  265,   -1,  267,  268,  269,   -1,   -1,   -1,   -1,
  318,  319,  320,   -1,   -1,   -1,  265,   93,  326,  283,
  257,  285,   -1,   33,   -1,   -1,  263,  264,   38,  266,
   40,   -1,   42,   43,   -1,   45,  285,   -1,   -1,   -1,
   -1,  290,  291,  292,   -1,   -1,   -1,  284,   58,  286,
  126,  288,  289,   -1,   -1,  292,   -1,   -1,   -1,   -1,
   -1,  298,  299,   -1,   -1,   -1,  257,   -1,   -1,   -1,
   -1,   -1,  263,  264,   -1,  266,   -1,   -1,   -1,   -1,
   -1,  318,  319,  320,   -1,   -1,   -1,   -1,   -1,  326,
   -1,   -1,   -1,  284,   -1,  286,   -1,  288,  289,   -1,
   -1,  292,   -1,   -1,   -1,   33,   -1,  298,  299,   -1,
   38,   -1,   40,   -1,   42,   43,  126,   45,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  318,  319,  320,
   -1,  257,   -1,   -1,   -1,  326,   -1,  263,  264,   -1,
  266,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  279,   -1,   -1,   -1,   -1,  284,   -1,
  286,   -1,  288,  289,   -1,   93,  292,   40,   41,   42,
   33,   44,  298,  299,   -1,   38,   -1,   40,   -1,   42,
   43,  257,   45,   -1,   -1,   58,   59,  263,  264,   -1,
  266,   -1,  318,  319,  320,   -1,   -1,   -1,  126,   -1,
  326,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  284,   -1,
  286,   -1,  288,  289,   38,   -1,  292,   41,   91,   33,
   44,   -1,  298,  299,   38,   -1,   40,   -1,   42,   43,
   93,   45,   -1,   -1,   58,   59,   -1,   61,   -1,   63,
   -1,   -1,  318,  319,  320,   -1,   -1,  257,   -1,   -1,
  326,   -1,  125,  263,  264,   -1,  266,   -1,   -1,   -1,
   -1,   -1,   -1,  126,   -1,   -1,   -1,   -1,   -1,   93,
   94,   -1,   -1,   -1,  284,   -1,  286,   -1,  288,  289,
   -1,   -1,  292,   -1,   -1,   33,   -1,   -1,  298,  299,
   38,   -1,   40,   -1,   42,   43,   -1,   45,   -1,   -1,
  124,  125,   -1,   -1,   -1,   -1,   -1,   -1,  318,  319,
  320,   -1,  126,   -1,   -1,   -1,  326,   -1,   -1,   -1,
   -1,   -1,  258,  259,  260,  261,  262,   -1,   -1,  257,
   -1,  267,  268,  269,   33,  263,  264,   -1,  266,   38,
   -1,   40,   -1,   42,   43,   -1,   45,  283,   -1,  285,
   -1,   -1,   -1,   -1,   -1,   -1,  284,   -1,  286,   -1,
  288,  289,   -1,   -1,  292,   -1,   -1,   -1,   -1,   -1,
  298,  299,   -1,   -1,   -1,   -1,   -1,   -1,  126,   -1,
   -1,   -1,   -1,   -1,  257,  258,   -1,   -1,   -1,   -1,
  318,  319,  320,   -1,  257,   -1,   -1,   -1,  326,   33,
  263,  264,   -1,  266,   38,   -1,   40,   -1,   42,   43,
   -1,   45,  285,   -1,   37,   38,   -1,   -1,   -1,   42,
   43,  284,   45,  286,   47,  288,  289,  126,   -1,  292,
   -1,   -1,   -1,   -1,   -1,  298,  299,   -1,   61,   -1,
   63,  265,   -1,  257,   -1,   -1,   -1,   -1,   -1,  263,
  264,   -1,  266,   -1,   -1,  318,  319,  320,   -1,   -1,
   -1,  285,   -1,  326,   -1,   -1,  290,  291,  292,  293,
  284,   94,  286,   -1,  288,  289,   -1,   -1,  292,   -1,
   -1,   33,   -1,   -1,  298,  299,   38,   -1,   40,   -1,
   42,   43,  126,   45,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  124,   -1,   -1,  318,  319,  320,   -1,   -1,  257,
   -1,   -1,  326,   -1,   -1,  263,  264,   -1,  266,   -1,
   33,   -1,   -1,   -1,   -1,   38,   -1,   40,   -1,   42,
   43,   -1,   45,   -1,   -1,   -1,  284,   -1,  286,   -1,
  288,  289,   -1,   -1,  292,   -1,   -1,   -1,   -1,   -1,
  298,  299,   -1,   -1,   -1,   -1,   -1,   -1,  257,   -1,
   -1,   -1,   -1,   -1,  263,  264,   -1,  266,   -1,   -1,
  318,  319,  320,   -1,  126,   -1,   37,   38,  326,   -1,
   -1,   42,   43,   -1,   45,  284,   47,  286,   -1,  288,
  289,   -1,   -1,  292,   -1,   -1,   33,   -1,   -1,  298,
  299,   38,   63,   40,   -1,   42,   43,   -1,   45,   -1,
   -1,   -1,   -1,  126,   -1,   -1,   -1,   -1,   -1,  318,
  319,  320,   -1,  257,   -1,   -1,   -1,  326,   -1,  263,
  264,   -1,  266,   94,   -1,   33,   -1,   -1,   -1,   -1,
   38,   -1,   40,   -1,   42,   43,   -1,   45,   -1,   -1,
  284,   -1,  286,   -1,  288,  289,   -1,   -1,  292,   -1,
   -1,   -1,  285,  124,  298,  299,   -1,  290,  291,  292,
  293,  294,  295,  296,   -1,   -1,   -1,   -1,   40,   41,
   42,   -1,   44,   -1,  318,  319,  320,   -1,   -1,  126,
   -1,   -1,  326,   -1,   -1,   -1,   58,   59,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  257,   -1,   -1,   -1,   -1,
   -1,  263,  264,   -1,  266,   37,   38,   -1,   40,   -1,
   42,   43,   -1,   45,   46,   47,   -1,   -1,  126,   91,
   -1,   -1,  284,   -1,  286,   -1,  288,  289,   -1,   61,
  292,   63,   -1,   -1,  257,   -1,  298,  299,   -1,   -1,
  263,  264,   -1,  266,   37,   38,   -1,   -1,   -1,   42,
   43,   -1,   45,  125,   47,   -1,  318,  319,  320,   91,
   -1,  284,   94,  286,  326,  288,  289,   -1,   61,  292,
   63,   -1,   -1,   -1,   -1,  298,  299,   -1,   37,   38,
   -1,   40,   41,   42,   43,   44,   45,   46,   47,   -1,
   -1,   -1,  124,   -1,   -1,  318,  319,  320,   -1,   58,
   59,   94,   61,  326,   63,   -1,   -1,   -1,   -1,   -1,
  257,   -1,   -1,   -1,   -1,   -1,  263,  264,   -1,  266,
  291,  292,  293,  294,  295,  296,   -1,   -1,   -1,   -1,
   -1,  124,   91,   -1,   93,   94,   -1,  284,   -1,  286,
   -1,  288,  289,   -1,   -1,  292,   -1,   -1,   -1,  257,
   -1,  298,  299,   -1,   -1,  263,  264,   -1,  266,   -1,
   -1,   -1,   -1,   -1,   -1,  124,  125,   -1,   -1,   -1,
   -1,  318,  319,  320,   -1,   -1,  284,   -1,  286,  326,
  288,  289,   -1,   -1,  292,  257,  258,   -1,   -1,   -1,
  298,  299,   44,   37,   38,   -1,   40,   -1,   42,   43,
   44,   45,   46,   47,   -1,   -1,   -1,   59,   -1,   61,
  318,  319,  320,  285,   58,   59,   -1,   61,  326,   63,
   37,   38,   -1,   -1,   -1,   42,   43,   -1,   45,   -1,
   47,   37,   38,   -1,   -1,   -1,   42,   43,   -1,   45,
   -1,   47,   -1,   -1,   61,   -1,   63,   91,   -1,   -1,
   94,   -1,   58,   -1,   -1,   61,   -1,   63,  290,  291,
  292,  293,  294,  295,  296,   -1,  298,  299,   -1,  301,
   -1,  123,   -1,   -1,   -1,   -1,   93,   94,   -1,   -1,
  124,  125,   -1,   -1,   -1,   -1,   -1,   -1,   94,   38,
   -1,   -1,   41,   -1,   43,   44,   45,  290,  291,  292,
  293,  294,  295,  296,   -1,   41,  265,  124,   44,   58,
   59,   -1,   61,   -1,   63,   -1,   -1,   -1,  124,   -1,
   -1,   -1,   58,   59,   -1,   61,  285,   63,   -1,   -1,
   -1,  290,  291,  292,  293,  294,  295,  296,   -1,  298,
  299,   -1,  301,   38,   93,   94,   41,   -1,   43,   44,
   45,   -1,   -1,   -1,   -1,   -1,   -1,   93,   -1,   -1,
   -1,   -1,   -1,   58,   59,   -1,   61,   -1,   63,   -1,
   -1,   -1,   -1,   -1,   -1,  124,  125,   -1,   -1,   -1,
   38,   -1,   -1,   41,   -1,   -1,   44,   -1,  124,  125,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   93,   94,
   58,   59,   -1,   61,  256,   63,  258,  259,  260,  261,
  262,   -1,   -1,   -1,   -1,  267,  268,  269,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  124,
  125,  283,   -1,  285,   -1,   93,   94,   -1,   38,   -1,
   -1,   41,   -1,   -1,   44,   -1,  290,  291,  292,  293,
  294,  295,  296,   -1,  298,  299,   -1,  301,   58,   59,
   -1,   61,   -1,   63,   -1,   -1,  124,  125,   -1,   -1,
   -1,   -1,   -1,  290,  291,  292,  293,  294,  295,  296,
   -1,   -1,   -1,   -1,  290,  291,  292,  293,  294,  295,
  296,   -1,   -1,   93,   94,   -1,   -1,   38,   -1,   -1,
   41,   -1,   -1,   44,   -1,   -1,   -1,   38,   -1,   -1,
   41,   -1,   -1,   44,   -1,   -1,  265,   58,   59,   -1,
   61,   -1,   63,   -1,  124,  125,   -1,   58,   59,  265,
   61,   -1,   63,   -1,   -1,   -1,  285,   -1,   -1,   -1,
   -1,  290,  291,  292,  293,  294,  295,  296,   -1,  285,
   -1,   -1,   93,   94,  290,  291,  292,   40,   41,   42,
   -1,   44,   93,   94,   -1,   -1,   -1,   -1,   -1,   -1,
  265,   -1,   -1,   -1,   -1,   58,   59,   -1,   -1,   -1,
   -1,   -1,   -1,  124,  125,   -1,   -1,   -1,   -1,   -1,
  285,   -1,   -1,  124,  125,  290,  291,  292,  293,  294,
  295,  296,   40,   41,   42,   -1,   44,  265,   91,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   58,   59,   40,   41,   42,   -1,   44,  285,   -1,   -1,
   -1,   -1,  290,  291,  292,  293,  294,  295,  296,   -1,
   58,   59,  125,   40,   41,   42,   -1,   44,   -1,   -1,
   -1,   -1,   -1,   91,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   58,   59,   41,   -1,  265,   44,   -1,   -1,   -1,
   -1,   -1,   -1,   91,   -1,   -1,   -1,   -1,   -1,   -1,
   58,   59,   -1,   61,   -1,  285,   -1,  125,   -1,   -1,
  290,  291,  292,  293,  294,  295,  296,   -1,   41,   -1,
   -1,   44,   -1,   -1,   -1,   -1,   -1,  125,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   58,   59,   -1,   61,   -1,
   -1,   -1,   -1,   -1,  265,   -1,   -1,   -1,  125,   -1,
   -1,   -1,   -1,   -1,  265,   -1,   -1,   -1,   40,   41,
   42,   -1,   44,   -1,  285,  123,   -1,  125,   -1,  290,
  291,  292,  293,  294,  285,   -1,   -1,   59,   -1,  290,
  291,  292,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   41,   -1,   -1,   44,  257,  258,  259,  260,  261,  262,
  123,   -1,  125,   -1,  267,  268,  269,   58,   59,   91,
   61,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  285,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   41,   -1,   -1,   44,  257,
  258,  259,  260,  261,  262,   -1,   -1,   -1,   -1,  267,
  268,  269,   58,   59,   -1,   61,   -1,   -1,   -1,  257,
  258,  259,  260,  261,  262,   -1,   -1,  285,   -1,  267,
  268,  269,  123,   -1,  125,   40,   41,   42,   -1,   44,
  257,  258,  259,  260,  261,  262,   -1,  285,   -1,   -1,
  267,  268,  269,   -1,   59,   -1,   -1,   -1,  256,   -1,
  258,  259,  260,  261,  262,   -1,   -1,   -1,  285,  267,
  268,  269,   -1,   -1,   44,   -1,   -1,  123,   -1,  125,
   -1,   -1,   -1,   -1,  282,  283,   91,  285,   58,   59,
   -1,   61,   -1,  256,   -1,  258,  259,  260,  261,  262,
   -1,   -1,   -1,   -1,  267,  268,  269,   -1,   -1,   44,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  282,
  283,   -1,  285,   58,   59,   -1,   61,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  257,  258,  259,  260,  261,
  262,   44,   -1,   -1,   -1,  267,  268,  269,   -1,   -1,
   -1,   -1,   -1,  123,   -1,  125,   59,   -1,   61,   -1,
   -1,  283,   -1,   -1,   -1,  256,   -1,  258,  259,  260,
  261,  262,   44,   -1,   -1,   -1,  267,  268,  269,   -1,
   -1,   40,   41,   42,   -1,   44,   -1,   59,  123,   61,
  125,  282,  283,   -1,  285,   -1,   -1,   -1,   -1,   58,
   59,   -1,   44,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  256,   -1,  258,  259,  260,  261,  262,   59,   -1,   61,
  123,  267,  268,  269,   -1,   -1,   -1,   -1,   -1,   40,
   41,   42,   91,   44,   -1,   -1,  282,  283,   -1,  285,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   59,   -1,
   -1,  123,  257,  258,  259,  260,  261,  262,   -1,   -1,
   -1,   -1,  267,  268,  269,   59,  125,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  283,   -1,
   91,  123,   -1,   -1,   -1,   -1,  256,   -1,  258,  259,
  260,  261,  262,   -1,   -1,   -1,   -1,  267,  268,  269,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  282,  283,   -1,  285,   -1,   -1,   -1,   -1,
   -1,  256,   -1,  258,  259,  260,  261,  262,   -1,   -1,
   -1,   -1,  267,  268,  269,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  282,  283,   -1,
  285,   -1,   -1,   -1,   -1,  258,  259,  260,  261,  262,
   -1,   -1,   -1,   -1,  267,  268,  269,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  283,   -1,  285,   -1,   -1,   -1,  258,  259,  260,  261,
  262,   -1,   -1,   -1,   -1,  267,  268,  269,  257,  258,
  259,  260,  261,  262,   -1,   -1,   -1,   -1,  267,  268,
  269,  283,   -1,  285,   -1,   -1,  258,  259,  260,  261,
  262,   -1,   -1,   -1,   -1,  267,  268,  269,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  283,   -1,  285,   -1,   -1,  257,  258,  259,  260,
  261,  262,   -1,   -1,   -1,   -1,  267,  268,  269,   -1,
   -1,   -1,  256,   -1,  258,  259,  260,  261,  262,   -1,
   -1,   -1,   -1,  267,  268,  269,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  282,  283,
   -1,  285,  286,
};
#define YYFINAL 1
#ifndef YYDEBUG
#define YYDEBUG 0
#endif
#define YYMAXTOKEN 326
#if YYDEBUG
const char * const yyname[] = {
"end-of-file",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
"'!'",0,0,0,"'%'","'&'",0,"'('","')'","'*'","'+'","','","'-'","'.'","'/'",0,0,0,
0,0,0,0,0,0,0,"':'","';'",0,"'='",0,"'?'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,"'['",0,"']'","'^'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,"'{'","'|'","'}'","'~'",0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,"IDENTIFIER","TYPENAME",
"SCSPEC","TYPESPEC","TYPE_QUAL","TYPE_QUAL_S","CONSTANT","STRING","ELLIPSIS",
"SIZEOF","ENUM","STRUCT","UNION","IF","ELSE","WHILE","DO","FOR","SWITCH","CASE",
"DEFAULT","BREAK","CONTINUE","RETURN","GOTO","ASM_KEYWORD","TYPEOF","ALIGNOF",
"ATTRIBUTE","EXTENSION","LABEL","REALPART","IMAGPART","ASSIGN","OROR","ANDAND",
"EQCOMPARE","ARITHCOMPARE","LSHIFT","RSHIFT","UNARY","PLUSPLUS","MINUSMINUS",
"HYPERUNARY","POINTSAT","INTERFACE","IMPLEMENTATION","END","SELECTOR","DEFS",
"ENCODE","CLASSNAME","PUBLIC","PRIVATE","PROTECTED","PROTOCOL","OBJECTNAME",
"CLASS","ALIAS","OBJC_STRING","FORALL","UPC_BLOCKSIZEOF","UPC_LOCALSIZEOF",
"UPC_ELEMSIZEOF","UPC_BARRIER","UPC_NOTIFY","UPC_WAIT","END_OF_LINE",
"UPC_FENCE","BUPC_ASSERT_TYPE",
};
const char * const yyrule[] = {
"$accept : program",
"program :",
"program : extdefs",
"$$1 :",
"extdefs : $$1 extdef",
"$$2 :",
"extdefs : extdefs $$2 extdef",
"extdef : fndef",
"extdef : datadef",
"extdef : ASM_KEYWORD '(' expr ')' ';'",
"extdef : extension extdef",
"datadef : setspecs notype_initdecls ';'",
"datadef : declmods setspecs notype_initdecls ';'",
"datadef : typed_declspecs setspecs initdecls ';'",
"datadef : declmods ';'",
"datadef : typed_declspecs ';'",
"datadef : error ';'",
"datadef : error '}'",
"datadef : ';'",
"$$3 :",
"$$4 :",
"fndef : typed_declspecs setspecs declarator $$3 old_style_parm_decls $$4 compstmt_or_error",
"fndef : typed_declspecs setspecs declarator error",
"$$5 :",
"$$6 :",
"fndef : declmods setspecs notype_declarator $$5 old_style_parm_decls $$6 compstmt_or_error",
"fndef : declmods setspecs notype_declarator error",
"$$7 :",
"$$8 :",
"fndef : setspecs notype_declarator $$7 old_style_parm_decls $$8 compstmt_or_error",
"fndef : setspecs notype_declarator error",
"identifier : IDENTIFIER",
"identifier : TYPENAME",
"unop : '&'",
"unop : '-'",
"unop : '+'",
"unop : PLUSPLUS",
"unop : MINUSMINUS",
"unop : '~'",
"unop : '!'",
"expr : nonnull_exprlist",
"exprlist :",
"exprlist : nonnull_exprlist",
"nonnull_exprlist : expr_no_commas",
"nonnull_exprlist : nonnull_exprlist ',' expr_no_commas",
"unary_expr : primary",
"unary_expr : '*' cast_expr",
"unary_expr : extension cast_expr",
"unary_expr : unop cast_expr",
"unary_expr : ANDAND identifier",
"unary_expr : sizeof unary_expr",
"unary_expr : sizeof '(' typename ')'",
"unary_expr : upc_blocksizeof unary_expr",
"unary_expr : upc_blocksizeof '(' typename ')'",
"unary_expr : upc_localsizeof unary_expr",
"unary_expr : upc_localsizeof '(' typename ')'",
"unary_expr : upc_elemsizeof unary_expr",
"unary_expr : upc_elemsizeof '(' typename ')'",
"unary_expr : alignof unary_expr",
"unary_expr : alignof '(' typename ')'",
"unary_expr : REALPART cast_expr",
"unary_expr : IMAGPART cast_expr",
"upc_blocksizeof : UPC_BLOCKSIZEOF",
"upc_localsizeof : UPC_LOCALSIZEOF",
"upc_elemsizeof : UPC_ELEMSIZEOF",
"bupc_assert_type : BUPC_ASSERT_TYPE",
"sizeof : SIZEOF",
"alignof : ALIGNOF",
"cast_expr : unary_expr",
"cast_expr : '(' typename ')' cast_expr",
"$$9 :",
"cast_expr : '(' typename ')' '{' $$9 initlist_maybe_comma '}'",
"expr_no_commas : cast_expr",
"expr_no_commas : expr_no_commas '+' expr_no_commas",
"expr_no_commas : expr_no_commas '-' expr_no_commas",
"expr_no_commas : expr_no_commas '*' expr_no_commas",
"expr_no_commas : expr_no_commas '/' expr_no_commas",
"expr_no_commas : expr_no_commas '%' expr_no_commas",
"expr_no_commas : expr_no_commas LSHIFT expr_no_commas",
"expr_no_commas : expr_no_commas RSHIFT expr_no_commas",
"expr_no_commas : expr_no_commas ARITHCOMPARE expr_no_commas",
"expr_no_commas : expr_no_commas EQCOMPARE expr_no_commas",
"expr_no_commas : expr_no_commas '&' expr_no_commas",
"expr_no_commas : expr_no_commas '|' expr_no_commas",
"expr_no_commas : expr_no_commas '^' expr_no_commas",
"$$10 :",
"expr_no_commas : expr_no_commas ANDAND $$10 expr_no_commas",
"$$11 :",
"expr_no_commas : expr_no_commas OROR $$11 expr_no_commas",
"$$12 :",
"$$13 :",
"expr_no_commas : expr_no_commas '?' $$12 expr ':' $$13 expr_no_commas",
"$$14 :",
"expr_no_commas : expr_no_commas '?' $$14 ':' expr_no_commas",
"expr_no_commas : expr_no_commas '=' expr_no_commas",
"expr_no_commas : expr_no_commas ASSIGN expr_no_commas",
"primary : IDENTIFIER",
"primary : CONSTANT",
"primary : string",
"primary : '(' expr ')'",
"primary : '(' error ')'",
"$$15 :",
"primary : '(' $$15 compstmt ')'",
"primary : bupc_assert_type '(' typename ',' typename ')'",
"primary : bupc_assert_type '(' typename ',' unary_expr ')'",
"primary : bupc_assert_type '(' unary_expr ',' typename ')'",
"primary : bupc_assert_type '(' unary_expr ',' unary_expr ')'",
"primary : primary '(' exprlist ')'",
"primary : primary '[' expr ']'",
"primary : primary '.' identifier",
"primary : primary POINTSAT identifier",
"primary : primary PLUSPLUS",
"primary : primary MINUSMINUS",
"string : STRING",
"string : string STRING",
"old_style_parm_decls :",
"old_style_parm_decls : datadecls",
"old_style_parm_decls : datadecls ELLIPSIS",
"lineno_datadecl : save_filename save_lineno datadecl",
"datadecls : lineno_datadecl",
"datadecls : errstmt",
"datadecls : datadecls lineno_datadecl",
"datadecls : lineno_datadecl errstmt",
"datadecl : typed_declspecs_no_prefix_attr setspecs initdecls ';'",
"datadecl : declmods_no_prefix_attr setspecs notype_initdecls ';'",
"datadecl : typed_declspecs_no_prefix_attr ';'",
"datadecl : declmods_no_prefix_attr ';'",
"setspecs :",
"setattrs :",
"decl : typed_declspecs setspecs initdecls ';'",
"decl : declmods setspecs notype_initdecls ';'",
"decl : typed_declspecs setspecs nested_function",
"decl : declmods setspecs notype_nested_function",
"decl : typed_declspecs ';'",
"decl : declmods ';'",
"decl : extension decl",
"typed_declspecs : typespec reserved_declspecs",
"typed_declspecs : declmods typespec reserved_declspecs",
"reserved_declspecs :",
"reserved_declspecs : reserved_declspecs typespecqual_reserved",
"reserved_declspecs : reserved_declspecs SCSPEC",
"reserved_declspecs : reserved_declspecs attributes",
"typed_declspecs_no_prefix_attr : typespec reserved_declspecs_no_prefix_attr",
"typed_declspecs_no_prefix_attr : declmods_no_prefix_attr typespec reserved_declspecs_no_prefix_attr",
"reserved_declspecs_no_prefix_attr :",
"reserved_declspecs_no_prefix_attr : reserved_declspecs_no_prefix_attr typespecqual_reserved",
"reserved_declspecs_no_prefix_attr : reserved_declspecs_no_prefix_attr SCSPEC",
"declmods : declmods_no_prefix_attr",
"declmods : attributes",
"declmods : declmods declmods_no_prefix_attr",
"declmods : declmods attributes",
"declmods_no_prefix_attr : type_qualifier",
"declmods_no_prefix_attr : SCSPEC",
"declmods_no_prefix_attr : declmods_no_prefix_attr type_qualifier",
"declmods_no_prefix_attr : declmods_no_prefix_attr SCSPEC",
"type_qualifier : TYPE_QUAL",
"type_qualifier : TYPE_QUAL_S",
"type_qualifier : TYPE_QUAL_S layout_specifier",
"typed_typespecs : typespec reserved_typespecquals",
"typed_typespecs : nonempty_type_quals typespec reserved_typespecquals",
"layout_specifier : '[' xexpr ']'",
"reserved_typespecquals :",
"reserved_typespecquals : reserved_typespecquals typespecqual_reserved",
"typespec : TYPESPEC",
"typespec : structsp",
"typespec : TYPENAME",
"typespec : TYPEOF '(' expr ')'",
"typespec : TYPEOF '(' typename ')'",
"typespecqual_reserved : TYPESPEC",
"typespecqual_reserved : TYPE_QUAL",
"typespecqual_reserved : TYPE_QUAL_S",
"typespecqual_reserved : TYPE_QUAL_S layout_specifier",
"typespecqual_reserved : structsp",
"initdecls : initdcl",
"initdecls : initdecls ',' initdcl",
"notype_initdecls : notype_initdcl",
"notype_initdecls : notype_initdecls ',' initdcl",
"maybeasm :",
"maybeasm : ASM_KEYWORD '(' string ')'",
"$$16 :",
"initdcl : declarator maybeasm maybe_attribute '=' $$16 init",
"initdcl : declarator maybeasm maybe_attribute",
"$$17 :",
"notype_initdcl : notype_declarator maybeasm maybe_attribute '=' $$17 init",
"notype_initdcl : notype_declarator maybeasm maybe_attribute",
"maybe_attribute :",
"maybe_attribute : attributes",
"attributes : attribute",
"attributes : attributes attribute",
"attribute : ATTRIBUTE '(' '(' attribute_list ')' ')'",
"attribute_list : attrib",
"attribute_list : attribute_list ',' attrib",
"attrib :",
"attrib : any_word",
"attrib : any_word '(' IDENTIFIER ')'",
"$$18 :",
"$$19 :",
"attrib : any_word '(' IDENTIFIER ',' $$18 nonnull_exprlist $$19 ')'",
"attrib : any_word '(' exprlist ')'",
"any_word : identifier",
"any_word : SCSPEC",
"any_word : TYPESPEC",
"any_word : TYPE_QUAL",
"any_word : TYPE_QUAL_S",
"init : expr_no_commas",
"$$20 :",
"init : '{' $$20 initlist_maybe_comma '}'",
"init : error",
"initlist_maybe_comma :",
"initlist_maybe_comma : initlist1 maybecomma",
"initlist1 : initelt",
"initlist1 : initlist1 ',' initelt",
"initelt : designator_list '=' initval",
"initelt : designator initval",
"$$21 :",
"initelt : identifier ':' $$21 initval",
"initelt : initval",
"$$22 :",
"initval : '{' $$22 initlist_maybe_comma '}'",
"initval : expr_no_commas",
"initval : error",
"designator_list : designator",
"designator_list : designator_list designator",
"designator : '.' identifier",
"designator : '[' expr_no_commas ELLIPSIS expr_no_commas ']'",
"designator : '[' expr_no_commas ']'",
"$$23 :",
"$$24 :",
"nested_function : declarator $$23 old_style_parm_decls $$24 compstmt",
"$$25 :",
"$$26 :",
"notype_nested_function : notype_declarator $$25 old_style_parm_decls $$26 compstmt",
"declarator : after_type_declarator",
"declarator : notype_declarator",
"after_type_declarator : '(' after_type_declarator ')'",
"after_type_declarator : after_type_declarator '(' parmlist_or_identifiers",
"after_type_declarator : after_type_declarator '[' expr ']'",
"after_type_declarator : after_type_declarator '[' ']'",
"after_type_declarator : '*' type_quals after_type_declarator",
"after_type_declarator : attributes setattrs after_type_declarator",
"after_type_declarator : TYPENAME",
"maybe_type_qualifier_list :",
"maybe_type_qualifier_list : SCSPEC type_qualifier_list",
"maybe_type_qualifier_list : type_qualifier_list SCSPEC",
"maybe_type_qualifier_list : type_qualifier_list",
"type_qualifier_list : TYPE_QUAL",
"type_qualifier_list : type_qualifier_list TYPE_QUAL",
"parm_declarator : parm_declarator '(' parmlist_or_identifiers",
"parm_declarator : parm_declarator '[' maybe_type_qualifier_list '*' ']'",
"parm_declarator : parm_declarator '[' maybe_type_qualifier_list expr ']'",
"parm_declarator : parm_declarator '[' maybe_type_qualifier_list ']'",
"parm_declarator : '*' type_quals parm_declarator",
"parm_declarator : attributes setattrs parm_declarator",
"parm_declarator : TYPENAME",
"notype_declarator : notype_declarator '(' parmlist_or_identifiers",
"notype_declarator : '(' notype_declarator ')'",
"notype_declarator : '*' type_quals notype_declarator",
"notype_declarator : notype_declarator '[' maybe_type_qualifier_list '*' ']'",
"notype_declarator : notype_declarator '[' maybe_type_qualifier_list expr ']'",
"notype_declarator : notype_declarator '[' maybe_type_qualifier_list ']'",
"notype_declarator : attributes setattrs notype_declarator",
"notype_declarator : IDENTIFIER",
"struct_head : STRUCT",
"struct_head : STRUCT attributes",
"union_head : UNION",
"union_head : UNION attributes",
"enum_head : ENUM",
"enum_head : ENUM attributes",
"$$27 :",
"structsp : struct_head identifier '{' $$27 component_decl_list '}' maybe_attribute",
"structsp : struct_head '{' component_decl_list '}' maybe_attribute",
"structsp : struct_head identifier",
"$$28 :",
"structsp : union_head identifier '{' $$28 component_decl_list '}' maybe_attribute",
"structsp : union_head '{' component_decl_list '}' maybe_attribute",
"structsp : union_head identifier",
"$$29 :",
"structsp : enum_head identifier '{' $$29 enumlist maybecomma_warn '}' maybe_attribute",
"$$30 :",
"structsp : enum_head '{' $$30 enumlist maybecomma_warn '}' maybe_attribute",
"structsp : enum_head identifier",
"maybecomma :",
"maybecomma : ','",
"maybecomma_warn :",
"maybecomma_warn : ','",
"component_decl_list : component_decl_list2",
"component_decl_list : component_decl_list2 component_decl",
"component_decl_list2 :",
"component_decl_list2 : component_decl_list2 component_decl ';'",
"component_decl_list2 : component_decl_list2 ';'",
"component_decl : typed_typespecs setspecs components",
"component_decl : typed_typespecs",
"component_decl : nonempty_type_quals setspecs components",
"component_decl : nonempty_type_quals",
"component_decl : error",
"component_decl : extension component_decl",
"components : component_declarator",
"components : components ',' component_declarator",
"component_declarator : save_filename save_lineno declarator maybe_attribute",
"component_declarator : save_filename save_lineno declarator ':' expr_no_commas maybe_attribute",
"component_declarator : save_filename save_lineno ':' expr_no_commas maybe_attribute",
"enumlist : enumerator",
"enumlist : enumlist ',' enumerator",
"enumlist : error",
"enumerator : identifier maybe_attribute",
"enumerator : identifier maybe_attribute '=' expr_no_commas",
"typename : typed_typespecs absdcl",
"typename : nonempty_type_quals absdcl",
"absdcl :",
"absdcl : absdcl1",
"nonempty_type_quals : type_qualifier",
"nonempty_type_quals : nonempty_type_quals type_qualifier",
"type_quals :",
"type_quals : type_quals type_qualifier",
"absdcl1 : '(' absdcl1 ')'",
"absdcl1 : '*' type_quals absdcl1",
"absdcl1 : '*' type_quals",
"absdcl1 : absdcl1 '(' parmlist",
"absdcl1 : absdcl1 '[' maybe_type_qualifier_list expr ']'",
"absdcl1 : absdcl1 '[' maybe_type_qualifier_list ']'",
"absdcl1 : '(' parmlist",
"absdcl1 : '[' maybe_type_qualifier_list expr ']'",
"absdcl1 : '[' maybe_type_qualifier_list ']'",
"absdcl1 : attributes setattrs absdcl1",
"stmts : lineno_stmt_or_labels",
"lineno_stmt_or_labels : lineno_stmt_or_label",
"lineno_stmt_or_labels : lineno_stmt_or_labels lineno_stmt_or_label",
"lineno_stmt_or_labels : lineno_stmt_or_labels errstmt",
"errstmt : error ';'",
"pushlevel :",
"maybe_label_decls :",
"maybe_label_decls : label_decls",
"label_decls : label_decl",
"label_decls : label_decls label_decl",
"label_decl : LABEL identifiers_or_typenames ';'",
"compstmt_or_error : compstmt",
"compstmt_or_error : error compstmt",
"compstmt_start : '{'",
"compstmt : compstmt_start '}'",
"compstmt : compstmt_start pushlevel maybe_label_decls error '}'",
"compstmt : compstmt_start pushlevel maybe_label_decls stmts '}'",
"simple_if : if_prefix lineno_labeled_stmt",
"simple_if : if_prefix error",
"if_prefix : IF '(' expr ')'",
"$$31 :",
"do_stmt_start : DO $$31 lineno_labeled_stmt WHILE",
"save_filename :",
"save_lineno :",
"lineno_labeled_stmt : save_filename save_lineno stmt",
"lineno_labeled_stmt : save_filename save_lineno label lineno_labeled_stmt",
"lineno_stmt_or_label : save_filename save_lineno stmt_or_label",
"stmt_or_label : stmt",
"stmt_or_label : label",
"stmt_or_label : decl",
"stmt : compstmt",
"stmt : all_iter_stmt",
"stmt : expr ';'",
"$$32 :",
"stmt : simple_if ELSE $$32 lineno_labeled_stmt",
"stmt : simple_if",
"stmt : simple_if ELSE error",
"$$33 :",
"$$34 :",
"stmt : WHILE $$33 '(' expr ')' $$34 lineno_labeled_stmt",
"stmt : do_stmt_start '(' expr ')' ';'",
"stmt : do_stmt_start error",
"$$35 :",
"$$36 :",
"$$37 :",
"stmt : FOR '(' for_init_stmt $$35 xexpr ';' $$36 xexpr ')' $$37 lineno_labeled_stmt",
"$$38 :",
"$$39 :",
"$$40 :",
"$$41 :",
"stmt : FORALL '(' for_init_stmt $$38 xexpr ';' $$39 xexpr ';' $$40 affinity_expr ')' $$41 lineno_labeled_stmt",
"$$42 :",
"stmt : SWITCH '(' expr ')' $$42 lineno_labeled_stmt",
"stmt : BREAK ';'",
"stmt : CONTINUE ';'",
"stmt : RETURN ';'",
"stmt : RETURN expr ';'",
"stmt : UPC_NOTIFY ';'",
"stmt : UPC_FENCE ';'",
"stmt : UPC_NOTIFY expr ';'",
"stmt : UPC_WAIT ';'",
"stmt : UPC_WAIT expr ';'",
"stmt : UPC_BARRIER ';'",
"stmt : UPC_BARRIER expr ';'",
"stmt : ASM_KEYWORD maybe_type_qual '(' expr ')' ';'",
"stmt : ASM_KEYWORD maybe_type_qual '(' expr ':' asm_operands ')' ';'",
"stmt : ASM_KEYWORD maybe_type_qual '(' expr ':' asm_operands ':' asm_operands ')' ';'",
"stmt : ASM_KEYWORD maybe_type_qual '(' expr ':' asm_operands ':' asm_operands ':' asm_clobbers ')' ';'",
"stmt : GOTO identifier ';'",
"stmt : GOTO '*' expr ';'",
"stmt : ';'",
"for_pushlevel :",
"for_init_stmt : xexpr ';'",
"for_init_stmt : for_pushlevel lineno_datadecl",
"affinity_expr : xexpr",
"affinity_expr : CONTINUE",
"all_iter_stmt : all_iter_stmt_simple",
"$$43 :",
"all_iter_stmt_simple : FOR '(' primary ')' $$43 lineno_labeled_stmt",
"label : CASE expr_no_commas ':'",
"label : CASE expr_no_commas ELLIPSIS expr_no_commas ':'",
"label : DEFAULT ':'",
"label : identifier ':' maybe_attribute",
"maybe_type_qual :",
"maybe_type_qual : TYPE_QUAL",
"xexpr :",
"xexpr : expr",
"xexpr : '*'",
"asm_operands :",
"asm_operands : nonnull_asm_operands",
"nonnull_asm_operands : asm_operand",
"nonnull_asm_operands : nonnull_asm_operands ',' asm_operand",
"asm_operand : STRING '(' expr ')'",
"asm_clobbers : string",
"asm_clobbers : asm_clobbers ',' string",
"$$44 :",
"parmlist : $$44 parmlist_1",
"parmlist_1 : parmlist_2 ')'",
"$$45 :",
"parmlist_1 : parms ';' $$45 parmlist_1",
"parmlist_1 : error ')'",
"parmlist_2 :",
"parmlist_2 : ELLIPSIS",
"parmlist_2 : parms",
"parmlist_2 : parms ',' ELLIPSIS",
"parms : parm",
"parms : parms ',' parm",
"parm : typed_declspecs setspecs parm_declarator maybe_attribute",
"parm : typed_declspecs setspecs notype_declarator maybe_attribute",
"parm : typed_declspecs setspecs absdcl maybe_attribute",
"parm : declmods setspecs notype_declarator maybe_attribute",
"parm : declmods setspecs absdcl maybe_attribute",
"$$46 :",
"parmlist_or_identifiers : $$46 parmlist_or_identifiers_1",
"parmlist_or_identifiers_1 : parmlist_1",
"parmlist_or_identifiers_1 : identifiers ')'",
"identifiers : IDENTIFIER",
"identifiers : identifiers ',' IDENTIFIER",
"identifiers_or_typenames : identifier",
"identifiers_or_typenames : identifiers_or_typenames ',' identifier",
"extension : EXTENSION",
};
#endif
#if YYDEBUG
#include <stdio.h>
#endif
#ifdef YYSTACKSIZE
#undef YYMAXDEPTH
#define YYMAXDEPTH YYSTACKSIZE
#else
#ifdef YYMAXDEPTH
#define YYSTACKSIZE YYMAXDEPTH
#else
#define YYSTACKSIZE 10000
#define YYMAXDEPTH 10000
#endif
#endif
#define YYINITSTACKSIZE 200
int yydebug;
int yynerrs;
int yyerrflag;
int yychar;
short *yyssp;
YYSTYPE *yyvsp;
YYSTYPE yyval;
YYSTYPE yylval;
short *yyss;
short *yysslim;
YYSTYPE *yyvs;
int yystacksize;
/* allocate initial stack or double stack size, up to YYMAXDEPTH */
static int yygrowstack()
{
    int newsize, i;
    short *newss;
    YYSTYPE *newvs;

    if ((newsize = yystacksize) == 0)
        newsize = YYINITSTACKSIZE;
    else if (newsize >= YYMAXDEPTH)
        return -1;
    else if ((newsize *= 2) > YYMAXDEPTH)
        newsize = YYMAXDEPTH;
    i = yyssp - yyss;
    newss = yyss ? (short *)realloc(yyss, newsize * sizeof *newss) :
      (short *)malloc(newsize * sizeof *newss);
    if (newss == NULL)
        return -1;
    yyss = newss;
    yyssp = newss + i;
    newvs = yyvs ? (YYSTYPE *)realloc(yyvs, newsize * sizeof *newvs) :
      (YYSTYPE *)malloc(newsize * sizeof *newvs);
    if (newvs == NULL)
        return -1;
    yyvs = newvs;
    yyvsp = newvs + i;
    yystacksize = newsize;
    yysslim = yyss + newsize - 1;
    return 0;
}

#define YYABORT goto yyabort
#define YYREJECT goto yyabort
#define YYACCEPT goto yyaccept
#define YYERROR goto yyerrlab

#ifndef YYPARSE_PARAM
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG void
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif	/* ANSI-C/C++ */
#else	/* YYPARSE_PARAM */
#ifndef YYPARSE_PARAM_TYPE
#define YYPARSE_PARAM_TYPE void *
#endif
#if defined(__cplusplus) || __STDC__
#define YYPARSE_PARAM_ARG YYPARSE_PARAM_TYPE YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else	/* ! ANSI-C/C++ */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL YYPARSE_PARAM_TYPE YYPARSE_PARAM;
#endif	/* ANSI-C/C++ */
#endif	/* ! YYPARSE_PARAM */

int
yyparse (YYPARSE_PARAM_ARG)
    YYPARSE_PARAM_DECL
{
    register int yym, yyn, yystate;
#if YYDEBUG
    register const char *yys;

    if ((yys = getenv("YYDEBUG")))
    {
        yyn = *yys;
        if (yyn >= '0' && yyn <= '9')
            yydebug = yyn - '0';
    }
#endif

    yynerrs = 0;
    yyerrflag = 0;
    yychar = (-1);

    if (yyss == NULL && yygrowstack()) goto yyoverflow;
    yyssp = yyss;
    yyvsp = yyvs;
    *yyssp = yystate = 0;

yyloop:
    if ((yyn = yydefred[yystate])) goto yyreduce;
    if (yychar < 0)
    {
        if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, reading %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
    }
    if ((yyn = yysindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: state %d, shifting to state %d\n",
                    YYPREFIX, yystate, yytable[yyn]);
#endif
        if (yyssp >= yysslim && yygrowstack())
        {
            goto yyoverflow;
        }
        *++yyssp = yystate = yytable[yyn];
        *++yyvsp = yylval;
        yychar = (-1);
        if (yyerrflag > 0)  --yyerrflag;
        goto yyloop;
    }
    if ((yyn = yyrindex[yystate]) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
    {
        yyn = yytable[yyn];
        goto yyreduce;
    }
    if (yyerrflag) goto yyinrecovery;
#if defined(lint) || defined(__GNUC__)
    goto yynewerror;
#endif
yynewerror:
    yyerror("syntax error");
#if defined(lint) || defined(__GNUC__)
    goto yyerrlab;
#endif
yyerrlab:
    ++yynerrs;
yyinrecovery:
    if (yyerrflag < 3)
    {
        yyerrflag = 3;
        for (;;)
        {
            if ((yyn = yysindex[*yyssp]) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: state %d, error recovery shifting\
 to state %d\n", YYPREFIX, *yyssp, yytable[yyn]);
#endif
                if (yyssp >= yysslim && yygrowstack())
                {
                    goto yyoverflow;
                }
                *++yyssp = yystate = yytable[yyn];
                *++yyvsp = yylval;
                goto yyloop;
            }
            else
            {
#if YYDEBUG
                if (yydebug)
                    printf("%sdebug: error recovery discarding state %d\n",
                            YYPREFIX, *yyssp);
#endif
                if (yyssp <= yyss) goto yyabort;
                --yyssp;
                --yyvsp;
            }
        }
    }
    else
    {
        if (yychar == 0) goto yyabort;
#if YYDEBUG
        if (yydebug)
        {
            yys = 0;
            if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
            if (!yys) yys = "illegal-symbol";
            printf("%sdebug: state %d, error recovery discards token %d (%s)\n",
                    YYPREFIX, yystate, yychar, yys);
        }
#endif
        yychar = (-1);
        goto yyloop;
    }
yyreduce:
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: state %d, reducing by rule %d (%s)\n",
                YYPREFIX, yystate, yyn, yyrule[yyn]);
#endif
    yym = yylen[yyn];
    yyval = yyvsp[1-yym];
    switch (yyn)
    {
case 1:
#line 279 "c-parse.y"
{ if (pedantic)
		    pedwarn ("ANSI C forbids an empty source file");
		  finish_file ();
		}
break;
case 2:
#line 284 "c-parse.y"
{
		  /* In case there were missing closebraces,
		     get us back to the global binding level.  */
		  while (! global_bindings_p ())
		    poplevel (0, 0, 0);
		  finish_file ();
		}
break;
case 3:
#line 298 "c-parse.y"
{yyval.ttype = NULL_TREE; }
break;
case 5:
#line 299 "c-parse.y"
{yyval.ttype = NULL_TREE; }
break;
case 9:
#line 306 "c-parse.y"
{ STRIP_NOPS (yyvsp[-2].ttype);
		  if ((TREE_CODE (yyvsp[-2].ttype) == ADDR_EXPR
		       && TREE_CODE (TREE_OPERAND (yyvsp[-2].ttype, 0)) == STRING_CST)
		      || TREE_CODE (yyvsp[-2].ttype) == STRING_CST)
		    assemble_asm (yyvsp[-2].ttype);
		  else
		    error ("argument of `asm' is not a constant string"); }
break;
case 10:
#line 314 "c-parse.y"
{ pedantic = yyvsp[-1].itype; }
break;
case 11:
#line 319 "c-parse.y"
{ if (pedantic)
		    error ("ANSI C forbids data definition with no type or storage class");
		  else if (!flag_traditional)
		    warning ("data definition has no type or storage class"); 

		  current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype); }
break;
case 12:
#line 329 "c-parse.y"
{ current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype); }
break;
case 13:
#line 334 "c-parse.y"
{ current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype);  }
break;
case 14:
#line 339 "c-parse.y"
{ pedwarn ("empty declaration"); }
break;
case 15:
#line 341 "c-parse.y"
{ shadow_tag (yyvsp[-1].ttype); }
break;
case 18:
#line 345 "c-parse.y"
{ if (pedantic)
		    pedwarn ("ANSI C does not allow extra `;' outside of a function"); }
break;
case 19:
#line 351 "c-parse.y"
{ if (! start_function (current_declspecs, yyvsp[0].ttype,
					prefix_attributes, NULL_TREE))
		    YYERROR1;
		  reinit_parse_for_function (); }
break;
case 20:
#line 356 "c-parse.y"
{ store_parm_decls (); }
break;
case 21:
#line 358 "c-parse.y"
{ finish_function (0); 
		  current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-5].itype); }
break;
case 22:
#line 364 "c-parse.y"
{ current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype); }
break;
case 23:
#line 369 "c-parse.y"
{ if (! start_function (current_declspecs, yyvsp[0].ttype,
					prefix_attributes, NULL_TREE))
		    YYERROR1;
		  reinit_parse_for_function (); }
break;
case 24:
#line 374 "c-parse.y"
{ store_parm_decls (); }
break;
case 25:
#line 376 "c-parse.y"
{ finish_function (0); 
		  current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-5].itype); }
break;
case 26:
#line 382 "c-parse.y"
{ current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype); }
break;
case 27:
#line 387 "c-parse.y"
{ if (! start_function (NULL_TREE, yyvsp[0].ttype,
					prefix_attributes, NULL_TREE))
		    YYERROR1;
		  reinit_parse_for_function (); }
break;
case 28:
#line 392 "c-parse.y"
{ store_parm_decls (); }
break;
case 29:
#line 394 "c-parse.y"
{ finish_function (0); 
		  current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-5].itype); }
break;
case 30:
#line 400 "c-parse.y"
{ current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype); }
break;
case 33:
#line 412 "c-parse.y"
{ yyval.code = ADDR_EXPR; }
break;
case 34:
#line 414 "c-parse.y"
{ yyval.code = NEGATE_EXPR; }
break;
case 35:
#line 416 "c-parse.y"
{ yyval.code = CONVERT_EXPR; }
break;
case 36:
#line 418 "c-parse.y"
{ yyval.code = PREINCREMENT_EXPR; }
break;
case 37:
#line 420 "c-parse.y"
{ yyval.code = PREDECREMENT_EXPR; }
break;
case 38:
#line 422 "c-parse.y"
{ yyval.code = BIT_NOT_EXPR; }
break;
case 39:
#line 424 "c-parse.y"
{ yyval.code = TRUTH_NOT_EXPR; }
break;
case 40:
#line 428 "c-parse.y"
{ yyval.ttype = build_compound_expr (yyvsp[0].ttype); }
break;
case 41:
#line 433 "c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 43:
#line 439 "c-parse.y"
{ yyval.ttype = build_tree_list (NULL_TREE, yyvsp[0].ttype); }
break;
case 44:
#line 441 "c-parse.y"
{ chainon (yyvsp[-2].ttype, build_tree_list (NULL_TREE, yyvsp[0].ttype)); }
break;
case 46:
#line 447 "c-parse.y"
{ yyval.ttype = build_indirect_ref (yyvsp[0].ttype, "unary *"); }
break;
case 47:
#line 450 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype;
		  pedantic = yyvsp[-1].itype; }
break;
case 48:
#line 453 "c-parse.y"
{ yyval.ttype = build_unary_op (yyvsp[-1].code, yyvsp[0].ttype, 0);
		  overflow_warning (yyval.ttype); }
break;
case 49:
#line 457 "c-parse.y"
{ tree label = lookup_label (yyvsp[0].ttype);
		  if (pedantic)
		    pedwarn ("ANSI C forbids `&&'");
		  if (label == 0)
		    yyval.ttype = null_pointer_node;
		  else
		    {
		      TREE_USED (label) = 1;
		      yyval.ttype = build1 (ADDR_EXPR, ptr_type_node, label);
		      TREE_CONSTANT (yyval.ttype) = 1;
		    }
		}
break;
case 50:
#line 485 "c-parse.y"
{ skip_evaluation--;
		  if (TREE_CODE (yyvsp[0].ttype) == COMPONENT_REF
		      && DECL_C_BIT_FIELD (TREE_OPERAND (yyvsp[0].ttype, 1)))
		    error ("`sizeof' applied to a bit-field");
		  yyval.ttype = c_sizeof (TREE_TYPE (yyvsp[0].ttype)); }
break;
case 51:
#line 491 "c-parse.y"
{ skip_evaluation--;
		  yyval.ttype = c_sizeof (groktypename (yyvsp[-1].ttype)); }
break;
case 52:
#line 495 "c-parse.y"
{ skip_evaluation--;
		  if (TREE_CODE (yyvsp[0].ttype) == COMPONENT_REF
		      && DECL_C_BIT_FIELD (TREE_OPERAND (yyvsp[0].ttype, 1)))
		    error ("`upc_blocksizeof' applied to a bit-field");
		  if (TREE_CODE (yyvsp[0].ttype) == ADDR_EXPR && 
		      TREE_CODE(TREE_OPERAND(yyvsp[0].ttype, 0)) == COMPONENT_REF) {
		    tree field_struct = TREE_OPERAND(TREE_OPERAND(yyvsp[0].ttype, 0), 0);
		    if (TYPE_SHARED(TREE_TYPE(field_struct))) {
		      yyval.ttype = integer_zero_node;
		    } else {
		      yyval.ttype = upc_blocksizeof(yyvsp[0].ttype);
		    }
		  } else {
		    yyval.ttype = upc_blocksizeof(yyvsp[0].ttype); 
		  }
		}
break;
case 53:
#line 512 "c-parse.y"
{ skip_evaluation--;
		  yyval.ttype = upc_blocksizeof (groktypename (yyvsp[-1].ttype)); }
break;
case 54:
#line 515 "c-parse.y"
{ skip_evaluation--;
		  if (TREE_CODE (yyvsp[0].ttype) == COMPONENT_REF
		      && DECL_C_BIT_FIELD (TREE_OPERAND (yyvsp[0].ttype, 1)))
		    error ("`upc_localsizeof' applied to a bit-field");
		  yyval.ttype = upc_localsizeof (yyvsp[0].ttype); }
break;
case 55:
#line 521 "c-parse.y"
{ skip_evaluation--;
		  yyval.ttype = upc_localsizeof (groktypename (yyvsp[-1].ttype)); }
break;
case 56:
#line 524 "c-parse.y"
{ skip_evaluation--;
		  if (TREE_CODE (yyvsp[0].ttype) == COMPONENT_REF
		      && DECL_C_BIT_FIELD (TREE_OPERAND (yyvsp[0].ttype, 1)))
		    error ("`upc_elemsizeof' applied to a bit-field");
		  yyval.ttype = upc_elemsizeof (TREE_TYPE (yyvsp[0].ttype)); }
break;
case 57:
#line 530 "c-parse.y"
{ skip_evaluation--;
		  yyval.ttype = upc_elemsizeof (groktypename (yyvsp[-1].ttype)); }
break;
case 58:
#line 533 "c-parse.y"
{ skip_evaluation--;
		  yyval.ttype = c_alignof_expr (yyvsp[0].ttype); }
break;
case 59:
#line 536 "c-parse.y"
{ skip_evaluation--;
		  yyval.ttype = c_alignof (groktypename (yyvsp[-1].ttype)); }
break;
case 60:
#line 539 "c-parse.y"
{ yyval.ttype = build_unary_op (REALPART_EXPR, yyvsp[0].ttype, 0); }
break;
case 61:
#line 541 "c-parse.y"
{ yyval.ttype = build_unary_op (IMAGPART_EXPR, yyvsp[0].ttype, 0); }
break;
case 62:
#line 546 "c-parse.y"
{ skip_evaluation++; }
break;
case 63:
#line 549 "c-parse.y"
{ skip_evaluation++; }
break;
case 64:
#line 552 "c-parse.y"
{ skip_evaluation++; }
break;
case 65:
#line 555 "c-parse.y"
{skip_evaluation++; }
break;
case 66:
#line 558 "c-parse.y"
{ skip_evaluation++; }
break;
case 67:
#line 563 "c-parse.y"
{ skip_evaluation++; }
break;
case 69:
#line 569 "c-parse.y"
{ tree type = groktypename (yyvsp[-2].ttype);
		  yyval.ttype = build_c_cast (type, yyvsp[0].ttype); }
break;
case 70:
#line 572 "c-parse.y"
{ start_init (NULL_TREE, NULL, 0);
		  yyvsp[-2].ttype = groktypename (yyvsp[-2].ttype);
		  really_start_incremental_init (yyvsp[-2].ttype); }
break;
case 71:
#line 576 "c-parse.y"
{ char *name;
		  tree result = pop_init_level (0);
		  tree type = yyvsp[-5].ttype;
		  finish_init ();

		  if (pedantic && ! flag_isoc99)
		    pedwarn ("ANSI C forbids constructor expressions");
		  if (TYPE_NAME (type) != 0)
		    {
		      if (TREE_CODE (TYPE_NAME (type)) == IDENTIFIER_NODE)
			name = IDENTIFIER_POINTER (TYPE_NAME (type));
		      else
			name = IDENTIFIER_POINTER (DECL_NAME (TYPE_NAME (type)));
		    }
		  else
		    name = "";
		  yyval.ttype = result;
		  if (TREE_CODE (type) == ARRAY_TYPE && TYPE_SIZE (type) == 0)
		    {
		      int failure = complete_array_type (type, yyval.ttype, 1);
		      if (failure)
			abort ();
		    }
		}
break;
case 73:
#line 605 "c-parse.y"
{ yyval.ttype = parser_build_binary_op (yyvsp[-1].code, yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 74:
#line 607 "c-parse.y"
{ yyval.ttype = parser_build_binary_op (yyvsp[-1].code, yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 75:
#line 609 "c-parse.y"
{ yyval.ttype = parser_build_binary_op (yyvsp[-1].code, yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 76:
#line 611 "c-parse.y"
{ yyval.ttype = parser_build_binary_op (yyvsp[-1].code, yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 77:
#line 613 "c-parse.y"
{ yyval.ttype = parser_build_binary_op (yyvsp[-1].code, yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 78:
#line 615 "c-parse.y"
{ yyval.ttype = parser_build_binary_op (yyvsp[-1].code, yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 79:
#line 617 "c-parse.y"
{ yyval.ttype = parser_build_binary_op (yyvsp[-1].code, yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 80:
#line 619 "c-parse.y"
{ yyval.ttype = parser_build_binary_op (yyvsp[-1].code, yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 81:
#line 621 "c-parse.y"
{ yyval.ttype = parser_build_binary_op (yyvsp[-1].code, yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 82:
#line 623 "c-parse.y"
{ yyval.ttype = parser_build_binary_op (yyvsp[-1].code, yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 83:
#line 625 "c-parse.y"
{ yyval.ttype = parser_build_binary_op (yyvsp[-1].code, yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 84:
#line 627 "c-parse.y"
{ yyval.ttype = parser_build_binary_op (yyvsp[-1].code, yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 85:
#line 629 "c-parse.y"
{ yyvsp[-1].ttype = truthvalue_conversion (default_conversion (yyvsp[-1].ttype));
		  skip_evaluation += yyvsp[-1].ttype == boolean_false_node; }
break;
case 86:
#line 632 "c-parse.y"
{ skip_evaluation -= yyvsp[-3].ttype == boolean_false_node;
		  yyval.ttype = parser_build_binary_op (TRUTH_ANDIF_EXPR, yyvsp[-3].ttype, yyvsp[0].ttype); }
break;
case 87:
#line 635 "c-parse.y"
{ yyvsp[-1].ttype = truthvalue_conversion (default_conversion (yyvsp[-1].ttype));
		  skip_evaluation += yyvsp[-1].ttype == boolean_true_node; }
break;
case 88:
#line 638 "c-parse.y"
{ skip_evaluation -= yyvsp[-3].ttype == boolean_true_node;
		  yyval.ttype = parser_build_binary_op (TRUTH_ORIF_EXPR, yyvsp[-3].ttype, yyvsp[0].ttype); }
break;
case 89:
#line 641 "c-parse.y"
{ yyvsp[-1].ttype = truthvalue_conversion (default_conversion (yyvsp[-1].ttype));
		  skip_evaluation += yyvsp[-1].ttype == boolean_false_node; }
break;
case 90:
#line 644 "c-parse.y"
{ skip_evaluation += ((yyvsp[-4].ttype == boolean_true_node)
				      - (yyvsp[-4].ttype == boolean_false_node)); }
break;
case 91:
#line 647 "c-parse.y"
{ skip_evaluation -= yyvsp[-6].ttype == boolean_true_node;
		  yyval.ttype = build_conditional_expr (yyvsp[-6].ttype, yyvsp[-3].ttype, yyvsp[0].ttype); }
break;
case 92:
#line 650 "c-parse.y"
{ if (pedantic)
		    pedwarn ("ANSI C forbids omitting the middle term of a ?: expression");
		  /* Make sure first operand is calculated only once.  */
		  yyvsp[0].ttype = save_expr (yyvsp[-1].ttype);
		  yyvsp[-1].ttype = truthvalue_conversion (default_conversion (yyvsp[0].ttype));
		  skip_evaluation += yyvsp[-1].ttype == boolean_true_node; }
break;
case 93:
#line 657 "c-parse.y"
{ skip_evaluation -= yyvsp[-4].ttype == boolean_true_node;
		  yyval.ttype = build_conditional_expr (yyvsp[-4].ttype, yyvsp[-3].ttype, yyvsp[0].ttype); }
break;
case 94:
#line 660 "c-parse.y"
{ char class;
		  yyval.ttype = build_modify_expr (yyvsp[-2].ttype, NOP_EXPR, yyvsp[0].ttype);
		  class = TREE_CODE_CLASS (TREE_CODE (yyval.ttype));
		  if (class == 'e' || class == '1'
		      || class == '2' || class == '<')
		    C_SET_EXP_ORIGINAL_CODE (yyval.ttype, MODIFY_EXPR);
		}
break;
case 95:
#line 668 "c-parse.y"
{ char class;
		  yyval.ttype = build_modify_expr (yyvsp[-2].ttype, yyvsp[-1].code, yyvsp[0].ttype);
		  /* This inhibits warnings in truthvalue_conversion.  */
		  class = TREE_CODE_CLASS (TREE_CODE (yyval.ttype));
		  if (class == 'e' || class == '1'
		      || class == '2' || class == '<')
		    C_SET_EXP_ORIGINAL_CODE (yyval.ttype, ERROR_MARK);
		}
break;
case 96:
#line 680 "c-parse.y"
{
		  yyval.ttype = lastiddecl;
		  if (!yyval.ttype || yyval.ttype == error_mark_node)
		    {
		      if (yychar == YYEMPTY)
			yychar = YYLEX;
		      if (yychar == '(')
			{
			    {
			      /* Ordinary implicit function declaration.  */
			      yyval.ttype = implicitly_declare (yyvsp[0].ttype);
			      assemble_external (yyval.ttype);
			      TREE_USED (yyval.ttype) = 1;
			    }
			}
		      else if (attribute_param)
			{
			  yyval.ttype = error_mark_node; /* TODO: this just ignores attribute parameters */
			}
		      else if (current_function_decl == 0)
			{
			  error ("`%s' undeclared here (not in a function)",
				 IDENTIFIER_POINTER (yyvsp[0].ttype));
			  yyval.ttype = error_mark_node;
			}
		      else
			{
			    {
			      if (IDENTIFIER_GLOBAL_VALUE (yyvsp[0].ttype) != error_mark_node
				  || IDENTIFIER_ERROR_LOCUS (yyvsp[0].ttype) != current_function_decl)
				{
				  error ("`%s' undeclared (first use in this function)",
					 IDENTIFIER_POINTER (yyvsp[0].ttype));

				  if (! undeclared_variable_notice)
				    {
				      error ("(Each undeclared identifier is reported only once");
				      error ("for each function it appears in.)");
				      undeclared_variable_notice = 1;
				    }
				}
			      yyval.ttype = error_mark_node;
			      /* Prevent repeated error messages.  */
			      IDENTIFIER_GLOBAL_VALUE (yyvsp[0].ttype) = error_mark_node;
			      IDENTIFIER_ERROR_LOCUS (yyvsp[0].ttype) = current_function_decl;
			    }
			}
		    }
		  else if (TREE_TYPE (yyval.ttype) == error_mark_node)
		    yyval.ttype = error_mark_node;
		  else if (C_DECL_ANTICIPATED (yyval.ttype))
		    {
		      /* The first time we see a build-in function used,
			 if it has not been declared.  */
		      C_DECL_ANTICIPATED (yyval.ttype) = 0;
		      if (yychar == YYEMPTY)
			yychar = YYLEX;
		      if (yychar == '(')
			{
			  /* Omit the implicit declaration we
			     would ordinarily do, so we don't lose
			     the actual built in type.
			     But print a diagnostic for the mismatch.  */
			    if (TREE_CODE (yyval.ttype) != FUNCTION_DECL)
			      error ("`%s' implicitly declared as function",
				     IDENTIFIER_POINTER (DECL_NAME (yyval.ttype)));
			  else if ((TYPE_MODE (TREE_TYPE (TREE_TYPE (yyval.ttype)))
				    != TYPE_MODE (integer_type_node))
				   && (TREE_TYPE (TREE_TYPE (yyval.ttype))
				       != void_type_node))
			    pedwarn ("type mismatch in implicit declaration for built-in function `%s'",
				     IDENTIFIER_POINTER (DECL_NAME (yyval.ttype)));
			  /* If it really returns void, change that to int.  */
			  if (TREE_TYPE (TREE_TYPE (yyval.ttype)) == void_type_node)
			    TREE_TYPE (yyval.ttype)
			      = build_function_type (integer_type_node,
						     TYPE_ARG_TYPES (TREE_TYPE (yyval.ttype)));
			}
		      else
			pedwarn ("built-in function `%s' used without declaration",
				 IDENTIFIER_POINTER (DECL_NAME (yyval.ttype)));

		      /* Do what we would ordinarily do when a fn is used.  */
		      assemble_external (yyval.ttype);
		      TREE_USED (yyval.ttype) = 1;
		    }
		  else
		    {
		      assemble_external (yyval.ttype);
		      TREE_USED (yyval.ttype) = 1;
		    }

		  if (TREE_CODE (yyval.ttype) == CONST_DECL)
		    {
		      yyval.ttype = DECL_INITIAL (yyval.ttype);
		      /* This is to prevent an enum whose value is 0
			 from being considered a null pointer constant.  */
		      yyval.ttype = build1 (NOP_EXPR, TREE_TYPE (yyval.ttype), yyval.ttype);
		      TREE_CONSTANT (yyval.ttype) = 1;
		    }
		}
break;
case 98:
#line 783 "c-parse.y"
{ yyval.ttype = combine_strings (yyvsp[0].ttype); }
break;
case 99:
#line 785 "c-parse.y"
{ char class = TREE_CODE_CLASS (TREE_CODE (yyvsp[-1].ttype));
		  if (class == 'e' || class == '1'
		      || class == '2' || class == '<')
		    C_SET_EXP_ORIGINAL_CODE (yyvsp[-1].ttype, ERROR_MARK);
		  yyval.ttype = yyvsp[-1].ttype; }
break;
case 100:
#line 791 "c-parse.y"
{ yyval.ttype = error_mark_node; }
break;
case 101:
#line 793 "c-parse.y"
{ if (current_function_decl == 0)
		    {
		      error ("braced-group within expression allowed only inside a function");
		      YYERROR;
		    }
		  /* We must force a BLOCK for this level
		     so that, if it is not expanded later,
		     there is a way to turn off the entire subtree of blocks
		     that are contained in it.  */
		  keep_next_level ();
		  push_iterator_stack ();
		  push_label_level ();
		  yyval.ttype = expand_start_stmt_expr (); }
break;
case 102:
#line 807 "c-parse.y"
{ tree rtl_exp;
		  if (pedantic)
		    pedwarn ("ANSI C forbids braced-groups within expressions");
		  pop_iterator_stack ();
		  pop_label_level ();
		  rtl_exp = expand_end_stmt_expr (yyvsp[-2].ttype);
		  /* The statements have side effects, so the group does.  */
		  TREE_SIDE_EFFECTS (rtl_exp) = 1;

		  if (TREE_CODE (yyvsp[-1].ttype) == BLOCK)
		    {
		      /* Make a BIND_EXPR for the BLOCK already made.  */
		      yyval.ttype = build (BIND_EXPR, TREE_TYPE (rtl_exp),
				  NULL_TREE, rtl_exp, yyvsp[-1].ttype);
		      /* Remove the block from the tree at this point.
			 It gets put back at the proper place
			 when the BIND_EXPR is expanded.  */
		      delete_block (yyvsp[-1].ttype);
		    }
		  else
		    yyval.ttype = yyvsp[-1].ttype;
		}
break;
case 103:
#line 830 "c-parse.y"
{ skip_evaluation--;
		  yyval.ttype = bupc_assert_type(groktypename (yyvsp[-3].ttype), groktypename (yyvsp[-1].ttype)); }
break;
case 104:
#line 833 "c-parse.y"
{ skip_evaluation--;
		  yyval.ttype = bupc_assert_type(groktypename (yyvsp[-3].ttype), TREE_TYPE(yyvsp[-1].ttype)); }
break;
case 105:
#line 836 "c-parse.y"
{ skip_evaluation--;
		  yyval.ttype = bupc_assert_type(TREE_TYPE (yyvsp[-3].ttype), groktypename (yyvsp[-1].ttype)); }
break;
case 106:
#line 839 "c-parse.y"
{ skip_evaluation--;
		  yyval.ttype = bupc_assert_type(TREE_TYPE (yyvsp[-3].ttype), TREE_TYPE(yyvsp[-1].ttype)); }
break;
case 107:
#line 842 "c-parse.y"
{ yyval.ttype = build_function_call (yyvsp[-3].ttype, yyvsp[-1].ttype); }
break;
case 108:
#line 844 "c-parse.y"
{ yyval.ttype = build_array_ref (yyvsp[-3].ttype, yyvsp[-1].ttype); }
break;
case 109:
#line 846 "c-parse.y"
{
		    yyval.ttype = build_component_ref (yyvsp[-2].ttype, yyvsp[0].ttype);
		}
break;
case 110:
#line 850 "c-parse.y"
{
                  tree expr = build_indirect_ref (yyvsp[-2].ttype, "->");

                    yyval.ttype = build_component_ref (expr, yyvsp[0].ttype);
		}
break;
case 111:
#line 856 "c-parse.y"
{ yyval.ttype = build_unary_op (POSTINCREMENT_EXPR, yyvsp[-1].ttype, 0); }
break;
case 112:
#line 858 "c-parse.y"
{ yyval.ttype = build_unary_op (POSTDECREMENT_EXPR, yyvsp[-1].ttype, 0); }
break;
case 114:
#line 865 "c-parse.y"
{ yyval.ttype = chainon (yyvsp[-1].ttype, yyvsp[0].ttype); }
break;
case 117:
#line 874 "c-parse.y"
{ c_mark_varargs ();
		  if (pedantic)
		    pedwarn ("ANSI C does not permit use of `varargs.h'"); }
break;
case 118:
#line 884 "c-parse.y"
{ }
break;
case 123:
#line 900 "c-parse.y"
{ current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype); }
break;
case 124:
#line 905 "c-parse.y"
{ current_declspecs = TREE_VALUE (declspec_stack);	
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype); }
break;
case 125:
#line 910 "c-parse.y"
{ shadow_tag_warned (yyvsp[-1].ttype, 1);
		  pedwarn ("empty declaration"); }
break;
case 126:
#line 913 "c-parse.y"
{ pedwarn ("empty declaration"); }
break;
case 127:
#line 943 "c-parse.y"
{ yyval.itype = suspend_momentary ();
		  pending_xref_error ();
		  declspec_stack = tree_cons (prefix_attributes,
					      current_declspecs,
					      declspec_stack);
		  split_specs_attrs (yyvsp[0].ttype,
				     &current_declspecs, &prefix_attributes); }
break;
case 128:
#line 954 "c-parse.y"
{ prefix_attributes = chainon (prefix_attributes, yyvsp[0].ttype); }
break;
case 129:
#line 959 "c-parse.y"
{ current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype); }
break;
case 130:
#line 964 "c-parse.y"
{ current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype); }
break;
case 131:
#line 969 "c-parse.y"
{ current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-1].itype); }
break;
case 132:
#line 974 "c-parse.y"
{ current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-1].itype); }
break;
case 133:
#line 979 "c-parse.y"
{ shadow_tag (yyvsp[-1].ttype); }
break;
case 134:
#line 981 "c-parse.y"
{ pedwarn ("empty declaration"); }
break;
case 135:
#line 983 "c-parse.y"
{ pedantic = yyvsp[-1].itype; }
break;
case 136:
#line 993 "c-parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, yyvsp[-1].ttype, yyvsp[0].ttype); }
break;
case 137:
#line 995 "c-parse.y"
{ yyval.ttype = chainon (yyvsp[0].ttype, tree_cons (NULL_TREE, yyvsp[-1].ttype, yyvsp[-2].ttype)); }
break;
case 138:
#line 999 "c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 139:
#line 1001 "c-parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, yyvsp[0].ttype, yyvsp[-1].ttype); }
break;
case 140:
#line 1003 "c-parse.y"
{ if (extra_warnings)
		    warning ("`%s' is not at beginning of declaration",
			     IDENTIFIER_POINTER (yyvsp[0].ttype));
		  yyval.ttype = tree_cons (NULL_TREE, yyvsp[0].ttype, yyvsp[-1].ttype); }
break;
case 141:
#line 1008 "c-parse.y"
{ yyval.ttype = tree_cons (yyvsp[0].ttype, NULL_TREE, yyvsp[-1].ttype); }
break;
case 142:
#line 1013 "c-parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, yyvsp[-1].ttype, yyvsp[0].ttype); }
break;
case 143:
#line 1015 "c-parse.y"
{ yyval.ttype = chainon (yyvsp[0].ttype, tree_cons (NULL_TREE, yyvsp[-1].ttype, yyvsp[-2].ttype)); }
break;
case 144:
#line 1020 "c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 145:
#line 1022 "c-parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, yyvsp[0].ttype, yyvsp[-1].ttype); }
break;
case 146:
#line 1024 "c-parse.y"
{ if (extra_warnings)
		    warning ("`%s' is not at beginning of declaration",
			     IDENTIFIER_POINTER (yyvsp[0].ttype));
		  yyval.ttype = tree_cons (NULL_TREE, yyvsp[0].ttype, yyvsp[-1].ttype); }
break;
case 147:
#line 1037 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype; }
break;
case 148:
#line 1039 "c-parse.y"
{ yyval.ttype = tree_cons (yyvsp[0].ttype, NULL_TREE, NULL_TREE); }
break;
case 149:
#line 1041 "c-parse.y"
{ yyval.ttype = chainon (yyvsp[0].ttype, yyvsp[-1].ttype); }
break;
case 150:
#line 1043 "c-parse.y"
{ yyval.ttype = tree_cons (yyvsp[0].ttype, NULL_TREE, yyvsp[-1].ttype); }
break;
case 151:
#line 1048 "c-parse.y"
{ TREE_STATIC (yyval.ttype) = 1; }
break;
case 152:
#line 1050 "c-parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, yyvsp[0].ttype, NULL_TREE); }
break;
case 153:
#line 1052 "c-parse.y"
{ yyval.ttype = chainon (yyvsp[0].ttype, yyvsp[-1].ttype);
		  TREE_STATIC (yyval.ttype) = 1; }
break;
case 154:
#line 1055 "c-parse.y"
{ if (extra_warnings && TREE_STATIC (yyvsp[-1].ttype))
		    warning ("`%s' is not at beginning of declaration",
			     IDENTIFIER_POINTER (yyvsp[0].ttype));
		  yyval.ttype = tree_cons (NULL_TREE, yyvsp[0].ttype, yyvsp[-1].ttype);
		  TREE_STATIC (yyval.ttype) = TREE_STATIC (yyvsp[-1].ttype); }
break;
case 155:
#line 1064 "c-parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, yyvsp[0].ttype, NULL_TREE); }
break;
case 156:
#line 1066 "c-parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, yyvsp[0].ttype, NULL_TREE); }
break;
case 157:
#line 1068 "c-parse.y"
{ 
	  
		  yyval.ttype = tree_cons (NULL_TREE, yyvsp[0].ttype,
				 tree_cons (NULL_TREE, yyvsp[-1].ttype, NULL_TREE)); }
break;
case 158:
#line 1082 "c-parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, yyvsp[-1].ttype, yyvsp[0].ttype); }
break;
case 159:
#line 1084 "c-parse.y"
{ yyval.ttype = chainon (yyvsp[0].ttype, tree_cons (NULL_TREE, yyvsp[-1].ttype, yyvsp[-2].ttype)); }
break;
case 160:
#line 1090 "c-parse.y"
{ yyval.ttype = tree_cons(NULL_TREE, yyvsp[-1].ttype, NULL_TREE); }
break;
case 161:
#line 1093 "c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 162:
#line 1095 "c-parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, yyvsp[0].ttype, yyvsp[-1].ttype); }
break;
case 165:
#line 1105 "c-parse.y"
{ /* For a typedef name, record the meaning, not the name.
		     In case of `foo foo, bar;'.  */
		  yyval.ttype = lookup_name (yyvsp[0].ttype); }
break;
case 166:
#line 1109 "c-parse.y"
{ yyval.ttype = TREE_TYPE (yyvsp[-1].ttype); }
break;
case 167:
#line 1111 "c-parse.y"
{ yyval.ttype = groktypename (yyvsp[-1].ttype); }
break;
case 171:
#line 1121 "c-parse.y"
{ 
	  
  yyval.ttype = tree_cons (NULL_TREE, yyvsp[0].ttype,
		  tree_cons (NULL_TREE, yyvsp[-1].ttype, NULL_TREE)); }
break;
case 177:
#line 1140 "c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 178:
#line 1142 "c-parse.y"
{ if (TREE_CHAIN (yyvsp[-1].ttype)) yyvsp[-1].ttype = combine_strings (yyvsp[-1].ttype);
		  yyval.ttype = yyvsp[-1].ttype;
		}
break;
case 179:
#line 1149 "c-parse.y"
{ yyval.ttype = start_decl (yyvsp[-3].ttype, current_declspecs, 1,
					  yyvsp[-1].ttype, prefix_attributes);
		  start_init (yyval.ttype, yyvsp[-2].ttype, global_bindings_p ()); }
break;
case 180:
#line 1154 "c-parse.y"
{ finish_init ();
		  finish_decl (yyvsp[-1].ttype, yyvsp[0].ttype, yyvsp[-4].ttype); }
break;
case 181:
#line 1157 "c-parse.y"
{ tree d = start_decl (yyvsp[-2].ttype, current_declspecs, 0,
				       yyvsp[0].ttype, prefix_attributes);
		  finish_decl (d, NULL_TREE, yyvsp[-1].ttype); 
                }
break;
case 182:
#line 1165 "c-parse.y"
{ yyval.ttype = start_decl (yyvsp[-3].ttype, current_declspecs, 1,
					  yyvsp[-1].ttype, prefix_attributes);
		  start_init (yyval.ttype, yyvsp[-2].ttype, global_bindings_p ()); }
break;
case 183:
#line 1170 "c-parse.y"
{ finish_init ();
		  decl_attributes (yyvsp[-1].ttype, yyvsp[-3].ttype, prefix_attributes);
		  finish_decl (yyvsp[-1].ttype, yyvsp[0].ttype, yyvsp[-4].ttype); }
break;
case 184:
#line 1174 "c-parse.y"
{ tree d = start_decl (yyvsp[-2].ttype, current_declspecs, 0,
				       yyvsp[0].ttype, prefix_attributes);
		  finish_decl (d, NULL_TREE, yyvsp[-1].ttype); }
break;
case 185:
#line 1182 "c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 186:
#line 1184 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype; }
break;
case 187:
#line 1189 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype; }
break;
case 188:
#line 1191 "c-parse.y"
{ yyval.ttype = chainon (yyvsp[-1].ttype, yyvsp[0].ttype); }
break;
case 189:
#line 1196 "c-parse.y"
{ yyval.ttype = yyvsp[-2].ttype; }
break;
case 190:
#line 1201 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype; }
break;
case 191:
#line 1203 "c-parse.y"
{ yyval.ttype = chainon (yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 192:
#line 1208 "c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 193:
#line 1210 "c-parse.y"
{ yyval.ttype = build_tree_list (yyvsp[0].ttype, NULL_TREE); }
break;
case 194:
#line 1212 "c-parse.y"
{ yyval.ttype = build_tree_list (yyvsp[-3].ttype, build_tree_list (NULL_TREE, yyvsp[-1].ttype)); }
break;
case 195:
#line 1214 "c-parse.y"
{attribute_param++;}
break;
case 196:
#line 1216 "c-parse.y"
{attribute_param--;}
break;
case 197:
#line 1218 "c-parse.y"
{ yyval.ttype = build_tree_list (yyvsp[-7].ttype, tree_cons (NULL_TREE, yyvsp[-5].ttype, yyvsp[-2].ttype)); }
break;
case 198:
#line 1220 "c-parse.y"
{ yyval.ttype = build_tree_list (yyvsp[-3].ttype, yyvsp[-1].ttype); }
break;
case 205:
#line 1239 "c-parse.y"
{ really_start_incremental_init (NULL_TREE);
		  /* Note that the call to clear_momentary
		     is in process_init_element.  */
		  push_momentary (); }
break;
case 206:
#line 1244 "c-parse.y"
{ yyval.ttype = pop_init_level (0);
		  if (yyval.ttype == error_mark_node
		      && ! (yychar == STRING || yychar == CONSTANT))
		    pop_momentary ();
		  else
		    pop_momentary_nofree (); }
break;
case 207:
#line 1252 "c-parse.y"
{ yyval.ttype = error_mark_node; }
break;
case 208:
#line 1258 "c-parse.y"
{ if (pedantic)
		    pedwarn ("ANSI C forbids empty initializer braces"); }
break;
case 214:
#line 1274 "c-parse.y"
{ set_init_label (yyvsp[-1].ttype); }
break;
case 217:
#line 1281 "c-parse.y"
{ push_init_level (0); }
break;
case 218:
#line 1283 "c-parse.y"
{ process_init_element (pop_init_level (0)); }
break;
case 219:
#line 1285 "c-parse.y"
{ process_init_element (yyvsp[0].ttype); }
break;
case 223:
#line 1296 "c-parse.y"
{ set_init_label (yyvsp[0].ttype); }
break;
case 224:
#line 1301 "c-parse.y"
{ set_init_index (yyvsp[-3].ttype, yyvsp[-1].ttype); }
break;
case 225:
#line 1303 "c-parse.y"
{ set_init_index (yyvsp[-1].ttype, NULL_TREE); }
break;
case 226:
#line 1308 "c-parse.y"
{ push_function_context ();
		  if (! start_function (current_declspecs, yyvsp[0].ttype,
					prefix_attributes, NULL_TREE))
		    {
		      pop_function_context ();
		      YYERROR1;
		    }
		  reinit_parse_for_function (); }
break;
case 227:
#line 1317 "c-parse.y"
{ store_parm_decls (); }
break;
case 228:
#line 1325 "c-parse.y"
{ finish_function (1);
		  pop_function_context (); }
break;
case 229:
#line 1331 "c-parse.y"
{ push_function_context ();
		  if (! start_function (current_declspecs, yyvsp[0].ttype,
					prefix_attributes, NULL_TREE))
		    {
		      pop_function_context ();
		      YYERROR1;
		    }
		  reinit_parse_for_function (); }
break;
case 230:
#line 1340 "c-parse.y"
{ store_parm_decls (); }
break;
case 231:
#line 1348 "c-parse.y"
{ finish_function (1);
		  pop_function_context (); }
break;
case 234:
#line 1364 "c-parse.y"
{ yyval.ttype = yyvsp[-1].ttype; }
break;
case 235:
#line 1366 "c-parse.y"
{ yyval.ttype = build_nt (CALL_EXPR, yyvsp[-2].ttype, yyvsp[0].ttype, NULL_TREE); }
break;
case 236:
#line 1371 "c-parse.y"
{ yyval.ttype = build_nt (ARRAY_REF, yyvsp[-3].ttype, yyvsp[-1].ttype); }
break;
case 237:
#line 1373 "c-parse.y"
{ yyval.ttype = build_nt (ARRAY_REF, yyvsp[-2].ttype, NULL_TREE); }
break;
case 238:
#line 1375 "c-parse.y"
{ yyval.ttype = make_pointer_declarator (yyvsp[-1].ttype, yyvsp[0].ttype); }
break;
case 239:
#line 1382 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype; }
break;
case 242:
#line 1395 "c-parse.y"
{ if (yyvsp[-1].ttype != ridpointers[(int)RID_STATIC])
	      error ("invalid storage class in array declarator");
	  }
break;
case 243:
#line 1399 "c-parse.y"
{ if (yyvsp[0].ttype != ridpointers[(int)RID_STATIC])
	      error ("invalid storage class in array declarator");
	  }
break;
case 245:
#line 1406 "c-parse.y"
{ }
break;
case 247:
#line 1417 "c-parse.y"
{ yyval.ttype = build_nt (CALL_EXPR, yyvsp[-2].ttype, yyvsp[0].ttype, NULL_TREE); }
break;
case 248:
#line 1422 "c-parse.y"
{ yyval.ttype = build_nt (ARRAY_REF, yyvsp[-4].ttype, NULL_TREE);
		  if (! flag_isoc99)
		    error ("`[*]' in parameter declaration only allowed in ISO C 9x");
		}
break;
case 249:
#line 1427 "c-parse.y"
{ yyval.ttype = build_nt (ARRAY_REF, yyvsp[-4].ttype, yyvsp[-1].ttype); }
break;
case 250:
#line 1429 "c-parse.y"
{ yyval.ttype = build_nt (ARRAY_REF, yyvsp[-3].ttype, NULL_TREE); }
break;
case 251:
#line 1431 "c-parse.y"
{ yyval.ttype = make_pointer_declarator (yyvsp[-1].ttype, yyvsp[0].ttype); }
break;
case 252:
#line 1438 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype; }
break;
case 254:
#line 1447 "c-parse.y"
{ yyval.ttype = build_nt (CALL_EXPR, yyvsp[-2].ttype, yyvsp[0].ttype, NULL_TREE); }
break;
case 255:
#line 1452 "c-parse.y"
{ yyval.ttype = yyvsp[-1].ttype; }
break;
case 256:
#line 1454 "c-parse.y"
{ yyval.ttype = make_pointer_declarator (yyvsp[-1].ttype, yyvsp[0].ttype); }
break;
case 257:
#line 1456 "c-parse.y"
{ yyval.ttype = build_nt (ARRAY_REF, yyvsp[-4].ttype, NULL_TREE);
		  if (! flag_isoc99)
		    error ("`[*]' in parameter declaration only allowed in ISO C 9x");
		}
break;
case 258:
#line 1461 "c-parse.y"
{ yyval.ttype = build_nt (ARRAY_REF, yyvsp[-4].ttype, yyvsp[-1].ttype); }
break;
case 259:
#line 1463 "c-parse.y"
{ yyval.ttype = build_nt (ARRAY_REF, yyvsp[-3].ttype, NULL_TREE); }
break;
case 260:
#line 1470 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype; }
break;
case 262:
#line 1476 "c-parse.y"
{ yyval.ttype = NULL_TREE; defining_type++; }
break;
case 263:
#line 1478 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype; defining_type++; }
break;
case 264:
#line 1483 "c-parse.y"
{ yyval.ttype = NULL_TREE; defining_type++; }
break;
case 265:
#line 1485 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype; defining_type++; }
break;
case 266:
#line 1490 "c-parse.y"
{ yyval.ttype = NULL_TREE; defining_type++; }
break;
case 267:
#line 1492 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype; defining_type++; }
break;
case 268:
#line 1497 "c-parse.y"
{ yyval.ttype = start_struct (RECORD_TYPE, yyvsp[-1].ttype);
		  /* Start scope of tag before parsing components.  */
		}
break;
case 269:
#line 1501 "c-parse.y"
{ yyval.ttype = finish_struct (yyvsp[-3].ttype, yyvsp[-2].ttype, chainon (yyvsp[-6].ttype, yyvsp[0].ttype));
		  defining_type--;
		}
break;
case 270:
#line 1505 "c-parse.y"
{ yyval.ttype = finish_struct (start_struct (RECORD_TYPE, NULL_TREE),
				      yyvsp[-2].ttype, chainon (yyvsp[-4].ttype, yyvsp[0].ttype));
		  defining_type--;
		}
break;
case 271:
#line 1510 "c-parse.y"
{ yyval.ttype = xref_tag (RECORD_TYPE, yyvsp[0].ttype); defining_type--; }
break;
case 272:
#line 1512 "c-parse.y"
{ yyval.ttype = start_struct (UNION_TYPE, yyvsp[-1].ttype); }
break;
case 273:
#line 1514 "c-parse.y"
{ yyval.ttype = finish_struct (yyvsp[-3].ttype, yyvsp[-2].ttype, chainon (yyvsp[-6].ttype, yyvsp[0].ttype));
		  defining_type--;
		}
break;
case 274:
#line 1518 "c-parse.y"
{ yyval.ttype = finish_struct (start_struct (UNION_TYPE, NULL_TREE),
				      yyvsp[-2].ttype, chainon (yyvsp[-4].ttype, yyvsp[0].ttype));
		  defining_type--;
		}
break;
case 275:
#line 1523 "c-parse.y"
{ yyval.ttype = xref_tag (UNION_TYPE, yyvsp[0].ttype); defining_type--; }
break;
case 276:
#line 1525 "c-parse.y"
{ yyvsp[0].itype = suspend_momentary ();
		  yyval.ttype = start_enum (yyvsp[-1].ttype); }
break;
case 277:
#line 1528 "c-parse.y"
{ yyval.ttype= finish_enum (yyvsp[-4].ttype, nreverse (yyvsp[-3].ttype), chainon (yyvsp[-7].ttype, yyvsp[0].ttype));
		  defining_type--;
		  resume_momentary (yyvsp[-5].itype); }
break;
case 278:
#line 1532 "c-parse.y"
{ yyvsp[0].itype = suspend_momentary ();
		  yyval.ttype = start_enum (NULL_TREE); }
break;
case 279:
#line 1535 "c-parse.y"
{ yyval.ttype= finish_enum (yyvsp[-4].ttype, nreverse (yyvsp[-3].ttype), chainon (yyvsp[-6].ttype, yyvsp[0].ttype));
		  defining_type--;
		  resume_momentary (yyvsp[-5].itype); }
break;
case 280:
#line 1539 "c-parse.y"
{ yyval.ttype = xref_tag (ENUMERAL_TYPE, yyvsp[0].ttype); defining_type--; }
break;
case 284:
#line 1550 "c-parse.y"
{ if (pedantic && ! flag_isoc99)
		    pedwarn ("comma at end of enumerator list"); }
break;
case 285:
#line 1556 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype; }
break;
case 286:
#line 1558 "c-parse.y"
{ yyval.ttype = chainon (yyvsp[-1].ttype, yyvsp[0].ttype);
		  pedwarn ("no semicolon at end of struct or union"); }
break;
case 287:
#line 1563 "c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 288:
#line 1565 "c-parse.y"
{ yyval.ttype = chainon (yyvsp[-2].ttype, yyvsp[-1].ttype); }
break;
case 289:
#line 1567 "c-parse.y"
{ if (pedantic)
		    pedwarn ("extra semicolon in struct or union specified"); }
break;
case 290:
#line 1582 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype;
		  current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-1].itype); }
break;
case 291:
#line 1588 "c-parse.y"
{ if (pedantic)
		    pedwarn ("ANSI C forbids member declarations with no members");
		  shadow_tag(yyvsp[0].ttype);
		  yyval.ttype = NULL_TREE; }
break;
case 292:
#line 1593 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype;
		  current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-1].itype); }
break;
case 293:
#line 1599 "c-parse.y"
{ if (pedantic)
		    pedwarn ("ANSI C forbids member declarations with no members");
		  shadow_tag(yyvsp[0].ttype);
		  yyval.ttype = NULL_TREE; }
break;
case 294:
#line 1604 "c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 295:
#line 1606 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype;
		  pedantic = yyvsp[-1].itype; }
break;
case 297:
#line 1613 "c-parse.y"
{ yyval.ttype = chainon (yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 298:
#line 1618 "c-parse.y"
{ yyval.ttype = grokfield (yyvsp[-3].filename, yyvsp[-2].lineno, yyvsp[-1].ttype, current_declspecs, NULL_TREE);
		  decl_attributes (yyval.ttype, yyvsp[0].ttype, prefix_attributes); }
break;
case 299:
#line 1622 "c-parse.y"
{ yyval.ttype = grokfield (yyvsp[-5].filename, yyvsp[-4].lineno, yyvsp[-3].ttype, current_declspecs, yyvsp[-1].ttype);
		  decl_attributes (yyval.ttype, yyvsp[0].ttype, prefix_attributes); }
break;
case 300:
#line 1625 "c-parse.y"
{ yyval.ttype = grokfield (yyvsp[-4].filename, yyvsp[-3].lineno, NULL_TREE, current_declspecs, yyvsp[-1].ttype);
		  decl_attributes (yyval.ttype, yyvsp[0].ttype, prefix_attributes); }
break;
case 302:
#line 1637 "c-parse.y"
{ if (yyvsp[-2].ttype == error_mark_node)
		    yyval.ttype = yyvsp[-2].ttype;
		  else
		    yyval.ttype = chainon (yyvsp[0].ttype, yyvsp[-2].ttype); }
break;
case 303:
#line 1642 "c-parse.y"
{ yyval.ttype = error_mark_node; }
break;
case 304:
#line 1648 "c-parse.y"
{ yyval.ttype = build_enumerator (yyvsp[-1].ttype, NULL_TREE); }
break;
case 305:
#line 1650 "c-parse.y"
{ yyval.ttype = build_enumerator (yyvsp[-3].ttype, yyvsp[0].ttype); }
break;
case 306:
#line 1655 "c-parse.y"
{ yyval.ttype = build_tree_list (yyvsp[-1].ttype, yyvsp[0].ttype); }
break;
case 307:
#line 1657 "c-parse.y"
{ yyval.ttype = build_tree_list (yyvsp[-1].ttype, yyvsp[0].ttype); }
break;
case 308:
#line 1662 "c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 311:
#line 1669 "c-parse.y"
{ yyval.ttype = chainon (yyvsp[0].ttype, yyvsp[-1].ttype); }
break;
case 312:
#line 1674 "c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 313:
#line 1676 "c-parse.y"
{ yyval.ttype = chainon (yyvsp[0].ttype, yyvsp[-1].ttype); }
break;
case 314:
#line 1681 "c-parse.y"
{ yyval.ttype = yyvsp[-1].ttype; }
break;
case 315:
#line 1684 "c-parse.y"
{ yyval.ttype = make_pointer_declarator (yyvsp[-1].ttype, yyvsp[0].ttype); }
break;
case 316:
#line 1686 "c-parse.y"
{ yyval.ttype = make_pointer_declarator (yyvsp[0].ttype, NULL_TREE); }
break;
case 317:
#line 1688 "c-parse.y"
{ yyval.ttype = build_nt (CALL_EXPR, yyvsp[-2].ttype, yyvsp[0].ttype, NULL_TREE); }
break;
case 318:
#line 1690 "c-parse.y"
{ yyval.ttype = build_nt (ARRAY_REF, yyvsp[-4].ttype, yyvsp[-1].ttype); }
break;
case 319:
#line 1692 "c-parse.y"
{ yyval.ttype = build_nt (ARRAY_REF, yyvsp[-3].ttype, NULL_TREE); }
break;
case 320:
#line 1694 "c-parse.y"
{ yyval.ttype = build_nt (CALL_EXPR, NULL_TREE, yyvsp[0].ttype, NULL_TREE); }
break;
case 321:
#line 1696 "c-parse.y"
{ yyval.ttype = build_nt (ARRAY_REF, NULL_TREE, yyvsp[-1].ttype); }
break;
case 322:
#line 1698 "c-parse.y"
{ yyval.ttype = build_nt (ARRAY_REF, NULL_TREE, NULL_TREE); }
break;
case 323:
#line 1702 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype; }
break;
case 324:
#line 1711 "c-parse.y"
{
		  if (pedantic && yyvsp[0].ends_in_label)
		    pedwarn ("ANSI C forbids label at end of compound statement");
		}
break;
case 326:
#line 1720 "c-parse.y"
{ yyval.ends_in_label = yyvsp[0].ends_in_label; }
break;
case 327:
#line 1722 "c-parse.y"
{ yyval.ends_in_label = 0; }
break;
case 329:
#line 1735 "c-parse.y"
{ emit_line_note (input_filename, lineno);
		  pushlevel (0);
		  clear_last_expr ();
		  push_momentary ();
		  UPC_statement_pragma_ok = 0;
		  expand_start_bindings (0);
		}
break;
case 331:
#line 1749 "c-parse.y"
{ if (pedantic)
		    pedwarn ("ANSI C forbids label declarations"); }
break;
case 334:
#line 1760 "c-parse.y"
{ tree link;
		  for (link = yyvsp[-1].ttype; link; link = TREE_CHAIN (link))
		    {
		      tree label = shadow_label (TREE_VALUE (link));
		      C_DECLARED_LABEL_FLAG (label) = 1;
		      declare_nonlocal_label (label);
		    }
		}
break;
case 335:
#line 1774 "c-parse.y"
{}
break;
case 337:
#line 1778 "c-parse.y"
{ 
	  push_consistency_nesting_level (1);
	  UPC_statement_pragma_ok = 1;
	  compstmt_count++; }
break;
case 338:
#line 1784 "c-parse.y"
{ yyval.ttype = convert (void_type_node, integer_zero_node);
		pop_consistency_nesting_level (1);	}
break;
case 339:
#line 1788 "c-parse.y"
{ emit_line_note (input_filename, lineno);
		  expand_end_bindings (getdecls (), kept_level_p (), 0);
		  yyval.ttype = poplevel (kept_level_p (), 0, 0);
		  if (yychar == CONSTANT || yychar == STRING)
		    pop_momentary_nofree ();
		  else
		    pop_momentary ();
		  pop_consistency_nesting_level (1); }
break;
case 340:
#line 1797 "c-parse.y"
{ emit_line_note (input_filename, lineno);
		  expand_end_bindings (getdecls (), kept_level_p (), 0);
		  yyval.ttype = poplevel (kept_level_p (), 0, 0);
		  if (yychar == CONSTANT || yychar == STRING)
		    pop_momentary_nofree ();
		  else
		    pop_momentary (); 
		  pop_consistency_nesting_level (1);	}
break;
case 343:
#line 1818 "c-parse.y"
{ emit_line_note (yyvsp[-5].filename, yyvsp[-4].lineno);
		  c_expand_start_cond (truthvalue_conversion (yyvsp[-1].ttype), 0, 
				       compstmt_count);
		  yyval.itype = stmt_count;
		  if_stmt_file = yyvsp[-5].filename;
		  if_stmt_line = yyvsp[-4].lineno;
		  position_after_white_space (); }
break;
case 344:
#line 1832 "c-parse.y"
{ stmt_count++;
		  compstmt_count++;
		  emit_line_note (yyvsp[-2].filename, yyvsp[-1].lineno);
		  /* See comment in `while' alternative, above.  */
		  emit_nop ();
		  expand_start_loop_continue_elsewhere (1);
		  position_after_white_space (); }
break;
case 345:
#line 1840 "c-parse.y"
{ expand_loop_continue_here (); }
break;
case 346:
#line 1844 "c-parse.y"
{ yyval.filename = input_filename; }
break;
case 347:
#line 1848 "c-parse.y"
{ yyval.lineno = lineno; }
break;
case 348:
#line 1853 "c-parse.y"
{ }
break;
case 349:
#line 1858 "c-parse.y"
{ }
break;
case 350:
#line 1863 "c-parse.y"
{ yyval.ends_in_label = yyvsp[0].ends_in_label; }
break;
case 351:
#line 1868 "c-parse.y"
{ yyval.ends_in_label = 0; }
break;
case 352:
#line 1870 "c-parse.y"
{ yyval.ends_in_label = 1; }
break;
case 353:
#line 1872 "c-parse.y"
{ yyval.ends_in_label = 0; }
break;
case 354:
#line 1879 "c-parse.y"
{ stmt_count++; }
break;
case 356:
#line 1882 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-3].filename, yyvsp[-2].lineno);
/* It appears that this should not be done--that a non-lvalue array
   shouldn't get an error if the value isn't used.
   Section 3.2.2.1 says that an array lvalue gets converted to a pointer
   if it appears as a top-level expression,
   but says nothing about non-lvalue arrays.  */
#if 0
		  /* Call default_conversion to get an error
		     on referring to a register array if pedantic.  */
		  if (TREE_CODE (TREE_TYPE (yyvsp[-1].ttype)) == ARRAY_TYPE
		      || TREE_CODE (TREE_TYPE (yyvsp[-1].ttype)) == FUNCTION_TYPE)
		    yyvsp[-1].ttype = default_conversion (yyvsp[-1].ttype);
#endif
		  iterator_expand (yyvsp[-1].ttype);
		  clear_momentary (); }
break;
case 357:
#line 1899 "c-parse.y"
{ c_expand_start_else ();
		  yyvsp[-1].itype = stmt_count;
		  position_after_white_space (); }
break;
case 358:
#line 1903 "c-parse.y"
{ c_expand_end_cond ();
		  if (extra_warnings && stmt_count == yyvsp[-3].itype)
		    warning ("empty body in an else-statement"); }
break;
case 359:
#line 1907 "c-parse.y"
{ c_expand_end_cond ();
		  /* This warning is here instead of in simple_if, because we
		     do not want a warning if an empty if is followed by an
		     else statement.  Increment stmt_count so we don't
		     give a second error if this is a nested `if'.  */
		  if (extra_warnings && stmt_count++ == yyvsp[0].itype)
		    warning_with_file_and_line (if_stmt_file, if_stmt_line,
						"empty body in an if-statement"); }
break;
case 360:
#line 1919 "c-parse.y"
{ c_expand_end_cond (); }
break;
case 361:
#line 1921 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-2].filename, yyvsp[-1].lineno);
		  /* The emit_nop used to come before emit_line_note,
		     but that made the nop seem like part of the preceding line.
		     And that was confusing when the preceding line was
		     inside of an if statement and was not really executed.
		     I think it ought to work to put the nop after the line number.
		     We will see.  --rms, July 15, 1991.  */
		  emit_nop (); }
break;
case 362:
#line 1931 "c-parse.y"
{ /* Don't start the loop till we have succeeded
		     in parsing the end test.  This is to make sure
		     that we end every loop we start.  */
		  expand_start_loop (1);
		  emit_line_note (input_filename, lineno);
		  expand_exit_loop_if_false (NULL_PTR,
					     truthvalue_conversion (yyvsp[-1].ttype));
		  position_after_white_space (); }
break;
case 363:
#line 1940 "c-parse.y"
{ expand_end_loop (); }
break;
case 364:
#line 1943 "c-parse.y"
{ emit_line_note (input_filename, lineno);
		  expand_exit_loop_if_false (NULL_PTR,
					     truthvalue_conversion (yyvsp[-2].ttype));
		  expand_end_loop ();
		  clear_momentary (); }
break;
case 365:
#line 1950 "c-parse.y"
{ expand_end_loop ();
		  clear_momentary (); }
break;
case 366:
#line 1952 "c-parse.y"
{ stmt_count++;
		  WFE_Pop_Pragma(); /* see comments in wfe_dst.cxx*/
		  emit_line_note (yyvsp[-4].filename, yyvsp[-3].lineno);
		  /* See comment in `while' alternative, above.  */
		  emit_nop ();
		  if (yyvsp[0].ttype && yyvsp[0].ttype != c99_for_node)
		    c_expand_expr_stmt (yyvsp[0].ttype);
		  WFE_Push_Pragma();

		  /* Next step is to call expand_start_loop_continue_elsewhere,
		     but wait till after we parse the entire for (...).
		     Otherwise, invalid input might cause us to call that
		     fn without calling expand_end_loop.  */
		}
break;
case 367:
#line 1968 "c-parse.y"
{
		  yyvsp[0].lineno = lineno;
		  yyval.filename = input_filename; 
		}
break;
case 368:
#line 1973 "c-parse.y"
{ 
		  /* Start the loop.  Doing this after parsing
		     all the expressions ensures we will end the loop.  */
		  expand_start_loop_continue_elsewhere (1);
		  /* Emit the end-test, with a line number.  */
		  /* emit_line_note ($<filename>8, $<lineno>7); */
		  emit_line_note (yyvsp[-2].filename, yyvsp[-3].lineno);
		  if (yyvsp[-4].ttype) 
		    expand_exit_loop_if_false (NULL_PTR,
					       truthvalue_conversion (yyvsp[-4].ttype)); 
					       
		  /* Don't let the tree nodes for $9 be discarded by
		     clear_momentary during the parsing of the next stmt.  */
		  push_momentary ();
		  yyvsp[-3].lineno = lineno;
		  yyvsp[-2].filename = input_filename;
		  position_after_white_space (); }
break;
case 369:
#line 1991 "c-parse.y"
{ /* Emit the increment expression, with a line number.  */
		  emit_line_note (yyvsp[-4].filename, yyvsp[-5].lineno);
		  expand_loop_continue_here ();
		   if (yyvsp[-3].ttype) 
 		    c_expand_expr_stmt (yyvsp[-3].ttype); 
		 
		  if (yychar == CONSTANT || yychar == STRING)
		    pop_momentary_nofree ();
		  else
		    pop_momentary ();
		  if (yyvsp[-8].ttype == c99_for_node)
		    poplevel(1,0,0);
		  expand_end_loop ();
		  if (yyvsp[-8].ttype == c99_for_node)
		    WFE_Finish_Inner_Scope();
		}
break;
case 370:
#line 2009 "c-parse.y"
{ stmt_count++;
		  WFE_Pop_Pragma();
		  emit_line_note (yyvsp[-4].filename, yyvsp[-3].lineno);
		  /* See comment in `while' alternative, above.  */
		  emit_nop ();
		  if (yyvsp[0].ttype && yyvsp[0].ttype != c99_for_node)
		    c_expand_expr_stmt (yyvsp[0].ttype);
		  WFE_Push_Pragma();
		  /* Next step is to call expand_start_loop_continue_elsewhere,
		     but wait till after we parse the entire for (...).
		     Otherwise, invalid input might cause us to call that
		     fn without calling expand_end_loop.  */
		}
break;
case 371:
#line 2024 "c-parse.y"
{ yyvsp[0].lineno = lineno;
		  yyval.filename = input_filename; }
break;
case 372:
#line 2027 "c-parse.y"
{ 
		/* Can't emit now; wait till after expand_start_loop...  */
		  /* $<lineno>10 = lineno; */
		  yyvsp[0].lineno = lineno;
		  yyval.filename = input_filename; }
break;
case 373:
#line 2033 "c-parse.y"
{
		  /* The xexpr of $11 is the affinity expression that
		     determines which thread executes a given iteration
		     of the FORALL loop.  It can evaluate either to a
		     shared address with a thread component or to an
		     integer in the range 0-(THREADS-1), inclusive.  The
		     thread component or the integer will specify the
		     executing thread. */
		  /* In the current implementation the FORALL loop body
		     will be wrapped inside a runtime conditional.  In
		     an unoptimized version, each thread will execute every
		     loop iteration of the loop, deciding on each iteration
		     whether to execute the body or to do the equivalent
		     of "continue" if the affinity is wrong. */
		  /* Start the loop.  Doing this after parsing
		     all the expressions ensures we will end the loop.  */
		  expand_start_loop_continue_elsewhere (1);
		  
		    /* Emit the affinity-test, with a line number.  */
		  emit_line_note (yyvsp[-2].filename, yyvsp[-3].lineno);
		  if (yyvsp[-1].ttype)
		    expand_affinity_test (yyvsp[-1].ttype);

		  /* Emit the end-test, with a line number.  */
		  emit_line_note (yyvsp[-2].filename, yyvsp[-3].lineno);
		  if (yyvsp[-7].ttype)
		    expand_exit_loop_if_false (NULL_PTR,
					       truthvalue_conversion (yyvsp[-7].ttype));
		
		  /* Don't let the tree nodes for $9 be discarded by
		     clear_momentary during the parsing of the next stmt.  */
		  push_momentary ();
		  yyvsp[-3].lineno = lineno;
		  yyvsp[-2].filename = input_filename;
		  position_after_white_space (); }
break;
case 374:
#line 2069 "c-parse.y"
{ /* Emit the increment expression, with a line number.  */
		  emit_line_note (yyvsp[-4].filename, yyvsp[-5].lineno);
		  expand_loop_continue_here ();
		  if (yyvsp[-6].ttype)
		    c_expand_expr_stmt (yyvsp[-6].ttype);
		  if (yychar == CONSTANT || yychar == STRING)
		    pop_momentary_nofree ();
		  else
		    pop_momentary ();
		  if (yyvsp[-11].ttype == c99_for_node)
		    poplevel(1,0,0);
		  expand_end_loop ();
		  if (yyvsp[-11].ttype == c99_for_node)
		    WFE_Finish_Inner_Scope();
		}
break;
case 375:
#line 2085 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-5].filename, yyvsp[-4].lineno);
		  c_expand_start_case (yyvsp[-1].ttype);
		  /* Don't let the tree nodes for $3 be discarded by
		     clear_momentary during the parsing of the next stmt.  */
		  push_momentary ();
		  position_after_white_space (); }
break;
case 376:
#line 2093 "c-parse.y"
{ expand_end_case (yyvsp[-3].ttype);
		  if (yychar == CONSTANT || yychar == STRING)
		    pop_momentary_nofree ();
		  else
		    pop_momentary (); }
break;
case 377:
#line 2099 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-3].filename, yyvsp[-2].lineno);
		  if ( ! expand_exit_something ())
		    error ("break statement not within loop or switch"); }
break;
case 378:
#line 2104 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-3].filename, yyvsp[-2].lineno);
		  if (! expand_continue_loop (NULL_PTR))
		    error ("continue statement not within a loop"); }
break;
case 379:
#line 2109 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-3].filename, yyvsp[-2].lineno);
		  c_expand_return (NULL_TREE); }
break;
case 380:
#line 2113 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-4].filename, yyvsp[-3].lineno);
		  c_expand_return (yyvsp[-1].ttype); }
break;
case 381:
#line 2117 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-3].filename, yyvsp[-2].lineno);
		  upc_expand_sync (1, NULL_TREE); }
break;
case 382:
#line 2121 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-3].filename, yyvsp[-2].lineno);
		  upc_expand_sync (4, NULL_TREE); }
break;
case 383:
#line 2125 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-4].filename, yyvsp[-3].lineno);
		  upc_expand_sync (1, yyvsp[-1].ttype); }
break;
case 384:
#line 2129 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-3].filename, yyvsp[-2].lineno);
		  upc_expand_sync (2, NULL_TREE); }
break;
case 385:
#line 2133 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-4].filename, yyvsp[-3].lineno);
		  upc_expand_sync (2, yyvsp[-1].ttype); }
break;
case 386:
#line 2137 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-3].filename, yyvsp[-2].lineno);
		  upc_expand_sync (3, NULL_TREE); }
break;
case 387:
#line 2141 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-4].filename, yyvsp[-3].lineno);
		  upc_expand_sync (3, yyvsp[-1].ttype); }
break;
case 388:
#line 2145 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-7].filename, yyvsp[-6].lineno);
		  STRIP_NOPS (yyvsp[-2].ttype);
		  if ((TREE_CODE (yyvsp[-2].ttype) == ADDR_EXPR
		       && TREE_CODE (TREE_OPERAND (yyvsp[-2].ttype, 0)) == STRING_CST)
		      || TREE_CODE (yyvsp[-2].ttype) == STRING_CST)
		    expand_asm (yyvsp[-2].ttype);
		  else
		    error ("argument of `asm' is not a constant string"); }
break;
case 389:
#line 2156 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-9].filename, yyvsp[-8].lineno);
		  c_expand_asm_operands (yyvsp[-4].ttype, yyvsp[-2].ttype, NULL_TREE, NULL_TREE,
					 yyvsp[-6].ttype == ridpointers[(int)RID_VOLATILE],
					 input_filename, lineno); }
break;
case 390:
#line 2163 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-11].filename, yyvsp[-10].lineno);
		  c_expand_asm_operands (yyvsp[-6].ttype, yyvsp[-4].ttype, yyvsp[-2].ttype, NULL_TREE,
					 yyvsp[-8].ttype == ridpointers[(int)RID_VOLATILE],
					 input_filename, lineno); }
break;
case 391:
#line 2171 "c-parse.y"
{ stmt_count++;
		  emit_line_note (yyvsp[-13].filename, yyvsp[-12].lineno);
		  c_expand_asm_operands (yyvsp[-8].ttype, yyvsp[-6].ttype, yyvsp[-4].ttype, yyvsp[-2].ttype,
					 yyvsp[-10].ttype == ridpointers[(int)RID_VOLATILE],
					 input_filename, lineno); }
break;
case 392:
#line 2177 "c-parse.y"
{ tree decl;
		  stmt_count++;
		  emit_line_note (yyvsp[-4].filename, yyvsp[-3].lineno);
		  decl = lookup_label (yyvsp[-1].ttype);
		  if (decl != 0)
		    {
		      TREE_USED (decl) = 1;
		      expand_goto (decl);
		    }
		}
break;
case 393:
#line 2188 "c-parse.y"
{ if (pedantic)
		    pedwarn ("ANSI C forbids `goto *expr;'");
		  stmt_count++;
		  emit_line_note (yyvsp[-5].filename, yyvsp[-4].lineno);
		  expand_computed_goto (convert (ptr_type_node, yyvsp[-1].ttype)); }
break;
case 395:
#line 2197 "c-parse.y"
{
	  pushlevel (0);  /* Add a new level for the declarations in a for loop header */
	  WFE_Start_Inner_Scope();
	}
break;
case 396:
#line 2205 "c-parse.y"
{ yyval.ttype = yyvsp[-1].ttype;}
break;
case 397:
#line 2207 "c-parse.y"
{ 
	      check_for_loop_decls(); 
	      yyval.ttype = c99_for_node;
	    }
break;
case 399:
#line 2216 "c-parse.y"
{yyval.ttype = NULL_TREE;}
break;
case 401:
#line 2226 "c-parse.y"
{
	    /* The value returned by this action is  */
	    /*      1 if everything is OK */ 
	    /*      0 in case of error or already bound iterator */

	    yyval.itype = 0;
	    if (TREE_CODE (yyvsp[-1].ttype) != VAR_DECL)
	      error ("invalid `for (ITERATOR)' syntax");
	    else if (! ITERATOR_P (yyvsp[-1].ttype))
	      error ("`%s' is not an iterator",
		     IDENTIFIER_POINTER (DECL_NAME (yyvsp[-1].ttype)));
	    else if (ITERATOR_BOUND_P (yyvsp[-1].ttype))
	      error ("`for (%s)' inside expansion of same iterator",
		     IDENTIFIER_POINTER (DECL_NAME (yyvsp[-1].ttype)));
	    else
	      {
		yyval.itype = 1;
		iterator_for_loop_start (yyvsp[-1].ttype);
	      }
	  }
break;
case 402:
#line 2247 "c-parse.y"
{
	    if (yyvsp[-1].itype)
	      iterator_for_loop_end (yyvsp[-3].ttype);
	  }
break;
case 403:
#line 2282 "c-parse.y"
{ register tree value = check_case_value (yyvsp[-1].ttype);
		  register tree label
		    = build_decl (LABEL_DECL, NULL_TREE, NULL_TREE);

		  stmt_count++;

		  if (value != error_mark_node)
		    {
		      tree duplicate;
		      int success;

		      if (pedantic && ! INTEGRAL_TYPE_P (TREE_TYPE (value)))
			pedwarn ("label must have integral type in ANSI C");

		      success = pushcase (value, convert_and_check,
					  label, &duplicate);

		      if (success == 1)
			error ("case label not within a switch statement");
		      else if (success == 2)
			{
			  error ("duplicate case value");
			  error_with_decl (duplicate, "this is the first entry for that value");
			}
		      else if (success == 3)
			warning ("case value out of range");
		      else if (success == 5)
			error ("case label within scope of cleanup or variable array");
		    }
		  position_after_white_space (); }
break;
case 404:
#line 2313 "c-parse.y"
{ register tree value1 = check_case_value (yyvsp[-3].ttype);
		  register tree value2 = check_case_value (yyvsp[-1].ttype);
		  register tree label
		    = build_decl (LABEL_DECL, NULL_TREE, NULL_TREE);

		  if (pedantic)
		    pedwarn ("ANSI C forbids case ranges");
		  stmt_count++;

		  if (value1 != error_mark_node && value2 != error_mark_node)
		    {
		      tree duplicate;
		      int success = pushcase_range (value1, value2,
						    convert_and_check, label,
						    &duplicate);
		      if (success == 1)
			error ("case label not within a switch statement");
		      else if (success == 2)
			{
			  error ("duplicate case value");
			  error_with_decl (duplicate, "this is the first entry for that value");
			}
		      else if (success == 3)
			warning ("case value out of range");
		      else if (success == 4)
			warning ("empty case range");
		      else if (success == 5)
			error ("case label within scope of cleanup or variable array");
		    }
		  position_after_white_space (); }
break;
case 405:
#line 2344 "c-parse.y"
{
		  tree duplicate;
		  register tree label
		    = build_decl (LABEL_DECL, NULL_TREE, NULL_TREE);
		  int success = pushcase (NULL_TREE, 0, label, &duplicate);
		  stmt_count++;
		  if (success == 1)
		    error ("default label not within a switch statement");
		  else if (success == 2)
		    {
		      error ("multiple default labels in one switch");
		      error_with_decl (duplicate, "this is the first default label");
		    }
		  position_after_white_space (); }
break;
case 406:
#line 2359 "c-parse.y"
{ tree label = define_label (input_filename, lineno, yyvsp[-2].ttype);
		  stmt_count++;
		  emit_nop ();
		  if (label)
		    {
		      expand_label (label);
		      decl_attributes (label, yyvsp[0].ttype, NULL_TREE);
		    }
		  position_after_white_space (); }
break;
case 407:
#line 2374 "c-parse.y"
{ emit_line_note (input_filename, lineno);
		  yyval.ttype = NULL_TREE; }
break;
case 408:
#line 2377 "c-parse.y"
{ emit_line_note (input_filename, lineno); }
break;
case 409:
#line 2382 "c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 411:
#line 2386 "c-parse.y"
{ yyval.ttype = star_layout_node; }
break;
case 412:
#line 2392 "c-parse.y"
{ yyval.ttype = NULL_TREE; }
break;
case 415:
#line 2399 "c-parse.y"
{ yyval.ttype = chainon (yyvsp[-2].ttype, yyvsp[0].ttype); }
break;
case 416:
#line 2404 "c-parse.y"
{ yyval.ttype = build_tree_list (yyvsp[-3].ttype, yyvsp[-1].ttype); }
break;
case 417:
#line 2409 "c-parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, combine_strings (yyvsp[0].ttype), NULL_TREE); }
break;
case 418:
#line 2411 "c-parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, combine_strings (yyvsp[0].ttype), yyvsp[-2].ttype); }
break;
case 419:
#line 2417 "c-parse.y"
{ pushlevel (0);
		  clear_parm_order ();
		  declare_parm_level (0); }
break;
case 420:
#line 2421 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype;
		  parmlist_tags_warning ();
		  poplevel (0, 0, 0); }
break;
case 422:
#line 2429 "c-parse.y"
{ tree parm;
		  if (pedantic)
		    pedwarn ("ANSI C forbids forward parameter declarations");
		  /* Mark the forward decls as such.  */
		  for (parm = getdecls (); parm; parm = TREE_CHAIN (parm))
		    TREE_ASM_WRITTEN (parm) = 1;
		  clear_parm_order (); }
break;
case 423:
#line 2437 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype; }
break;
case 424:
#line 2439 "c-parse.y"
{ yyval.ttype = tree_cons (NULL_TREE, NULL_TREE, NULL_TREE); }
break;
case 425:
#line 2445 "c-parse.y"
{ yyval.ttype = get_parm_info (0); }
break;
case 426:
#line 2447 "c-parse.y"
{ yyval.ttype = get_parm_info (0);
		  /* Gcc used to allow this as an extension.  However, it does
		     not work for all targets, and thus has been disabled.
		     Also, since func (...) and func () are indistinguishable,
		     it caused problems with the code in expand_builtin which
		     tries to verify that BUILT_IN_NEXT_ARG is being used
		     correctly.  */
		  error ("ANSI C requires a named argument before `...'");
		}
break;
case 427:
#line 2457 "c-parse.y"
{ yyval.ttype = get_parm_info (1); }
break;
case 428:
#line 2459 "c-parse.y"
{ yyval.ttype = get_parm_info (0); }
break;
case 429:
#line 2464 "c-parse.y"
{ push_parm_decl (yyvsp[0].ttype); }
break;
case 430:
#line 2466 "c-parse.y"
{ push_parm_decl (yyvsp[0].ttype); }
break;
case 431:
#line 2473 "c-parse.y"
{ yyval.ttype = build_tree_list (build_tree_list (current_declspecs,
							 yyvsp[-1].ttype),
					build_tree_list (prefix_attributes,
							 yyvsp[0].ttype));
		  current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype); }
break;
case 432:
#line 2482 "c-parse.y"
{ yyval.ttype = build_tree_list (build_tree_list (current_declspecs,
							 yyvsp[-1].ttype),
					build_tree_list (prefix_attributes,
							 yyvsp[0].ttype)); 
		  current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype); }
break;
case 433:
#line 2491 "c-parse.y"
{ yyval.ttype = build_tree_list (build_tree_list (current_declspecs,
							 yyvsp[-1].ttype),
					build_tree_list (prefix_attributes,
							 yyvsp[0].ttype));
		  current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype); }
break;
case 434:
#line 2500 "c-parse.y"
{ yyval.ttype = build_tree_list (build_tree_list (current_declspecs,
							 yyvsp[-1].ttype),
					build_tree_list (prefix_attributes,
							 yyvsp[0].ttype));
		  current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype);  }
break;
case 435:
#line 2510 "c-parse.y"
{ yyval.ttype = build_tree_list (build_tree_list (current_declspecs,
							 yyvsp[-1].ttype),
					build_tree_list (prefix_attributes,
							 yyvsp[0].ttype));
		  current_declspecs = TREE_VALUE (declspec_stack);
		  prefix_attributes = TREE_PURPOSE (declspec_stack);
		  declspec_stack = TREE_CHAIN (declspec_stack);
		  resume_momentary (yyvsp[-2].itype);  }
break;
case 436:
#line 2524 "c-parse.y"
{ pushlevel (0);
		  clear_parm_order ();
		  declare_parm_level (1); }
break;
case 437:
#line 2528 "c-parse.y"
{ yyval.ttype = yyvsp[0].ttype;
		  parmlist_tags_warning ();
		  poplevel (0, 0, 0); }
break;
case 439:
#line 2536 "c-parse.y"
{ tree t;
		  for (t = yyvsp[-1].ttype; t; t = TREE_CHAIN (t))
		    if (TREE_VALUE (t) == NULL_TREE)
		      error ("`...' in old-style identifier list");
		  yyval.ttype = tree_cons (NULL_TREE, NULL_TREE, yyvsp[-1].ttype); }
break;
case 440:
#line 2546 "c-parse.y"
{ yyval.ttype = build_tree_list (NULL_TREE, yyvsp[0].ttype); }
break;
case 441:
#line 2548 "c-parse.y"
{ yyval.ttype = chainon (yyvsp[-2].ttype, build_tree_list (NULL_TREE, yyvsp[0].ttype)); }
break;
case 442:
#line 2554 "c-parse.y"
{ yyval.ttype = build_tree_list (NULL_TREE, yyvsp[0].ttype); }
break;
case 443:
#line 2556 "c-parse.y"
{ yyval.ttype = chainon (yyvsp[-2].ttype, build_tree_list (NULL_TREE, yyvsp[0].ttype)); }
break;
case 444:
#line 2561 "c-parse.y"
{ yyval.itype = pedantic;
		  pedantic = 0; }
break;
#line 4672 "c-parse.c"
    }
    yyssp -= yym;
    yystate = *yyssp;
    yyvsp -= yym;
    yym = yylhs[yyn];
    if (yystate == 0 && yym == 0)
    {
#if YYDEBUG
        if (yydebug)
            printf("%sdebug: after reduction, shifting from state 0 to\
 state %d\n", YYPREFIX, YYFINAL);
#endif
        yystate = YYFINAL;
        *++yyssp = YYFINAL;
        *++yyvsp = yyval;
        if (yychar < 0)
        {
            if ((yychar = yylex()) < 0) yychar = 0;
#if YYDEBUG
            if (yydebug)
            {
                yys = 0;
                if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
                if (!yys) yys = "illegal-symbol";
                printf("%sdebug: state %d, reading %d (%s)\n",
                        YYPREFIX, YYFINAL, yychar, yys);
            }
#endif
        }
        if (yychar == 0) goto yyaccept;
        goto yyloop;
    }
    if ((yyn = yygindex[yym]) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn];
    else
        yystate = yydgoto[yym];
#if YYDEBUG
    if (yydebug)
        printf("%sdebug: after reduction, shifting from state %d \
to state %d\n", YYPREFIX, *yyssp, yystate);
#endif
    if (yyssp >= yysslim && yygrowstack())
    {
        goto yyoverflow;
    }
    *++yyssp = yystate;
    *++yyvsp = yyval;
    goto yyloop;
yyoverflow:
    yyerror("yacc stack overflow");
yyabort:
    return (1);
yyaccept:
    return (0);
}
